/**************************************************************************\
*                                                                          *
*                       AnteproyectoFL                                     *
*                                                                          *
\**************************************************************************/



import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.accessibility.*;


class AnteproyectoFL extends JFrame implements   ActionListener
{
    static int lang = SistemaFL.lang;


    //========     Bloque con todos los textos de este fichero  ===============


    static String text[][] =
    {
        { "AVANTPROJECTE", "ANTEPROYECTO", "PRELIMINARY SKETCH" },
        { "Objecte", "Objeto", "Object" },
        { "Lents i diafragmes", "Lentes y diafragmas", "Lenses and stops" },
        { "Veure objecte virtual", "Ver objeto virtual", "Show virtual object" },
        { "Veure imatge virtual", "Ver imagen virtual", "Show virtual image" },
        { "Elements cardinals", "Elementos cardinales", "Cardinal points" },
        { "Men principal", "Men principal", "Main menu" },
        { "Posici", "Posicin", "Position" },
        { "Potncia", "Potencia", "Power" },
        { "Semicamp", "Semicampo", "Half field" },
        { "Element", "Elemento", "Element" },
        { "Lent", "Lente", "Lens" },
        { "Diafragma", "Diafragma", "Stop" },
        { "Dimetre", "Dimetro", "Diameter" },
        { "Infinit", "Infinito", "Infinite" },
        { "Focal", "Focal", "Focal" }
    } ;


    //===========================================================================


    static AnteproyectoFL anteproyecto;

    static JPanel   panelBase, panelObj[] = new JPanel[2], panelCard = new JPanel();
    static JPanel   panelE[] = new JPanel[7];
    static Color    grisAzulado = new Color (102, 102, 153);


                        //  Canvas para los dibujos

    static  DibujoSistemaFL      canvasSistema;
    static  PuntosCardinalesFL   puntosCardinales;


                        //  Botones del men

    static JToggleButton   buttonVirtual;
    static JToggleButton   buttonObjVirtual;
    static JButton  buttonCard, buttonMP;
    static JButton  buttonObj[] = new JButton[2];
    static JButton  buttonE[] = new JButton[7];
    static String   nomBoton[] = new String[7];

                                        //  Leyendas para el objeto 

    static JLabel   labelObj[] = new JLabel[2];     //  "Objeto"
    static JLabel   labelZObj[] = new JLabel[2];    //  "Posicin"
    static JLabel   labelValZObj[] = new JLabel[2]; //  Valor de la posicim (texto)
    static JLabel   labelHObj[] = new JLabel[2];    //  "Semicampo"
    static JLabel   labelValHObj[] = new JLabel[2]; //  Valor del semicampo (texto)


                                        //  Botones "radio" para los objetos.

    static JRadioButton  buttonR[] = new JRadioButton[2];
    static JRadioButton  buttonV[] = new JRadioButton[2];
    static ButtonGroup   grupoO[] = new ButtonGroup[2];

                                        //  Correderas para el objeto 

    static JSlider  sliderValZObj[] = new JSlider[2];   //  Para la posicin
    static ChangeListener listenerValZObj[] = new ChangeListener[2];

    static JLabel   valPosObj[][] = new JLabel[2][5];
    static String   leyendaPosObj[] = { "-1600", "-800", "0", "800", "1600" };

    static JSlider  sliderValHObj[] = new JSlider[2];   //  Para el semicampo
    static ChangeListener listenerValHObj[] = new ChangeListener[2];

    static JLabel   valCampo[][] = new JLabel[2][5];
    static String   leyendaCampo[] = { "0", "5", "10", "15", "20" };

                                        //  Botones "radio" para lentes y diaf.

    static JRadioButton  buttonL[] = new JRadioButton[7];
    static JRadioButton  buttonD[] = new JRadioButton[7];
    static ButtonGroup   grupo[] = new ButtonGroup[7];
 
                                        //  Leyendas para lentes y diafragmas

    static JLabel   labelE[] = new JLabel[7];       //  "Elemento"
    static JLabel   labelZE[] = new JLabel[7];      //  "Posicin"
    static JLabel   labelHE[] = new JLabel[7];      //  "Potencia" o "Dimetro"
    static JLabel   labelFE[] = new JLabel[7];      //  "Focal"
    static JLabel   labelValZE[] = new JLabel[7];   //  Valores numricos de lo 
    static JLabel   labelValHE[] = new JLabel[7];   //  anterior (texto)
    static JLabel   labelValFE[] = new JLabel[7];

                                        //  Correderas para lentes y diafragmas

    static JSlider  sliderValZE[] = new JSlider[7];     //  Para la posicin
    static ChangeListener listenerValZE[] = new ChangeListener[7];

    static JSlider  sliderValHE[] = new JSlider[7];     //  Para la potencia o el 
    static ChangeListener listenerValHE[] = new ChangeListener[7];  //  dimetro

                                            //    Nmeros para las escalas

    static JLabel valPos[][] = new JLabel[7][5];
    static String leyendaPos[] = { "0", "400", "800", "1200", "1600" };

    static JLabel valPot[][] = new JLabel[7][5];
    static String leyendaPot[] = { "-20", "-10", "0", "10", "20" };

    static JLabel valDiam[][] = new JLabel[7][4];
    static String leyendaDiam[] = { "0", "20", "40", "60" };

                                        //  Variables auxiliares

    static String  texto1, texto2;
    static String  unidad[] = new String[7];
    static int     verImagenVirtual = - 1;
    static int     verObjetoVirtual = - 1;
    int     cuadro;

                //  Datos del sistema

    int     numLentes = 0;
    int     numSup = 0;

                //  Tabla de los elementos que existen

    static  int     elemento[] = new int[8];
    static  int     numElementos;
    static  int     numUltimoElemento;
    static  int     numUltimaLente;
    static  int     numPupilaE = 1;     //  N de la pupila de entrada entre los 6 
    static  int     numPupilaS = 1;     //  N de la pupila de salida     "    "
    static  int     numDiafragma = 1;   //  N del diafragma de abertura  "    "
    static  int     numRelDiafragma;    //  N del diafragma de abertura entre los
                                        //  elementos que existen

                //  Tabla de los tramos de rayos

    static  int     tramo[][] = new int[2][9];
    static  int     numTramos[] = new int[2];

                //  Tabla de los tramos de rayos para puntos cardinales

    static  int     tramoCard[] = new int[9];
    static  int     numTramosCard;

                //  Posicin de focos y puntos principales

    static  double  zF[] = new double[2];
    static  double  zH[] = new double[2];


                    //  Datos de las imgenes 

    static double zImag[][] = new double[2][8]; //  Posicin de la imagen intermedia          
    static double yImag[][] = new double[2][8]; //  Altura de la imagen intermedia     
                //  En el objeto, la imagen intermedia es el propio objeto


                    //  Datos de las pupilas

    static double zPE;                      //  Posicin de la pupila de entrada
    static double DPE;                      //  Dimetro de la pupila de entrada
    static double zPS;                      //  Posicin de la pupila de entrada
    static double DPS;                      //  Dimetro de la pupila de salida


                //  Datos de los rayos
    static int    pasa[][][]  = new int[2][8][22];      //  1 si pasa el rayo, 0 si no.
    static double apRayo[][][] = new double[2][8][22];  //  Coeficientes de la recta del
    static double bpRayo[][][] = new double[2][8][22];  //  rayo.  ( y = az + b )
                        //  Los subndices corresponden:
                        //  El 1 al elemento del que sale el rayo.
                        //  El subndice 0 es el del rayo en espacio objeto
                        //  El 2 al rayo j.
                        //  Para j de 0 a 10, rayo del punto del eje del objeto
                        //  Para j de 11 a 22, rayo del punto del borde del objeto
    static double zaRayo[][][] = new double[2][8][22];  //  Interseccin del rayo con el
    static double yaRayo[][][] = new double[2][8][22];  //  elemento. (Sup. anterior). 

    static double zpRayo[][][] = new double[2][8][22];  //  Interseccin del rayo con el
    static double ypRayo[][][] = new double[2][8][22];  //  elemento. (Sup. posterior). 

    static double hRayo[][][] = new double[2][8][22];   //  Altura del rayo en el
                                                        //  elemento (paraxial)
                        //  El subndice 0 corresponde al origen de coordenadas

                        //  Datos de los rayos para puntos cardinales
    static double aRayoCard[][] = new double[2][8];   //  Coeficientes de la recta del
    static double bRayoCard[][] = new double[2][8];   //  rayo (y = az + b) a la entrada                                            //  del rayo a la entrada
    static double apRayoCard[][] = new double[2][8];  //  Coeficientes de la recta del
    static double bpRayoCard[][] = new double[2][8];  //  rayo (y = az + b) a la salida
    static double zaRayoCard[][] = new double[2][8];  //  Interseccin del rayo con el
    static double yaRayoCard[][] = new double[2][8];  //  elemento. (Sup. anterior). 
    static double zpRayoCard[][] = new double[2][8];  //  Interseccin del rayo con el
    static double ypRayoCard[][] = new double[2][8];  //  elemento. (Sup. posterior). 
    static double hRayoCard[][] = new double[2][8];   //  Altura del rayo en el elemento
    static double fRayoCard[][] = new double[2][8];   //  Relacin entre la altura en 
                                                      //  el elemento y su dimetro

    static int      diamMax = 70;       //  Dimetro mximo para los diafragmas

    static double   indice = 1.5;       //  Indice de refraccin 

    static int      pintarRayos[] = {0, 0};    //  Control para el dibujo


    //======================  Crea varias fuentes   ===========================

    static Font fuente1 = new Font ("Dialog", Font.BOLD, 24);
    static Font fuente2 = new Font ("Dialog", Font.BOLD, 12);
    static Font fuente3 = new Font ("Dialog", Font.BOLD, 11);
    static Font fuente4 = new Font ("Dialog", Font.BOLD, 9);

    static Color   colorTexto1 = Color.white;
    static Color   colorTexto2 = Color.black;


    //======================    Abre la funcin     ===========================

    static public void abrir ()
    {
        int     i, j;


        SistemaFL.panelBase.add (panelBase);
        SistemaFL.panelBase.add (canvasSistema);


        //----------------------     Objeto 1   ---------------------

                        //  Datos de los objetos

        for (i = 0; i < 2; i ++)
        {
            if (SistemaFL.valZObj[i] == -1600)
                                                //  No existe el objeto
            {
                SistemaFL.existeObjeto[i] = 0;
                labelValZObj[i].setText ("----");

                                //  Desactiva la corredera de campo y las leyendas
                sliderValHObj[i].setEnabled (false);
                for (j = 0; j < 5; j ++)
                {
                    valCampo[i][j].setVisible (false);
                }
            }
            else
            {                                   //  Existe el objeto
                SistemaFL.existeObjeto[i] = 1;

                                //  Activa la corredera de campo y las leyendas
                sliderValHObj[i].setEnabled (true);
                for (j = 0; j < 5; j ++)
                {
                    valCampo[i][j].setVisible (true);
                }
               
                if (SistemaFL.valZObj[i] <= -1500 || SistemaFL.valZObj[i] >= 1600)
                                                    //  Objeto en el infinito
                {
                    labelValZObj[i].setText (text[14][lang]);
                    SistemaFL.zObjeto[i] = -1.E10;
                }
                else
                                                    //  Objeto a distancia finita
                {
                    labelValZObj[i].setText (SistemaFL.valZObj[i] + " mm");
                    SistemaFL.zObjeto[i] = SistemaFL.valZObj[i];
                }
            }
        }


        //------------  Paneles para los objetos    ---------------------------

        for (i = 0; i < 2; i ++)
        {
                                    //  Botones "radio"

            if (SistemaFL.real[i] == 1)
                buttonR[i].setSelected (true);
            else
                buttonV[i].setSelected (true);

            labelValHObj[i].setText (SistemaFL.campo[i] + "");

            sliderValZObj[i].setValue ((int) SistemaFL.valZObj[i]);
            sliderValHObj[i].setValue ((int) (SistemaFL.campo[i] * 10.));

        }



        //----------------   Lentes y diafragmas   ---------------------

                            //  Datos de las lentes y diafragmas

        for (i = 1; i < 7; i++)
        {
            if (SistemaFL.valPE[i] < 0.)
                SistemaFL.espesor[i] = 5.;
            else
                SistemaFL.espesor[i] = SistemaFL.valDibPE[i] * 2.;

            if (SistemaFL.valPE[i] != 0)
            {
                sliderValZE[i].setEnabled (true);
                SistemaFL.existe[i] = 1;

                        //  Calcula los radios como lente simtrica

                SistemaFL.curv[i] = SistemaFL.valPE[i] / (2. * indice - 2.);
                if (Math.abs (SistemaFL.curv[i]) <= 1.e-10)
                {
                    SistemaFL.radio[i] = 1000.e10;
                    SistemaFL.radioDib[i] = 1000.e10;
                }
                else
                {
                    SistemaFL.radio[i] = 2000. * (indice - 1.) / SistemaFL.valPE[i];
                    SistemaFL.radioDib[i] = SistemaFL.radio[i] * SistemaFL.valPE[i] / SistemaFL.valDibPE[i];
                }
            }

        }


        //------------  Paneles para lentes y diafragmas   ---------------------

                                //  Paneles de cada elemento

        for (i = 1; i < 7; i ++)
        {
                                //  Elementos del panel
    
                                    //  Botones "radio"

            if (SistemaFL.tipoE[i] == 1)
                buttonL[i].setSelected (true);
            else
                buttonD[i].setSelected (true);

                                    //  Valor de la posicin

            labelValZE[i].setText (SistemaFL.valZE[i] + " mm");
    
                                    //  Corredera para la posicin
    
            sliderValZE[i].setValue ((int) SistemaFL.valZE[i]);
    
            if (SistemaFL.tipoE[i] == 1)           //     Es lente
            {
       
                                //  Ttulo "Potencia"

                unidad[i] = " diop";
                labelHE[i].setText (text[8][lang]);
            
                                //  Focal
            
                labelFE[i].setText (text[15][lang]);

                                //  Activa las leyendas de la posicin

                for (j = 0; j < 5; j ++)
                {
                    valPos[i][j].setVisible (true);
                }

                                //  Borra las leyendas del dimetro

                for (j = 0; j < 4; j ++)
                {
                    valDiam[i][j].setVisible (false);
                }

                                //  Activa las leyendas de la potencia

                for (j = 0; j < 5; j ++)
                {
                    valPot[i][j].setVisible (true);
                }

                                //  Corredera para la potencia

                datosCorrederaHLente (i);

                                //  Activa o no la corredera de posicin

                if (SistemaFL.valPE[i] != 0.)
                {
                    sliderValZE[i].setEnabled (true);
                }
                else
                {
                    sliderValZE[i].setEnabled (false);
                }

            }

            else           //  Es diafragma

            {

                labelHE[i].setText (text[13][lang]);
                unidad[i] = " mm";

                                                //  Borra la focal si no es lente
                labelFE[i].setText (" ");
                labelValFE[i].setText (" ");

                if (SistemaFL.valDE[i] != diamMax)
                {
                    labelValHE[i].setText (SistemaFL.valDE[i] + " mm");
                }
                else
                {
                    labelValHE[i].setText ("---");
                }

                            //  Borra las leyendas de la potencia

                for (j = 0; j < 5; j ++)
                {
                    valPot[i][j].setVisible (false);
                }

                                //  Activa las leyendas del dimetro

                for (j = 0; j < 4; j ++)
                {
                    valDiam[i][j].setVisible (true);
                }

                                //  Corredera para el dimetro

                datosCorrederaHDiafragma (i);

                if (SistemaFL.valDE[i] != diamMax)
                {
                    sliderValZE[i].setEnabled (true);
                }
                else
                {
                    sliderValZE[i].setEnabled (false);
                }

            }

        }

                        //  Actualiza el sistema

        for (i = 0; i < 2; i ++)
        {
            FuncionesParaxialesFL.tablaTramos (i);
            FuncionesParaxialesFL.marchaParaxial (i);
            FuncionesParaxialesFL.coeficientesRayos (i);
            FuncionesParaxialesFL.interseccionesRayos (i);
        }

        FuncionesParaxialesFL.calculaPupilas ();

        canvasSistema.redraw ();
    }



    //=====================  Constructor  =====================================


    public AnteproyectoFL ()
    {
        super ();       //  Llama al constructor de JFrame

        int     i, j;

        SistemaFL.valZE[0] = 0.;
        SistemaFL.existe[0] = 1;      //  El origen de coordenadas existe

        SistemaFL.valZE[7] = 1600.;   //  El extremo derecho
        SistemaFL.existe[7] = 1;      //  El extremo derecho existe

        for (i = 0; i < 7; i ++)
        {
            for (j = 0; j < 22; j ++)
            {
                pasa[0][i][j] = 0;
                pasa[1][i][j] = 0;
            }
        }


        for (i = 1; i < 7; i ++)
        {
            SistemaFL.valZE[i] = 200. + 200. * i;
            SistemaFL.valPE[i] = 0.;
            SistemaFL.valDibPE[i] = 0.;
            SistemaFL.existe[i] = 0;
            SistemaFL.valDE[i] = (double) diamMax;
            SistemaFL.dist[i] = 0.;
            SistemaFL.tipoE[i] = 1;
            SistemaFL.altura[i] = diamMax / 2.;
        }

        //-------------    Panel para la marcha paraxial  --------------------

        canvasSistema = new DibujoSistemaFL ();
        canvasSistema.setBackground (Color.black);
        canvasSistema.setBounds (30, 0, 800, 210);


        //-------------    Panel para los puntos cardinales   ---------------

        puntosCardinales = new PuntosCardinalesFL (canvasSistema);
        puntosCardinales.setBackground (Color.black);
        puntosCardinales.setBounds (0, 230, 800, 220);


        //------------  Panel para el men del anteproyecto     ---------------

        panelBase = new JPanel ();
        panelBase.setLayout (null);                 
        panelBase.setBackground (Color.gray);
        panelBase.setBounds (0, 230, 300, 220);

                //  Prepara los botones del anteproyecto y los pone en panelBase

                        //  Ttulo

        JLabel labelBase = new JLabel (text[0][lang]);
        labelBase.setBounds (100, 5, 220, 27);
        labelBase.setForeground (colorTexto1);
        labelBase.setFont (fuente2);
        panelBase.add (labelBase);

                        //  Botones para el objeto

        buttonObj[0] = new JButton (text[1][lang] + " 1");
        buttonObj[0].setBounds (10, 32, 138, 27);
        buttonObj[0].setForeground (colorTexto2);
        buttonObj[0].setFont (fuente2);

        buttonObj[1] = new JButton (text[1][lang] + " 2");
        buttonObj[1].setBounds (148, 32, 138, 27);
        buttonObj[1].setForeground (colorTexto2);
        buttonObj[1].setFont (fuente2);

                                //  Para que respondan a una pulsacin
        buttonObj[0].addActionListener (this);  
        buttonObj[1].addActionListener (this);  

                                //  Texto que devuelven cuando responde
        buttonObj[0].setActionCommand ("buttonObj0");
        buttonObj[1].setActionCommand ("buttonObj1");

        panelBase.add (buttonObj[0]);
        panelBase.add (buttonObj[1]);

                        //  Ttulo para las lentes y diafragmas

        JLabel labelL = new JLabel (text[2][lang]);
        labelL.setBounds (80, 59, 200, 27);
        labelL.setForeground (colorTexto1);
        labelL.setFont (fuente2);
        panelBase.add (labelL);


                        //  Botones para lentes y diafragmas

        for (i = 1; i < 7; i ++)
        {
            nomBoton[i] = new String (""+i);
            buttonE[i] = new JButton (nomBoton[i]);
            buttonE[i].setBounds (10+(i-1)*46, 86, 46, 27);
            buttonE[i].setForeground (colorTexto2);
            buttonE[i].setFont (fuente2);
            buttonE[i].addActionListener (this); 
            buttonE[i].setActionCommand (nomBoton[i]);
            panelBase.add (buttonE[i]);
        }

                        //  Botn para Objeto Virtual

        buttonObjVirtual = new JToggleButton (text[3][lang]);
        buttonObjVirtual.setBounds (10, 113, 138, 27);
        buttonObjVirtual.setForeground (colorTexto2);
        buttonObjVirtual.setFont (fuente4);
        buttonObjVirtual.addActionListener (this); 
        buttonObjVirtual.setActionCommand ("buttonObjVirtual");   
        panelBase.add (buttonObjVirtual);


                        //  Botn para Imagen Virtual

        buttonVirtual = new JToggleButton (text[4][lang]);
        buttonVirtual.setBounds (148, 113, 138, 27);
        buttonVirtual.setForeground (colorTexto2);
        buttonVirtual.setFont (fuente4);
        buttonVirtual.addActionListener (this); 
        buttonVirtual.setActionCommand ("buttonVirtual");   
        panelBase.add (buttonVirtual);

                        //  Botn para Puntos Cardinales

        buttonCard = new JButton (text[5][lang]);
        buttonCard.setBounds (10, 140, 276, 27);
        buttonCard.setForeground (colorTexto2);
        buttonCard.setFont (fuente2);
        buttonCard.addActionListener (this); 
        buttonCard.setActionCommand ("buttonCard");   
        panelBase.add (buttonCard);

                        //  Botn para Men principal

        buttonMP = new JButton (text[6][lang]);
        buttonMP.setBounds (10, 167, 276, 27);
        buttonMP.setForeground (colorTexto2);
        buttonMP.setFont (fuente2);
        buttonMP.addActionListener (this); 
        buttonMP.setActionCommand ("buttonMP");
        panelBase.add (buttonMP);



        //====  Prepara los paneles de las opciones del anteproyecto   ========

        //------------  Paneles para los objetos    ---------------------------

        for (i = 0; i < 2; i ++)
        {

            panelObj[i] = new JPanel ();
            panelObj[i].setLayout (null);                 
            panelObj[i].setBounds (300, 230, 500, 220);
           
                                //  Elementos del panel
           
                                    //  Ttulo
           
            labelObj[i] = new JLabel (text[1][lang]+" "+(i+1));
            labelObj[i].setBounds (20, 10, 200, 30);
            labelObj[i].setForeground (Color.black);
            labelObj[i].setFont (fuente2);
            panelObj[i].add (labelObj[i]);
    
    
                                    //  Botones "radio"

            buttonR[i] = new JRadioButton ("Real");
            buttonR[i].setBounds (200, 10, 100, 30);
            buttonR[i].setFont (fuente2);
            buttonR[i].setActionCommand ("R");
            buttonR[i].addActionListener (this);
            buttonR[i].setSelected (true);

            buttonV[i] = new JRadioButton ("Virtual");
            buttonV[i].setBounds (350, 10, 100, 30);
            buttonV[i].setFont (fuente2);
            buttonV[i].setActionCommand ("V");
            buttonV[i].addActionListener (this);


                                    //  Agrupa los botones "radio"

            grupoO[i] = new ButtonGroup ();
            grupoO[i].add (buttonR[i]);
            grupoO[i].add (buttonV[i]);

            panelObj[i].add (buttonR[i]);
            panelObj[i].add (buttonV[i]);

           
                                    //  Corredera para la posicin del objeto

            labelZObj[i] = new JLabel (text[7][lang]);
            labelZObj[i].setBounds (20, 70, 100, 30);
            labelZObj[i].setForeground (grisAzulado);
            labelZObj[i].setFont (fuente2);
            panelObj[i].add (labelZObj[i]);
           
            labelValZObj[i] = new JLabel ("---");
            labelValZObj[i].setBounds (100, 70, 100, 30);
            labelValZObj[i].setForeground (grisAzulado);
            labelValZObj[i].setFont (fuente2);
            panelObj[i].add (labelValZObj[i]);

           
                                        //  Corredera
           
            sliderValZObj[i] = new JSlider (-1600, 1600, -1600);
            sliderValZObj[i].setPaintTicks (true);
            sliderValZObj[i].setMajorTickSpacing (800);
            sliderValZObj[i].setMinorTickSpacing (100);
            sliderValZObj[i].setPaintLabels (false);
            sliderValZObj[i].setBounds (190, 70, 280, 30);

                                        //  Leyendas de la posicin
    
            valPosObj[i][0] = new JLabel (leyendaPosObj[0]);
            valPosObj[i][0].setBounds (180, 90, 60, 30);
            valPosObj[i][0].setForeground (grisAzulado);
            valPosObj[i][0].setFont (fuente2);
            valPosObj[i][0].setVisible (true);
            panelObj[i].add (valPosObj[i][0]);
        
            valPosObj[i][1] = new JLabel (leyendaPosObj[1]);
            valPosObj[i][1].setBounds (250, 90, 60, 30);
            valPosObj[i][1].setForeground (grisAzulado);
            valPosObj[i][1].setFont (fuente2);
            valPosObj[i][1].setVisible (true);
            panelObj[i].add (valPosObj[i][1]);
        
            valPosObj[i][2] = new JLabel (leyendaPosObj[2]);
            valPosObj[i][2].setBounds (325, 90, 60, 30);
            valPosObj[i][2].setForeground (grisAzulado);
            valPosObj[i][2].setFont (fuente2);
            valPosObj[i][2].setVisible (true);
            panelObj[i].add (valPosObj[i][2]);
        
            valPosObj[i][3] = new JLabel (leyendaPosObj[3]);
            valPosObj[i][3].setBounds (388, 90, 60, 30);
            valPosObj[i][3].setForeground (grisAzulado);
            valPosObj[i][3].setFont (fuente2);
            valPosObj[i][3].setVisible (true);
            panelObj[i].add (valPosObj[i][3]);
        
            valPosObj[i][4] = new JLabel (leyendaPosObj[4]);
            valPosObj[i][4].setBounds (450, 90, 60, 30);
            valPosObj[i][4].setForeground (grisAzulado);
            valPosObj[i][4].setFont (fuente2);
            valPosObj[i][4].setVisible (true);
            panelObj[i].add (valPosObj[i][4]);
        
           
                                        //  Crea el "escuchador" para la corredera.

            listenerValZObj[i] = new SliderListener (labelValZObj[i]);
            sliderValZObj[i].addChangeListener (listenerValZObj[i]);
            panelObj[i].add (sliderValZObj[i]);
           
           
                                    //  Corredera para la altura del objeto
           
            labelHObj[i] = new JLabel (text[9][lang]);
            labelHObj[i].setBounds (20, 130, 100, 30);
            labelHObj[i].setForeground (grisAzulado);
            labelHObj[i].setFont (fuente2);
            panelObj[i].add (labelHObj[i]);
           
            labelValHObj[i] = new JLabel ("0.");
            labelValHObj[i].setBounds (110, 130, 100, 30);
            labelValHObj[i].setForeground (grisAzulado);
            labelValHObj[i].setFont (fuente2);
            panelObj[i].add (labelValHObj[i]);
           
                                        //  Corredera
           
            sliderValHObj[i] = new JSlider (0, 200, 0);
            sliderValHObj[i].setPaintTicks (true);
            sliderValHObj[i].setMajorTickSpacing (50);
            sliderValHObj[i].setMinorTickSpacing (25);
            sliderValHObj[i].setPaintLabels (false);
            sliderValHObj[i].setBounds (190, 135, 280, 30);
            sliderValHObj[i].setEnabled (false);
           

                                        //  Leyendas del campo
    
            valCampo[i][0] = new JLabel (leyendaCampo[0]);
            valCampo[i][0].setBounds (195, 155, 60, 30);
            valCampo[i][0].setForeground (grisAzulado);
            valCampo[i][0].setFont (fuente2);
            valCampo[i][0].setVisible (false);
            panelObj[i].add (valCampo[i][0]);
        
            valCampo[i][1] = new JLabel (leyendaCampo[1]);
            valCampo[i][1].setBounds (262, 155, 60, 30);
            valCampo[i][1].setForeground (grisAzulado);
            valCampo[i][1].setFont (fuente2);
            valCampo[i][1].setVisible (false);
            panelObj[i].add (valCampo[i][1]);
        
            valCampo[i][2] = new JLabel (leyendaCampo[2]);
            valCampo[i][2].setBounds (325, 155, 60, 30);
            valCampo[i][2].setForeground (grisAzulado);
            valCampo[i][2].setFont (fuente2);
            valCampo[i][2].setVisible (false);
            panelObj[i].add (valCampo[i][2]);
        
            valCampo[i][3] = new JLabel (leyendaCampo[3]);
            valCampo[i][3].setBounds (388, 155, 60, 30);
            valCampo[i][3].setForeground (grisAzulado);
            valCampo[i][3].setFont (fuente2);
            valCampo[i][3].setVisible (false);
            panelObj[i].add (valCampo[i][3]);
        
            valCampo[i][4] = new JLabel (leyendaCampo[4]);
            valCampo[i][4].setBounds (450, 155, 60, 30);
            valCampo[i][4].setForeground (grisAzulado);
            valCampo[i][4].setFont (fuente2);
            valCampo[i][4].setVisible (false);
            panelObj[i].add (valCampo[i][4]);
        

                                        //  Crea el "escuchador" para la corredera.

            listenerValHObj[i] = new SliderListener (labelValHObj[i]);
            sliderValHObj[i].addChangeListener (listenerValHObj[i]);
            panelObj[i].add (sliderValHObj[i]);
        }



        //-----------   Paneles para lentes y diafragmas    -------------------

                                //  Paneles de cada elemento

        for (i = 1; i < 7; i ++)
        {
            panelE[i] = new JPanel ();
            panelE[i].setLayout (null);                 
            panelE[i].setBounds (300, 230, 500, 220);
            unidad[i] = " diop.";

                                //  Elementos del panel
                                    //  Ttulo
    
            labelE[i] = new JLabel (text[10][lang]+" "+i);
            labelE[i].setBounds (20, 10, 200, 30);
            labelE[i].setForeground (Color.black);
            labelE[i].setFont (fuente2);
            panelE[i].add (labelE[i]);
    
                                    //  Botones "radio"

            buttonL[i] = new JRadioButton (text[11][lang]);
            buttonL[i].setBounds (200, 10, 100, 30);
            buttonL[i].setFont (fuente2);
            buttonL[i].addActionListener (this);
            buttonL[i].setActionCommand ("L");
            buttonL[i].setSelected (true);

            buttonD[i] = new JRadioButton (text[12][lang]);
            buttonD[i].setBounds (350, 10, 100, 30);
            buttonD[i].setFont (fuente2);
            buttonD[i].addActionListener (this);
            buttonD[i].setActionCommand ("D");

                                    //  Agrupa los botones "radio"

            grupo[i] = new ButtonGroup ();
            grupo[i].add (buttonL[i]);
            grupo[i].add (buttonD[i]);

            panelE[i].add (buttonL[i]);
            panelE[i].add (buttonD[i]);


                                    //  Posicin
    
            labelZE[i] = new JLabel (text[7][lang]);
            labelZE[i].setBounds (20, 70, 100, 30);
            labelZE[i].setForeground (grisAzulado);
            labelZE[i].setFont (fuente2);
            panelE[i].add (labelZE[i]);
    
                                    //  Valor de la posicin
    
            labelValZE[i] = new JLabel (SistemaFL.valZE[i] + " mm");
            labelValZE[i].setBounds (100, 70, 100, 30);
            labelValZE[i].setForeground (grisAzulado);
            labelValZE[i].setFont (fuente2);
            panelE[i].add (labelValZE[i]);
    
                                    //  Corredera
    
            sliderValZE[i] = new JSlider (0, 1600, 200+200*i);
            sliderValZE[i].setPaintTicks (true);
            sliderValZE[i].setMajorTickSpacing (400);
            sliderValZE[i].setMinorTickSpacing (50);
            sliderValZE[i].setPaintLabels (false);
            sliderValZE[i].setBounds (190, 70, 280, 30);
            sliderValZE[i].setEnabled (false);
    
                                    //  Crea el "escuchador" para la corredera.
    
            listenerValZE[i] = new SliderListener (labelValZE[i]);
            sliderValZE[i].addChangeListener (listenerValZE[i]);
            sliderValZE[i].setEnabled (false);
    
            panelE[i].add (sliderValZE[i]);
    
                                    //  Leyendas de la posicin

            valPos[i][0] = new JLabel (leyendaPos[0]);
            valPos[i][0].setBounds (190, 90, 60, 30);
            valPos[i][0].setForeground (grisAzulado);
            valPos[i][0].setFont (fuente2);
            panelE[i].add (valPos[i][0]);
    
            valPos[i][1] = new JLabel (leyendaPos[1]);
            valPos[i][1].setBounds (250, 90, 60, 30);
            valPos[i][1].setForeground (grisAzulado);
            valPos[i][1].setFont (fuente2);
            panelE[i].add (valPos[i][1]);
    
            valPos[i][2] = new JLabel (leyendaPos[2]);
            valPos[i][2].setBounds (315, 90, 60, 30);
            valPos[i][2].setForeground (grisAzulado);
            valPos[i][2].setFont (fuente2);
            panelE[i].add (valPos[i][2]);
    
            valPos[i][3] = new JLabel (leyendaPos[3]);
            valPos[i][3].setBounds (380, 90, 60, 30);
            valPos[i][3].setForeground (grisAzulado);
            valPos[i][3].setFont (fuente2);
            panelE[i].add (valPos[i][3]);
    
            valPos[i][4] = new JLabel (leyendaPos[4]);
            valPos[i][4].setBounds (450, 90, 60, 30);
            valPos[i][4].setForeground (grisAzulado);
            valPos[i][4].setFont (fuente2);
            panelE[i].add (valPos[i][4]);
    
            panelE[i].add (sliderValZE[i]);
    
                                    //  Potencia o radio de diafragma
    
            labelHE[i] = new JLabel (text[8][lang]);
            labelHE[i].setBounds (20, 130, 100, 30);
            labelHE[i].setForeground (grisAzulado);
            labelHE[i].setFont (fuente2);
            panelE[i].add (labelHE[i]);
            SistemaFL.altura[i] = diamMax / 2.;
    
                                    //  Valor de la potencia
    
            texto1 = "0 diop";
            labelValHE[i] = new JLabel (texto1);
            labelValHE[i].setBounds (100, 130, 100, 30);
            labelValHE[i].setForeground (grisAzulado);
            labelValHE[i].setFont (fuente2);
            panelE[i].add (labelValHE[i]);

                                    //  Focal
    
            labelFE[i] = new JLabel (text[15][lang]);
            labelFE[i].setBounds (20, 150, 100, 30);
            labelFE[i].setForeground (grisAzulado);
            labelFE[i].setFont (fuente2);
            panelE[i].add (labelFE[i]);
    
                                    //  Valor de la focal

            texto1 = "---";
            labelValFE[i] = new JLabel (texto1);
            labelValFE[i].setBounds (100, 150, 100, 30);
            labelValFE[i].setForeground (grisAzulado);
            labelValFE[i].setFont (fuente2);
            panelE[i].add (labelValFE[i]);

                                //  Corredera
    
            sliderValHE[i] = new JSlider (-200, 200, 0);
            datosCorrederaHLente (i);

                                    //  Crea el "escuchador" para la corredera.
    
            listenerValHE[i] = new SliderListener (labelValHE[i]);
            sliderValHE[i].addChangeListener (listenerValHE[i]);
    

                                    //  Leyendas de la potencia

            valPot[i][0] = new JLabel (leyendaPot[0]);
            valPot[i][0].setBounds (190, 150, 60, 30);
            valPot[i][0].setForeground (grisAzulado);
            valPot[i][0].setFont (fuente2);
            panelE[i].add (valPot[i][0]);
    
            valPot[i][1] = new JLabel (leyendaPot[1]);
            valPot[i][1].setBounds (255, 150, 60, 30);
            valPot[i][1].setForeground (grisAzulado);
            valPot[i][1].setFont (fuente2);
            panelE[i].add (valPot[i][1]);
    
            valPot[i][2] = new JLabel (leyendaPot[2]);
            valPot[i][2].setBounds (328, 150, 60, 30);
            valPot[i][2].setForeground (grisAzulado);
            valPot[i][2].setFont (fuente2);
            panelE[i].add (valPot[i][2]);
    
            valPot[i][3] = new JLabel (leyendaPot[3]);
            valPot[i][3].setBounds (385, 150, 60, 30);
            valPot[i][3].setForeground (grisAzulado);
            valPot[i][3].setFont (fuente2);
            panelE[i].add (valPot[i][3]);
    
            valPot[i][4] = new JLabel (leyendaPot[4]);
            valPot[i][4].setBounds (450, 150, 60, 30);
            valPot[i][4].setForeground (grisAzulado);
            valPot[i][4].setFont (fuente2);
            panelE[i].add (valPot[i][4]);

            panelE[i].add (sliderValHE[i]);

                                    //  Leyendas del dimetro

            valDiam[i][0] = new JLabel (leyendaDiam[0]);
            valDiam[i][0].setBounds (190, 150, 60, 30);
            valDiam[i][0].setForeground (grisAzulado);
            valDiam[i][0].setFont (fuente2);
            panelE[i].add (valDiam[i][0]);
    
            valDiam[i][1] = new JLabel (leyendaDiam[1]);
            valDiam[i][1].setBounds (265, 150, 60, 30);
            valDiam[i][1].setForeground (grisAzulado);
            valDiam[i][1].setFont (fuente2);
            panelE[i].add (valDiam[i][1]);
    
            valDiam[i][2] = new JLabel (leyendaDiam[2]);
            valDiam[i][2].setBounds (340, 150, 60, 30);
            valDiam[i][2].setForeground (grisAzulado);
            valDiam[i][2].setFont (fuente2);
            panelE[i].add (valDiam[i][2]);
    
            valDiam[i][3] = new JLabel (leyendaDiam[3]);
            valDiam[i][3].setBounds (420, 150, 60, 30);
            valDiam[i][3].setForeground (grisAzulado);
            valDiam[i][3].setFont (fuente2);
            panelE[i].add (valDiam[i][3]);
    
            panelE[i].add (sliderValHE[i]);

        }


    }



    //========  Define los mtodos de ActionListener  =========================


    public void actionPerformed (ActionEvent e) 
    {
        int     i, j;


            //  Obtiene la etiqueta del botn pulsado

        String s = e.getActionCommand ();


        //-------------     Opciones del anteproyecto   -----------------------


        //  Ante cualquier accin de cambio de panel, borra el panel 
        //  inferior derecho, que es el que haba puesto la opcin anterior.

        if ((s != "L") && (s != "D") && (s != "R") && (s != "V") &&
                 (s != "buttonVirtual") && (s != "buttonObjVirtual")) 
        {
            if (cuadro == 0)
                SistemaFL.panelBase.remove (panelObj[0]);
    
            if (cuadro == 1)
                SistemaFL.panelBase.remove (panelObj[1]);
    
            for (i = 0; i < 7; i ++)
            {
                if (cuadro == 20 + i)
                    SistemaFL.panelBase.remove (panelE[i]);
            }
        }

                //  Pone el panel de la opcin
 
                                //  Objeto

        if (s == "buttonObj0")  
        {
            SistemaFL.panelBase.add (panelObj[0]);
            cuadro = 0;
        }

        if (s == "buttonObj1")  
        {
            SistemaFL.panelBase.add (panelObj[1]);
            cuadro = 1;
        }

                                    //  Controla el botn "radio" del objeto

        if (cuadro == 0)            //  Objeto 1
        {
            if (s == "R")           //  Objeto real
                SistemaFL.real[0] = 1;

            if (s == "V")           //  Objeto virtual
                SistemaFL.real[0] = 0;
        }

        if (cuadro == 1)            //  Objeto 2
        {
            if (s == "R")           //  Objeto real
                SistemaFL.real[1] = 1;

            if (s == "V")           //  Objeto virtual
                SistemaFL.real[1] = 0;
        }


                                //  Elemento i

        for (i = 0; i < 7; i ++)
        {

                                    //  Controla el botn que lo llama
            if (s == nomBoton[i])
            {

                SistemaFL.panelBase.add (panelE[i]);
                cuadro = 20 + i;
            }



                                    //  Controla el botn "radio"
                //  Como al cambiar los valores de las correderas, se lanza
                //  un evento de cambio y llama al "StateChanged", hay que poner
                //  el "setValue (0)" lo primero de todo en el caso "L", para
                //  que no utilice el que haba antes (diamMax) al calcular el
                //  espesor, mientras que en el caso "D" el "setValue (diamMax)" 
                //  ha de estar despus de cambiar el mximo.

            if (cuadro == 20 + i)
            {
                if (s == "L")           //     Lo declaramos lente
                {
                    SistemaFL.tipoE[i] = 1;
                    unidad[i] = " diop.";
                    SistemaFL.existe[i] = 0;

                                //  Borra las leyendas del dimetro

                    for (j = 0; j < 4; j ++)
                    {
                        valDiam[i][j].setVisible (false);
                    }

                    datosCorrederaHLente (i);

                    sliderValZE[i].setEnabled (false);
                    labelHE[i].setText (text[8][lang]);
                    labelValHE[i].setText (0. + unidad[i]);
                    labelFE[i].setText (text[15][lang]);
                    labelValFE[i].setText ("---");
                    SistemaFL.altura[i] = diamMax / 2.;

                                //  Escribe las leyendas de la potencia
                    for (j = 0; j < 5; j ++)
                    {
                        valPot[i][j].setVisible (true);
                    }

                    SistemaFL.valPE[i] = 0.;
                    SistemaFL.valDibPE[i] = 0.;
                    SistemaFL.valDE[i] = (double) diamMax;

                                //  Calcula la separacin mnima entre dos elementos
                    if (i < 6)
                        SistemaFL.dist[i] = Math.abs (SistemaFL.valDibPE[i+1]);
                    else
                        SistemaFL.dist[i] = 0.;
                    SistemaFL.dist[i-1] = Math.abs (SistemaFL.valDibPE[i-1]);
                }

                if (s == "D")           //  Lo declaramos diafragma
                {
                    SistemaFL.tipoE[i] = 0;
                    unidad[i] = " mm";
                    SistemaFL.existe[i] = 0;

                                //  Borra las leyendas de la potencia
                    for (j = 0; j < 5; j ++)
                    {
                        valPot[i][j].setVisible (false);
                    }

                    datosCorrederaHDiafragma (i);

                    sliderValZE[i].setEnabled (false);
                    labelHE[i].setText (text[13][lang]);
                    labelValHE[i].setText ("---");
                    labelFE[i].setText (" ");
                    labelValFE[i].setText (" ");

                                //  Escribe las leyendas del dimetro

                    for (j = 0; j < 4; j ++)
                    {
                        valDiam[i][j].setVisible (true);
                    }

                    SistemaFL.valPE[i] = 0.;
                    SistemaFL.valDibPE[i] = 0.;
                    SistemaFL.valDE[i] = (double) diamMax;
                    SistemaFL.altura[i] = diamMax / 2.;
                    SistemaFL.espesor[i] = 0.;

                                //  Calcula la separacin mnima entre dos elementos
                    if (i < 6)
                        SistemaFL.dist[i] = Math.abs (SistemaFL.valDibPE[i+1]);
                    else
                        SistemaFL.dist[i] = 0.;
                    SistemaFL.dist[i-1] = Math.abs (SistemaFL.valDibPE[i-1]);
                }
            }

        }

        if (s == "buttonObjVirtual")      //  Ver el objeto virtual
        {
            verObjetoVirtual = - verObjetoVirtual;
        }

        if (s == "buttonVirtual")      //  Ver la imagen virtual
        {
            verImagenVirtual = - verImagenVirtual;
        }


        if (s == "buttonCard")      //  Ver los planos cardinales
        {
            SistemaFL.panelBase.remove (panelBase);
            SistemaFL.panelBase.add (puntosCardinales);
            puntosCardinales.dibujoPC.redraw ();
        }


        if (s == "buttonMP")        //  Vuelve a Men principal
        {
            SistemaFL.panelBase.remove (panelBase);
            SistemaFL.panelBase.remove (canvasSistema);
            SistemaFL.panelBase.add (SistemaFL.panelBase.panelMP);
        }


                //  Actualiza la ventana

        SistemaFL.panelBase.repaint ();
        for (i = 0; i < 2; i ++)
        {
            FuncionesParaxialesFL.tablaTramos (i);
            FuncionesParaxialesFL.marchaParaxial (i);
            FuncionesParaxialesFL.coeficientesRayos (i);
            FuncionesParaxialesFL.interseccionesRayos (i);
        }
        FuncionesParaxialesFL.calculaPupilas ();
        canvasSistema.redraw ();
    }


    //================      Clase para leer las correderas  ===================

        //  Al moverse la corredera entra aqu y no sigue hasta que se
        //  vuelve a mover o se pulsa otro botn.
        //  Por eso se debe poner aqu todo el cdigo de las operaciones
        //  que deban realizarse al mover la corredera.
        //  Se puede poner una clase para cada corredera o bien una sola clase
        //  con un control segn el nombre de la corredera.

    class SliderListener implements ChangeListener 
    {
        JLabel  tf;                            
        int     i;

        public SliderListener (JLabel f) 
        {
            tf = f;
        }
        

        //------------  Define los mtodos de "stateChanged"    ---------------

        public void stateChanged (ChangeEvent e) 
        {
            JSlider s1 = (JSlider) e.getSource ();
            double  focal;
            int     j;


        //-------------  Aqu viene el cdigo de operaciones    ---------------


            //------------------------    Objetos     -------------------------

            for (i = 0; i < 2; i ++)
            {

                            //  Posicin 
    
                if (tf == labelValZObj[i]) 
                {
                    SistemaFL.valZObj[i] = (double) s1.getValue ();
    
                    if (SistemaFL.valZObj[i] == -1600)        //  No existe el objeto
                    {
                        SistemaFL.existeObjeto[i] = 0;
                        tf.setText ("----");

                                //  Desactiva la corredera y las leyendas del campo

                        sliderValHObj[i].setEnabled (false);
                        for (j = 0; j < 5; j ++)
                        {
                            valCampo[i][j].setVisible (false);
                        }
                    }
                    else
                    {
                        SistemaFL.existeObjeto[i] = 1;

                        if (SistemaFL.valZObj[i]>=1600 || SistemaFL.valZObj[i]<=-1500)

                                                //  Objeto en el infinito
                        {
                            SistemaFL.zObjeto[i] = -1.e10;
                            tf.setText (text[14][lang]);
                        }
                        else
                        {
                                                //  Objeto a distancia finita

                            SistemaFL.zObjeto[i] = SistemaFL.valZObj[i];
                            tf.setText (SistemaFL.valZObj[i] + " mm");
                        }

                                //  Activa la corredera y las leyendas del campo
    
                        sliderValHObj[i].setEnabled (true);
                        for (j = 0; j < 5; j ++)
                        {
                            valCampo[i][j].setVisible (true);
                        }
                    }
                }
    
                            //  Altura
    
                if (tf == labelValHObj[i])
                {
                    SistemaFL.campo[i] = (double) s1.getValue () / 10.;
                    SistemaFL.campoDib[i] = SistemaFL.campo[i] * 8.;
                    tf.setText (SistemaFL.campo[i] + " ");
                }
            }
    

            //-------------------       Lente 1        -----------------------


                        //      Posicin

            if (tf == labelValZE[1])  
            {
                datosElemento (s1, tf, 1);
            }

                        //      Potencia

            if (tf == labelValHE[1])      
            {
                datosElemento (s1, tf, 1);
                SistemaFL.dist[1] = Math.abs (SistemaFL.valDibPE[1]) +
                                  Math.abs (SistemaFL.valDibPE[2]);
            }

                        //  Empuja las otras lentes si hace falta

            if ((tf == labelValZE[1]) || (tf == labelValHE[1]))
            {
                if (SistemaFL.valZE[2] < SistemaFL.valZE[1] + SistemaFL.dist[1])
                    SistemaFL.valZE[2] = SistemaFL.valZE[1] + SistemaFL.dist[1];
                if (SistemaFL.valZE[3] < SistemaFL.valZE[2] + SistemaFL.dist[2])
                    SistemaFL.valZE[3] = SistemaFL.valZE[2] + SistemaFL.dist[2];
                if (SistemaFL.valZE[4] < SistemaFL.valZE[3] + SistemaFL.dist[3])
                    SistemaFL.valZE[4] = SistemaFL.valZE[3] + SistemaFL.dist[3];
                if (SistemaFL.valZE[5] < SistemaFL.valZE[4] + SistemaFL.dist[4])
                    SistemaFL.valZE[5] = SistemaFL.valZE[4] + SistemaFL.dist[4];
                if (SistemaFL.valZE[6] < SistemaFL.valZE[5] + SistemaFL.dist[5])
                    SistemaFL.valZE[6] = SistemaFL.valZE[5] + SistemaFL.dist[5];

                                //  Corrige los valores de sus correderas
                AnteproyectoFL.sliderValZE[2].setValue ((int) SistemaFL.valZE[2]);
                AnteproyectoFL.sliderValZE[3].setValue ((int) SistemaFL.valZE[3]);
                AnteproyectoFL.sliderValZE[4].setValue ((int) SistemaFL.valZE[4]);
                AnteproyectoFL.sliderValZE[5].setValue ((int) SistemaFL.valZE[5]);
                AnteproyectoFL.sliderValZE[6].setValue ((int) SistemaFL.valZE[6]);

            }


            //-------------------       Lente 2        -----------------------


                        //      Posicin

            if (tf == labelValZE[2])  
            {
                datosElemento (s1, tf, 2);
            }

                        //      Potencia

            if (tf == labelValHE[2])      
            {
                datosElemento (s1, tf, 2);
                SistemaFL.dist[1] = Math.abs (SistemaFL.valDibPE[1]) + Math.abs (SistemaFL.valDibPE[2]);
                SistemaFL.dist[2] = Math.abs (SistemaFL.valDibPE[2]) + Math.abs (SistemaFL.valDibPE[3]);

            }

                        //  Empuja las otras lentes si hace falta

            if ((tf == labelValZE[2]) || (tf == labelValHE[2]))
            {
                if (SistemaFL.valZE[1] > SistemaFL.valZE[2] - SistemaFL.dist[1])
                    SistemaFL.valZE[1] = SistemaFL.valZE[2] - SistemaFL.dist[1];
                if (SistemaFL.valZE[3] < SistemaFL.valZE[2] + SistemaFL.dist[2])
                    SistemaFL.valZE[3] = SistemaFL.valZE[2] + SistemaFL.dist[2];
                if (SistemaFL.valZE[4] < SistemaFL.valZE[3] + SistemaFL.dist[3])
                    SistemaFL.valZE[4] = SistemaFL.valZE[3] + SistemaFL.dist[3];
                if (SistemaFL.valZE[5] < SistemaFL.valZE[4] + SistemaFL.dist[4])
                    SistemaFL.valZE[5] = SistemaFL.valZE[4] + SistemaFL.dist[4];
                if (SistemaFL.valZE[6] < SistemaFL.valZE[5] + SistemaFL.dist[5])
                    SistemaFL.valZE[6] = SistemaFL.valZE[5] + SistemaFL.dist[5];

                                //  Corrige los valores de sus correderas
                AnteproyectoFL.sliderValZE[1].setValue ((int) SistemaFL.valZE[1]);
                AnteproyectoFL.sliderValZE[3].setValue ((int) SistemaFL.valZE[3]);
                AnteproyectoFL.sliderValZE[4].setValue ((int) SistemaFL.valZE[4]);
                AnteproyectoFL.sliderValZE[5].setValue ((int) SistemaFL.valZE[5]);
                AnteproyectoFL.sliderValZE[6].setValue ((int) SistemaFL.valZE[6]);
            }

            //-------------------       Lente 3        -----------------------


                        //      Posicin

            if (tf == labelValZE[3])  
            {
                datosElemento (s1, tf, 3);
            }

                        //      Potencia

            if (tf == labelValHE[3])      
            {
                datosElemento (s1, tf, 3);
                SistemaFL.dist[2] = Math.abs (SistemaFL.valDibPE[2]) + Math.abs (SistemaFL.valDibPE[3]);
                SistemaFL.dist[3] = Math.abs (SistemaFL.valDibPE[3]) + Math.abs (SistemaFL.valDibPE[4]);
            }

                        //  Empuja las otras lentes si hace falta

            if ((tf == labelValZE[3]) || (tf == labelValHE[3]))
            {
                if (SistemaFL.valZE[2] > SistemaFL.valZE[3] - SistemaFL.dist[2])
                    SistemaFL.valZE[2] = SistemaFL.valZE[3] - SistemaFL.dist[2];
                if (SistemaFL.valZE[1] > SistemaFL.valZE[2] - SistemaFL.dist[1])
                    SistemaFL.valZE[1] = SistemaFL.valZE[2] - SistemaFL.dist[1];
                if (SistemaFL.valZE[4] < SistemaFL.valZE[3] + SistemaFL.dist[3])
                    SistemaFL.valZE[4] = SistemaFL.valZE[3] + SistemaFL.dist[3];
                if (SistemaFL.valZE[5] < SistemaFL.valZE[4] + SistemaFL.dist[4])
                    SistemaFL.valZE[5] = SistemaFL.valZE[4] + SistemaFL.dist[4];
                if (SistemaFL.valZE[6] < SistemaFL.valZE[5] + SistemaFL.dist[5])
                    SistemaFL.valZE[6] = SistemaFL.valZE[5] + SistemaFL.dist[5];

                                //  Corrige los valores de sus correderas
                AnteproyectoFL.sliderValZE[1].setValue ((int) SistemaFL.valZE[1]);
                AnteproyectoFL.sliderValZE[2].setValue ((int) SistemaFL.valZE[2]);
                AnteproyectoFL.sliderValZE[4].setValue ((int) SistemaFL.valZE[4]);
                AnteproyectoFL.sliderValZE[5].setValue ((int) SistemaFL.valZE[5]);
                AnteproyectoFL.sliderValZE[6].setValue ((int) SistemaFL.valZE[6]);
            }


            //-------------------       Lente 4        -----------------------

                        //      Posicin

            if (tf == labelValZE[4])  
            {
                datosElemento (s1, tf, 4);
            }

                        //      Potencia

            if (tf == labelValHE[4])      
            {
                datosElemento (s1, tf, 4);
                SistemaFL.dist[3] = Math.abs (SistemaFL.valDibPE[3]) + Math.abs (SistemaFL.valDibPE[4]);
                SistemaFL.dist[4] = Math.abs (SistemaFL.valDibPE[4]) + Math.abs (SistemaFL.valDibPE[5]);
            }

                        //  Empuja las otras lentes si hace falta

            if ((tf == labelValZE[4]) || (tf == labelValHE[4]))
            {
                if (SistemaFL.valZE[3] > SistemaFL.valZE[4] - SistemaFL.dist[3])
                    SistemaFL.valZE[3] = SistemaFL.valZE[4] - SistemaFL.dist[3];
                if (SistemaFL.valZE[2] > SistemaFL.valZE[3] - SistemaFL.dist[2])
                    SistemaFL.valZE[2] = SistemaFL.valZE[3] - SistemaFL.dist[2];
                if (SistemaFL.valZE[1] > SistemaFL.valZE[2] - SistemaFL.dist[1])
                    SistemaFL.valZE[1] = SistemaFL.valZE[2] - SistemaFL.dist[1];
                if (SistemaFL.valZE[5] < SistemaFL.valZE[4] + SistemaFL.dist[4])
                    SistemaFL.valZE[5] = SistemaFL.valZE[4] + SistemaFL.dist[4];
                if (SistemaFL.valZE[6] < SistemaFL.valZE[5] + SistemaFL.dist[5])
                    SistemaFL.valZE[6] = SistemaFL.valZE[5] + SistemaFL.dist[5];

                                //  Corrige los valores de sus correderas
                AnteproyectoFL.sliderValZE[1].setValue ((int) SistemaFL.valZE[1]);
                AnteproyectoFL.sliderValZE[2].setValue ((int) SistemaFL.valZE[2]);
                AnteproyectoFL.sliderValZE[3].setValue ((int) SistemaFL.valZE[3]);
                AnteproyectoFL.sliderValZE[5].setValue ((int) SistemaFL.valZE[5]);
                AnteproyectoFL.sliderValZE[6].setValue ((int) SistemaFL.valZE[6]);
            }

            //-------------------       Lente 5        -----------------------


                        //      Posicin

            if (tf == labelValZE[5])  
            {
                datosElemento (s1, tf, 5);
            }

                        //      Potencia

            if (tf == labelValHE[5])      
            {
                datosElemento (s1, tf, 5);
                SistemaFL.dist[4] = Math.abs (SistemaFL.valDibPE[4]) + Math.abs (SistemaFL.valDibPE[5]);
                SistemaFL.dist[5] = Math.abs (SistemaFL.valDibPE[5]) + Math.abs (SistemaFL.valDibPE[6]);
            }

                        //  Empuja las otras lentes si hace falta

            if ((tf == labelValZE[5]) || (tf == labelValHE[5]))
            {
                if (SistemaFL.valZE[4] > SistemaFL.valZE[5] - SistemaFL.dist[4])
                    SistemaFL.valZE[4] = SistemaFL.valZE[5] - SistemaFL.dist[4];
                if (SistemaFL.valZE[3] > SistemaFL.valZE[4] - SistemaFL.dist[3])
                    SistemaFL.valZE[3] = SistemaFL.valZE[4] - SistemaFL.dist[3];
                if (SistemaFL.valZE[2] > SistemaFL.valZE[3] - SistemaFL.dist[2])
                    SistemaFL.valZE[2] = SistemaFL.valZE[3] - SistemaFL.dist[2];
                if (SistemaFL.valZE[1] > SistemaFL.valZE[2] - SistemaFL.dist[1])
                    SistemaFL.valZE[1] = SistemaFL.valZE[2] - SistemaFL.dist[1];
                if (SistemaFL.valZE[6] < SistemaFL.valZE[5] + SistemaFL.dist[5])
                    SistemaFL.valZE[6] = SistemaFL.valZE[5] + SistemaFL.dist[5];

                                //  Corrige los valores de sus correderas
                AnteproyectoFL.sliderValZE[1].setValue ((int) SistemaFL.valZE[1]);
                AnteproyectoFL.sliderValZE[2].setValue ((int) SistemaFL.valZE[2]);
                AnteproyectoFL.sliderValZE[3].setValue ((int) SistemaFL.valZE[3]);
                AnteproyectoFL.sliderValZE[4].setValue ((int) SistemaFL.valZE[4]);
                AnteproyectoFL.sliderValZE[6].setValue ((int) SistemaFL.valZE[6]);
            }


            //-------------------       Lente 6        -----------------------


                        //      Posicin

            if (tf == labelValZE[6])  
            {
                datosElemento (s1, tf, 6);
            }

                        //      Potencia

            if (tf == labelValHE[6])      
            {
                datosElemento (s1, tf, 6);
                SistemaFL.dist[5] = Math.abs (SistemaFL.valDibPE[5]) + Math.abs (SistemaFL.valDibPE[6]);
            }

                        //  Empuja las otras lentes si hace falta

            if ((tf == labelValZE[6]) || (tf == labelValHE[6]))
            {
                if (SistemaFL.valZE[5] > SistemaFL.valZE[6] - SistemaFL.dist[5])
                    SistemaFL.valZE[5] = SistemaFL.valZE[6] - SistemaFL.dist[5];
                if (SistemaFL.valZE[4] > SistemaFL.valZE[5] - SistemaFL.dist[4])
                    SistemaFL.valZE[4] = SistemaFL.valZE[5] - SistemaFL.dist[4];
                if (SistemaFL.valZE[3] > SistemaFL.valZE[4] - SistemaFL.dist[3])
                    SistemaFL.valZE[3] = SistemaFL.valZE[4] - SistemaFL.dist[3];
                if (SistemaFL.valZE[2] > SistemaFL.valZE[3] - SistemaFL.dist[2])
                    SistemaFL.valZE[2] = SistemaFL.valZE[3] - SistemaFL.dist[2];
                if (SistemaFL.valZE[1] > SistemaFL.valZE[2] - SistemaFL.dist[1])
                    SistemaFL.valZE[1] = SistemaFL.valZE[2] - SistemaFL.dist[1];

                                //  Corrige los valores de sus correderas

                AnteproyectoFL.sliderValZE[1].setValue ((int) SistemaFL.valZE[1]);
                AnteproyectoFL.sliderValZE[2].setValue ((int) SistemaFL.valZE[2]);
                AnteproyectoFL.sliderValZE[3].setValue ((int) SistemaFL.valZE[3]);
                AnteproyectoFL.sliderValZE[4].setValue ((int) SistemaFL.valZE[4]);
                AnteproyectoFL.sliderValZE[5].setValue ((int) SistemaFL.valZE[5]);
            }


                    //      Renueva el dibujo del sistema

                       //       Calcula el sistema

            FuncionesParaxialesFL.tablaElementos ();

            pintarRayos[0] = 0;
            pintarRayos[1] = 0;
            for (i = 1; i < 7; i ++)
            {
                if (SistemaFL.existe[i] != 0) 
                {
                    pintarRayos[0] = 1;
                    pintarRayos[1] = 1;
                    break;
                }
            }


            for (i = 0; i < 2; i ++)
            {
                FuncionesParaxialesFL.tablaTramos (i);
                FuncionesParaxialesFL.marchaParaxial (i);
                FuncionesParaxialesFL.coeficientesRayos (i);
                FuncionesParaxialesFL.interseccionesRayos (i);
            }
            FuncionesParaxialesFL.calculaPupilas ();
            canvasSistema.redraw ();

        }
    }


    //===============   Calcula los datos de un elemento    ===================


    void datosElemento (JSlider s1, JLabel tf, int i)
    {
        double focal;

        if (tf == labelValZE[i])  
        {
            SistemaFL.valZE[i] = (double) s1.getValue ();
            tf.setText (SistemaFL.valZE[i] + " mm");
        }

                    //      Potencia

        if (tf == labelValHE[i])      
        {

            if (SistemaFL.tipoE[i] == 1)          //  Es lente
            {
                SistemaFL.valPE[i] = s1.getValue () / 10.;

                if (SistemaFL.valPE[i] > 0)
                {
                    SistemaFL.valDibPE[i] = SistemaFL.valPE[i] + 8.;
                }
                else
                {
                    SistemaFL.valDibPE[i] = SistemaFL.valPE[i] - 8.;
                }

                tf.setText (SistemaFL.valPE[i] + unidad[i]);
                if (SistemaFL.valPE[i] != 0)
                {
                    focal = (int) (10000. / SistemaFL.valPE[i]) / 10.;
                    labelValFE[i].setText (focal + " mm");
                    sliderValZE[i].setEnabled (true);
                    SistemaFL.existe[i] = 1;

                            //  Calcula los radios como lente simtrica

                    SistemaFL.curv[i] = SistemaFL.valPE[i] / (2. * indice - 2.);
                    if (Math.abs (SistemaFL.curv[i]) <= 1.e-10)
                    {
                        SistemaFL.radio[i] = 1000.e10;
                        SistemaFL.radioDib[i] = 1000.e10;
                    }
                    else
                    {
                        SistemaFL.radio[i] = 2000. * (indice - 1.) / SistemaFL.valPE[i];
                        SistemaFL.radioDib[i] = SistemaFL.radio[i] * SistemaFL.valPE[i] / SistemaFL.valDibPE[i];
                    }

                            //      Calcula el espesor

                    if (SistemaFL.valPE[i] < 0.)
                        SistemaFL.espesor[i] = 5.;
                    else
                        SistemaFL.espesor[i] = SistemaFL.valDibPE[i] * 2.;
                }
                else
                {
                    labelValFE[i].setText ("---");
                    sliderValZE[i].setEnabled (false);
                    SistemaFL.existe[i] = 0;
                }
            }
            else                        //  Es diafragma
            {
                SistemaFL.valDE[i] = (double) s1.getValue ();
                SistemaFL.altura[i] = SistemaFL.valDE[i] / 2.;
                if (SistemaFL.valDE[i] != diamMax)
                {
                    tf.setText (SistemaFL.valDE[i] + unidad[i]);
                    sliderValZE[i].setEnabled (true);
                    SistemaFL.existe[i] = 1;
                    SistemaFL.radio[i] = 1000.e10;
                    SistemaFL.radioDib[i] = 1000.e10;
                }
                else
                {
                    tf.setText ("---");
                    sliderValZE[i].setEnabled (false);
                    SistemaFL.existe[i] = 0;
                }
            }          
        }


    }


    //-------------------------------------------------------------------------

    static public  void datosCorrederaHLente (int i)
    {
                                        //  "setValue" ha de ser lo primero

        sliderValHE[i].setValue ((int) (SistemaFL.valPE[i] * 10.));
        sliderValHE[i].setMinimum (-200);
        sliderValHE[i].setMaximum (200);
        sliderValHE[i].setPaintTicks (true);
        sliderValHE[i].setMajorTickSpacing (100);
        sliderValHE[i].setMinorTickSpacing (20);
        sliderValHE[i].setBounds (190, 130, 280, 30);
    }

    //-------------------------------------------------------------------------

    static public  void datosCorrederaHDiafragma (int i)
    {
                                        //  "setValue" ha de ser lo primero

        sliderValHE[i].setValue ((int) SistemaFL.valDE[i]);
        sliderValHE[i].setMinimum (0);
        sliderValHE[i].setMaximum (diamMax);
        sliderValHE[i].setPaintTicks (true);
        sliderValHE[i].setMajorTickSpacing (10);
        sliderValHE[i].setMinorTickSpacing (2);
        sliderValHE[i].setBounds (190, 130, 280, 30);
    }

}
