/**************************************************************************\
*                                                                          *
*               Panel para dibujar los diagramas de impactos               *
*                           --------------------                           *
*                                                                          *
\**************************************************************************/


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;


//=============================================================================


public class DibujoDiagramasFC extends Canvas
{


                //  Para los diagramas de impactos

    static    int  xc = 45;
    static    int  yc = 45;
    static    int  iD[][][] = new int[2][91][91];     //  Matriz para los diagramas

                //  Para las funciones de mrito

    static  double fiEje, fiCampo;




    //--------------------  Funcin para dibujar    ---------------------------

    public void paint (Graphics gr)
    {


                        //  Traza una lnea de separacin

//        gr.setColor (Color.green);
       gr.setColor (Color.yellow);

        gr.drawLine (0, 0, 0, 189);
        gr.drawRect (0, 189, 379, 0);
        gr.drawLine (379, 189, 379, 0);
        gr.drawLine (189, 189, 189, 0);

                        //  Si no hay objeto definido no dibuja nada ms

        if (SistemaFC.existeObjeto[0] == 0) 
            return;

        if (ExactoFC.dibuja == 0)
            return;                   

        dibujaDiagramas (gr);

    }


    //===============     Dibujo de los diagramas de impactos   ===============


    void dibujaDiagramas (Graphics gr)
    {
        int     i, j, k, obj, h, zd, xi, yi, xd, yd;

        double  zi, xf, yf, ypr[] = new double[2];
        Color cian = new Color (0, 255, 255);
        Color azulClaro = new Color (100, 100, 255);

        Color   col[] = {Color.black, Color.green, azulClaro, Color.red, 
                         cian, Color.yellow, Color.magenta, Color.white};

        int numRayos = ExactoFC.numRayos; 
        int numColores = ExactoFC.numColores;
        int numSup = FuncionesExactasFC.numSup;

                        //  Para las funciones de mrito

        int     numSumandos = numRayos * numColores;
        double  r2;
        double  suma;
        double  fMerito[] = new double[2];
        double  epsilon = .03;


                        //  Posicin del plano de imagen

        zi = FuncionesExactasFC.imagParax + ExactoFC.valZImag;


                        //  Dibuja los diagramas de impactos

                            //  Borra la matriz

        for (obj = 0; obj < 2; obj ++)
            for (i = 0; i < 91; i++)
                for (j = 0; j < 91; j++)
                    iD[obj][i][j] = 0;


                            //  Clculo de la matriz

        for (obj = 0; obj < 2; obj ++)
        {
            suma = 0.;
                                   
            for (k = 0; k < numColores; k ++)
            {                      

                ypr[obj] = FuncionesExactasFC.cRayo[obj][k][numSup+1][0] * zi + 
                        FuncionesExactasFC.dRayo[obj][k][numSup+1][0];

                for (j = 0; j < numRayos; j ++)
                {
                    if (FuncionesExactasFC.pasa[obj][k][numSup][j] == 0) 
                        continue;

                    xf = FuncionesExactasFC.aRayo[obj][k][numSup+1][j] * zi + 
                        FuncionesExactasFC.bRayo[obj][k][numSup+1][j];
                    xi = (int) (90 * xf / ExactoFC.escala);
    
        
                    yf = FuncionesExactasFC.cRayo[obj][k][numSup+1][j] * zi + 
                        FuncionesExactasFC.dRayo[obj][k][numSup+1][j] - ypr[obj];
                    yi = - (int) (90 * yf / ExactoFC.escala);
    
                    r2 = xf * xf + yf * yf;
                    suma = suma + epsilon / (epsilon + r2);

    
                    if (xi < -xc || xi > xc || yi < -yc || yi > yc)
                        continue;
        
                    xd = xc + xi;
                    yd = yc + yi;

                    if (numColores == 1)
                    {
                        iD[obj][xd][yd] = 1;
                    }
    
                    if (numColores == 3)
                    {
                        if (k == 0)     //  Rayos verdes
                        {
                            iD[obj][xd][yd] = 1;
                        }

                        if (k == 1)     //  Rayos azules
                        {
                            if (iD[obj][xd][yd] == 0)
                                iD[obj][xd][yd] = 2;
                            if (iD[obj][xd][yd] == 1)
                                iD[obj][xd][yd] = 4;
                        }

                        if (k == 2)     //  Rayos rojos
                        {
                            if (iD[obj][xd][yd] == 0)
                                iD[obj][xd][yd] = 3;
                            if (iD[obj][xd][yd] == 1)
                                iD[obj][xd][yd] = 5;
                            if (iD[obj][xd][yd] == 2)
                                iD[obj][xd][yd] = 6;
                            if (iD[obj][xd][yd] == 4)
                                iD[obj][xd][yd] = 7;
                        }
                    }
    
                    iD[obj][xc-xi][yd] = iD[obj][xd][yd];
    
                }
            }

            fMerito[obj] = (int) (1000. * suma / numSumandos) / 10.;

            ExactoFC.labelValMerito[obj].setText (fMerito[obj] + " %");


                        //  Dibuja la matriz

            for (i = 1; i < 180; i += 2)
            {
                for (j = 1; j < 180; j += 2)
                {
                    gr.setColor (col[iD[obj][i/2][j/2]]);
                    gr.drawRect (i+obj*190, j, 2, 2);
                }
            }
        }

    }

    //=========================================================================
                                                          
    public void redraw ()
    {
        repaint ();
    }
}

                                                                                                                                                                
