/**************************************************************************\
*                                                                          *
*                       Panel para dibujar el sistema                      *
*                           --------------------                           *
*                                                                          *
*       Se deforma el dibujo para que se vean mejor las lentes:            *
*       Se dibujan las dimensiones horizontales a escala 1/2.              *
*       Las verticales a escala 4/1.                                       *
*       El radio de curvatura a escala 12/1.                               *
*                                                                          *
\**************************************************************************/


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;


//=============================================================================


public class DibujoSistemaFC extends Canvas
{
    int     eje = 105;


    public void paint (Graphics graphics)
    {

        int     i, j, k, n, ia, ip, i1, i2, z, y, w, z1, z2, h, y1, y2, obj;
        double  radioDib, zv, altura;
        Color naranja = new Color (255, 128, 0);
        int     NULente = AnteproyectoFC.numUltimaLente;
        int     NUElemento = AnteproyectoFC.numUltimoElemento;
        float[] trama = { 4.f, 4.f }; 
        BasicStroke  trazos, continuo;
           

        trazos = new BasicStroke (1, BasicStroke.CAP_ROUND,
                    BasicStroke.JOIN_MITER, 1.f, trama, 0.f);
        continuo = new BasicStroke (1);

                        //  Utiliza las funciones de Graphics2D
     
        Graphics2D gr = (Graphics2D) graphics;

                        //  Dibuja las lentes y diafragmas

        dibujaElementos (gr);

                    //  Dibuja los rayos
                        //  Tramos entre las lentes
  
        for (obj = 0; obj < 2; obj ++)
        {
            n = AnteproyectoFC.numTramos[obj];
            if (n < 2)
                break;

            if (SistemaFC.existeObjeto[obj] == 0)
                continue;

            for (j = 0; j < 22; j ++)
            {
                if ((SistemaFC.valYObj[obj] == 0.) && (j > 10))
                    break;

                if ((obj == 0) && (j == 0))
                    gr.setColor (Color.green);
           
                if ((obj == 0) && (j == 11))
                    gr.setColor (Color.cyan);
           
                if ((obj == 1) && (j == 0))
                    gr.setColor (Color.yellow);
           
                if ((obj == 1) && (j == 11))
                    gr.setColor (naranja);
           
           
                        //  Cada tramo va del elemnto k al k+1
           
                for (k = 0; k < n; k ++)
                {

                    i = AnteproyectoFC.tramo[obj][k];    //  Extremo izquierdo del tramo
           
                    ip = AnteproyectoFC.tramo[obj][k+1]; //  Extremo derecho del tramo
           
           
                    if (i == 0)
                    {
                                //  Tramo del objeto al elemento 1
           
                                //  Objeto lejano o virtual
           
                        if ((SistemaFC.zObjeto[obj] < 0) ||
                            (SistemaFC.real[obj] == 0) ||
                            (SistemaFC.zObjeto[obj] >= 1.e10))

                        {
                            z1 = 0;
                            y1 = eje - (int) (AnteproyectoFC.bpRayo[obj][0][j] * 2.);
                        }
                        else
                                //  Objeto real prximo
                        {
                            z1 = (int) (SistemaFC.zObjeto[obj] / 2.);
                            if (j <= 10)
                                y1 = eje;
                            else
                                y1 = eje - (int) (SistemaFC.valYObj[obj] * 2.);
                        }
           
                    }
           
                                //  Restantes tramos
           
                    else
                    {
                        if (AnteproyectoFC.pasa[obj][i][j] == 0)
                            break;
           
                        z1 = (int) (AnteproyectoFC.zpRayo[obj][i][j] / 2.);
                        y1 = eje - (int) (AnteproyectoFC.ypRayo[obj][i][j] * 2.);
                    }
           
           
                            //  Interseccin con la superficie de entrada siguiente
           
                    z2 = (int) (AnteproyectoFC.zaRayo[obj][ip][j] / 2.);
                    y2 = eje - (int) (AnteproyectoFC.yaRayo[obj][ip][j] * 2.);
           
                    gr.drawLine (z1, y1, z2, y2);
           
                }
            }

                            //  Si el objeto es virtual dibuja el objeto y los
                            //  rayos entre la 1 superficie y el objeto

            ip = AnteproyectoFC.tramo[obj][1];  //  Extremo derecho del tramo

            if ((AnteproyectoFC.verObjetoVirtual == 1) && SistemaFC.real[obj] == 0
                       && obj == 0 && SistemaFC.existeObjeto[1] == 0 
                       && SistemaFC.zObjeto[0] > AnteproyectoFC.zaRayo[obj][ip][0])
            {
                gr.setStroke (trazos);          //  Pone lnea de trazos

                z2 = (int) (SistemaFC.zObjeto[obj] / 2.);
                y2 = eje - (int) (SistemaFC.valYObj[obj] * 2.);

                gr.setColor (new Color (0, 100, 255));

                                                //  Dibuja el objeto
                gr.drawLine (z2, eje, z2, y2); 


                ip = AnteproyectoFC.tramo[obj][1];  //  Extremo derecho del tramo

                                                //  Dibuja los rayos de eje
                gr.setColor (Color.green);
                for (j = 0; j < 11; j ++)
                {
                    z1 = (int) (AnteproyectoFC.zaRayo[obj][ip][j] / 2.);
                    y1 = eje - (int) (AnteproyectoFC.yaRayo[obj][ip][j] * 2.);
                    gr.drawLine (z1, y1, z2, eje);
                }

                                                //  Dibuja los rayos de campo

                if (SistemaFC.campo[0] != 0.)
                {
                    gr.setColor (Color.cyan);
                    for (j = 11; j < 22; j ++)
                    {
                        z1 = (int) (AnteproyectoFC.zaRayo[obj][ip][j] / 2.);
                        y1 = eje - (int) (AnteproyectoFC.yaRayo[obj][ip][j] * 2.);
                        gr.drawLine (z1, y1, z2, y2);
                    }
                }

                gr.setStroke (continuo);        //  Pone lnea continua
            }
           
                            //  Dibuja las imgenes
                              
            if (obj == 0)
                gr.setColor (new Color (0, 100, 255));
            else
               gr.setColor (Color.magenta);

           
            for (k = 0; k < n; k ++)
            {
                i = AnteproyectoFC.tramo[obj][k];     //  Extremo izquierdo del tramo
                ip = AnteproyectoFC.tramo[obj][k+1];  //  Extremo derecho del tramo
                z1 = (int) (AnteproyectoFC.zImag[obj][i] / 2.);
                y1 = eje - (int) (AnteproyectoFC.yImag[obj][i] * 2.);

                if ((AnteproyectoFC.zImag[obj][i] > SistemaFC.valZE[i]) &&
                    (AnteproyectoFC.zImag[obj][i] < SistemaFC.valZE[ip]))
                {
                    gr.drawLine (z1, eje, z1, y1);
                }

                                    //  Caso de imagen virtual

                if ((AnteproyectoFC.verImagenVirtual == 1) && (k == n-1) &&
                   (obj == 0) && (SistemaFC.existeObjeto[1] == 0) &&
                   (AnteproyectoFC.zImag[obj][NUElemento] < SistemaFC.valZE[NULente]))
                {
                    gr.setStroke (trazos);          //  Pone lnea de trazos

                    gr.drawLine (z1, eje, z1, y1);  //  Dibuja la imagen

                                        //      Dibuja los rayos de eje

                    gr.setColor (Color.green);

                    for (j = 0; j < 11; j ++)
                    {
                        if (AnteproyectoFC.pasa[obj][NULente][j] == 0)
                            continue;
                        z2 = (int) (AnteproyectoFC.zpRayo[obj][NULente][j] / 2.);
                        y2 = eje - (int) (AnteproyectoFC.ypRayo[obj][NULente][j] * 2.);
                        gr.drawLine (z1, eje, z2, y2);
                    }

                                        //      Dibuja los rayos de campo

                    if (SistemaFC.campo[0] != 0.)
                    {
                        gr.setColor (Color.cyan);
    
                        for (j = 11; j < 22; j ++)
                        {
                            if (AnteproyectoFC.pasa[obj][NULente][j] == 0)
                                continue;
                            z2 = (int) (AnteproyectoFC.zpRayo[obj][NULente][j] / 2.);
                            y2 = eje - 
                                 (int) (AnteproyectoFC.ypRayo[obj][NULente][j] * 2.);
                            gr.drawLine (z1, y1, z2, y2);
                        }
                    }

                    gr.setStroke (continuo);          //  Pone lnea continua
                    gr.setColor (new Color (0, 100, 255));
                }
            }
        }

        //  Si est definido el objeto 1 pero no el 2, dibuja diafragma y pupilas

        if (SistemaFC.existeObjeto[0] == 0)
            return;
        if (SistemaFC.existeObjeto[1] == 1)
            return;

                            //  Escribe la leyenda del diafragma de abertura

        gr.setColor (Color.white);
        int zDA = (int) (SistemaFC.valZE[AnteproyectoFC.numDiafragma] / 2.);
        gr.drawString ("D.A.", zDA-10, eje-75);

                            //  Dibuja las pupilas

        int     rad;
        gr.setColor (Color.magenta);

                                //  Pupila de entrada

        int zPE = (int) (AnteproyectoFC.zPE / 2.) - 1;
        rad = (int) AnteproyectoFC.DPE;

        if (rad < 100)
        {
            gr.drawLine (zPE, eje + rad, zPE, eje + 100);
            gr.drawLine (zPE, eje - rad, zPE, eje - 90);
        }
        gr.drawString ("P.E.", zPE-10, eje-90);

                                //  Pupila de salida

        int zPS = (int) (AnteproyectoFC.zPS / 2.) + 1;
        rad = (int) AnteproyectoFC.DPS;

        if (rad < 100)
        {
            gr.drawLine (zPS, eje + rad, zPS, eje + 90);
            gr.drawLine (zPS, eje - rad, zPS, eje - 100);
        }
        gr.drawString ("P.S.", zPS-10, eje+100);

    }



    //===============     Dibujo de lentes y diafragmas  ======================


    void dibujaElementos (Graphics gr)
    {
        int     i, n, y, z1, z2;
        double  d, z, ze1, ze2, zb1, zb2;
        double  radioDib, altura;

  //      gr.setColor (Color.yellow);
        gr.setColor (Color.white);



        for (i = 1; i < 7; i ++)
        {
            if (SistemaFC.tipoE[i] == 1)             //  Es una lente
            {
                if (SistemaFC.valPE[i] != 0.)        //  Existe
                {
                    radioDib = SistemaFC.radioDib[i]; 
                    altura = AnteproyectoFC.diamMax / 2.;

                    z = SistemaFC.valZE[i];
                    d = SistemaFC.espesor[i];
                    ze1 = z - d / 2.;
                    ze2 = z + d / 2.;
                    zb1 = ze1 + SistemaFC.valDibPE[i];
                    zb2 = ze2 - SistemaFC.valDibPE[i];

                                    //  Dibuja la superficie anterior

                    dibujaSuperficie (gr, ze1, radioDib, altura);
    
                                    //  Dibuja la superficie posterior

                    dibujaSuperficie (gr, ze2, -radioDib, altura);

                                    //  Si es divergente dibuja los bordes

                    if (SistemaFC.valPE[i] < 0.)        
                    {
                        z1 = (int) (zb1 / 2.);
                        z2 = (int) (zb2 / 2.);

                        y = eje - (int) altura * 2 - 4;
                        gr.drawLine (z1, y, z2, y);

                        y = eje + (int) altura * 2 + 4;
                        gr.drawLine (z1, y, z2, y);
                    }

                }

            }
            else                                        //  Es diafragma
            {
                if (SistemaFC.valDE[i] != AnteproyectoFC.diamMax)  //  Existe
                {
                    z = SistemaFC.valZE[i];
                    altura = SistemaFC.valDE[i] / 2.;
                    dibujaDiafragma (gr, z, altura);
                }
            }
        }
    }


    //===============     Dibujo de una superficie       ======================

    void dibujaSuperficie (Graphics gr, double xv, double radio, double altura)
    {

        int  x, y, ancho, h;
        double  xvDib, alturaDib, radioDib;
        double  zeta, alfa1, alfa2, xc;

        //  Se reducen las dimensiones horizontales a la mitad.
        //  Las verticales se multiplican por 2.
        //  El radio se multiplica por 6,

        xvDib = xv / 2.;
        alturaDib = altura * 2. + 4.;
        radioDib = radio * 6.;
        xc = xvDib + radioDib;

        x = (int) xvDib;

                                    //  Es superficie plana
        if (radio >= 1.e10)
        {
            h = (int) (alturaDib);
            gr.drawLine (x, eje - h, x, eje + h);
            return;
        }

                                    //  Es superficie curva
        zeta = Math.asin (alturaDib / radioDib);

        if (radioDib > 0)
        {
            alfa1 = 3.141592 - zeta;
            alfa2 = alfa1 + 2. * zeta;
        }

        else
        {
            alfa1 = zeta;
            alfa2 = alfa1 - 2. * zeta;
        }
 

        dibujaArco (gr, xc, radioDib, alfa1, alfa2);

        return;
    }


    //===============     Dibujo de un arco              ======================

    void dibujaArco (Graphics gr, double xc, double radio,
                      double alfa1, double alfa2)

                //  Los ngulos estn en radianes
    {
        int     i, n;
        int     x[] = new int[1000];
        int     y[] = new int[1000];
        double  alfa, delta;

        delta = 2. / Math.abs (radio);

        for (i = 0, n = 0, alfa = alfa1; alfa <= alfa2 && i < 1000;
                          i ++, alfa += delta)
        {
            if (radio > 0)
                x[i] = (int) (xc + radio * Math.cos (alfa));
            else
                x[i] = (int) (xc - radio * Math.cos (alfa));
            y[i] = eje - (int) (radio * Math.sin (alfa));
        }

        n = i;

        for (i = 1; i < n; i ++)
        {
            gr.drawLine (x[i-1], y[i-1], x[i], y[i]);
        }
    }



    //===============     Dibujo de un diafragma         ======================

    void dibujaDiafragma (Graphics gr, double xv, double altura)
    {
        int  x, r;

        x = (int) (xv / 2.);
        r = (int) (altura * 2.);
        gr.drawLine (x, eje - 73, x, eje - r);
        gr.drawLine (x, eje + 73, x, eje + r);
    }


    //=========================================================================
                                                          
    public void redraw ()
    {
        repaint ();
    }

}
