/**************************************************************************\
*                                                                          *
*                              ExactoFL                                    *
*                                                                          *
\**************************************************************************/



import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.accessibility.*;



class ExactoFL extends JFrame implements   ActionListener
{
    static int lang = SistemaFL.lang;

    //========     Bloque con todos los textos de este fichero  ===============

    static String text[][] =
    {
        { "MARXA EXACTA", "MARCHA EXACTA", "EXACT RAY TRACING" },
        { "Objecte", "Objeto", "Object" },
        { "Lents i diafragmes", "Lentes y diafragmas", "Lenses and stops" },
        { "Imatge", "Imagen", "Image" },
        { "Men principal", "Men principal", "Main menu" },
        { "Eix", "Eje", "Axis" },
        { "Costat", "Lado", "Side" },
        { "Posici", "Posicin", "Position" },
        { "Semicamp", "Semicampo", "Half field" },
        { "Radis", "Radios", "Radii" },
        { "Element", "Elemento", "Element" },
        { "Lent", "Lente", "Lens" },
        { "Diafragma", "Diafragma", "Stop" },
        { "Dimetre", "Dimetro", "Diameter" },
        { "Potncia", "Potencia", "Power" },
        { "Focal", "Focal", "Focal" },
        { "Infinit", "Infinito", "Infinite" },
        { "Distncia des del pla paraxial", "Distancia desde el plano paraxial", "Distance from the paraxial plane" },
        { "Escala", "Escala", "Scale" },
        { "Index", "Indice", "Index" },
        { "Abbe", "Abbe", "Abbe" },
        { "Monocromtica", "Monocromtica", "Monochromatic" } ,
        { "Color", "Color", "Color" },
        { "Posici de la imatge paraxial", "Posicin de la imagen paraxial", "Paraxial image position" },
        { "F. de mrit en eix", "F. de Mrito en eje", "On-axis Merit F." },
        { "F. de mrit en camp", "F. de Mrito en campo", "Off-axis Merit F." }
    } ;

    //===========================================================================

    static ExactoFL   exacto;

    static Color    grisAzulado = new Color (102, 102, 153);
    static double   lado = 1.;


                        //      Paneles para la marcha exacta

    static JPanel   panelBase, panelObj, panelImag, panelMerito;
    static JPanel   panelE[] = new JPanel[7];
    static JPanel   panelVE[] = new JPanel[7];
    static JPanel   panelDiagramas;

                        //      Paneles para dibujar

    static  DibujoExactoFL        canvasExactoFL;
    static  DibujoDiagramasFL     canvasDiagramas;


                                        //  Botones del men

    static JButton  buttonMP;
    static JButton  buttonObj;
    static JButton  buttonImag;
    static JButton  buttonE[] = new JButton[7];
    static String   nomBoton[] = new String[7];

                                        //  Leyendas para el objeto 

    static JLabel   labelObj;           
    static JLabel   labelZObj;         
    static JLabel   labelHObj;         
    static JLabel   labelValZObj;      
    static JLabel   labelValHObj;

                                        //  Botones "radio" para los objetos.

    static JRadioButton  buttonR;
    static JRadioButton  buttonV;
    static ButtonGroup   grupoO;

                                        //  Correderas para el objeto 

    static JSlider  sliderValZObj;      
    static ChangeListener listenerValZObj;
    static JLabel   valPosObj[] = new JLabel[5];
    static String   leyendaPosObj[] = { "-1600", "-800", "0", "800", "1600" };

    static ChangeListener listenerValHObj;
    static JSlider  sliderValHObj;
    static JLabel   valCampo[] = new JLabel[5];
    static String   leyendaCampo[] = { "0", "5", "10", "15", "20" };

                                        //  Leyendas para la imagen 

    static JLabel   labelImag;           
    static JLabel   labelZImag;         
    static JLabel   labelZParax;         
    static JLabel   labelHImag;         
    static JLabel   labelValZImag;      
    static JLabel   labelValZParax;      
    static JLabel   labelValHImag;

                                        //  Botones "radio" para la imagen.

    static JRadioButton  buttonMono;
    static JRadioButton  buttonColor;
    static ButtonGroup   grupo1;

                                        //  Correderas para la imagen

    static JSlider  sliderValZImag;      
    static JSlider  sliderValHImag;
    static ChangeListener listenerValZImag;
    static ChangeListener listenerValHImag;
    static JLabel   valPosImag[] = new JLabel[5];
    static String   leyendaPosImag[] = { "-100", "-50", "0", "50", "100" };

                                        //  Leyendas para los diagramas

    static JLabel   labelDiagramas1;
    static JLabel   labelDiagramas2;
    static JLabel   labelDiagramas3;
                                        //  Para las funciones de mrito

    static JLabel   labelMerito[] = new JLabel[2];
    static JLabel   labelValMerito[] = new JLabel[2];


                                        //  Botones "radio" para lentes y diaf.

    static JRadioButton  buttonL[] = new JRadioButton[7];
    static JRadioButton  buttonD[] = new JRadioButton[7];
    static ButtonGroup   grupo[] = new ButtonGroup[7];
 
                                        //  Leyendas para lentes y diafragmas

    static JLabel   labelE[] = new JLabel[7];        //     "Elemento"
    static JLabel   labelZE[] = new JLabel[7];       //     "Posicin"
    static JLabel   labelHE[] = new JLabel[7];       //     "Dimetro"
    static JLabel   labelFE[] = new JLabel[7];       //     "Focal"
    static JLabel   labelBE[] = new JLabel[7];       //     "Doblado"
    static JLabel   labelValZE[] = new JLabel[7];    //     Valor de la posicin
    static JLabel   labelValHE[] = new JLabel[7];    //     Valor del dimetro 
    static JLabel   labelValFE[] = new JLabel[7];    //     Valor de la focal
    static JLabel   labelValBE[] = new JLabel[7];    //     Valor del doblado
    static JLabel   labelValR1E[] = new JLabel[7];   //     Valor del radio 1
    static JLabel   labelValR2E[] = new JLabel[7];   //     Valor del radio 2

    static JLabel   labelNE[] = new JLabel[7];       //     "Indice"
    static JLabel   labelAE[] = new JLabel[7];       //     "N de Abbe"
    static JLabel   labelValNE[] = new JLabel[7];    //     Valor del ndice
    static JLabel   labelValAE[] = new JLabel[7];    //     Valor del n de Abbe

                                        //  Correderas para lentes y diafragmas

    static JSlider  sliderValZE[] = new JSlider[7]; 
    static JSlider  sliderValHE[] = new JSlider[7];
    static JSlider  sliderValFE[] = new JSlider[7];
    static JSlider  sliderValBE[] = new JSlider[7];
    static ChangeListener listenerValZE[] = new ChangeListener[7];
    static ChangeListener listenerValHE[] = new ChangeListener[7];
    static ChangeListener listenerValFE[] = new ChangeListener[7];
    static ChangeListener listenerValBE[] = new ChangeListener[7];
    static JLabel valPos[][] = new JLabel[7][5];
    static JLabel valPot[][] = new JLabel[7][5];
    static JLabel valDiam[][] = new JLabel[7][4];
    static String leyendaPos[] = { "0", "400", "800", "1200", "1600" };
    static String leyendaPot[] = { "-20", "-10", "0", "10", "20" };
    static String leyendaDiam[] = { "0", "20", "40", "60" };

    static JSlider  sliderValNE[] = new JSlider[7]; 
    static JSlider  sliderValAE[] = new JSlider[7]; 
    static ChangeListener listenerValNE[] = new ChangeListener[7];
    static ChangeListener listenerValAE[] = new ChangeListener[7];

    static String  texto1, texto2;
    static String  unidad[] = new String[7];

                //  Datos del sistema

    static int     numLentes = 0;
    static int     numSup = 0;
    static int     nir = 10;
    static int     nia = 20;

                //  Tabla de los elementos que existen

    static  int     elemento[] = new int[8];
    static  int     numElementos;

                //  Tabla de los tramos de rayos

    static  int     tramo[][] = new int[2][8];
    static  int     numTramos[] = new int[2];

                //  Datos de la imagen

    static  int     numColores = 1;
    static  double  valZParax = 0.;
    static  double  valZImag = 0.;
    static  double  escala = 1.;


                //  Datos de los elementos (lentes o diafragmas)

                    //  El subndice 0 corresponde al objeto
                    //  El subndice 7 corresponde al borde derecho del cuadro

    static double espesor[] = new double[8];
    static double valBE[] = new double[8];    //  Doblado
    static double curv1[] = new double[8];    //  Curvatura 1 (exacto)
    static double curv2[] = new double[8];    //  Curvatura 2 (exacto)
    static double radio1[] = new double[8];   //  Radio de curvatura 1 (exacto)
    static double radio2[] = new double[8];   //  Radio de curvatura 2 (exacto)
    static double radioDib1[] = new double[8]; //  Radio de curvatura 1 para dibujo
    static double radioDib2[] = new double[8]; //  Radio de curvatura 2 para dibujo
    static double valDib1PE[] = new double[8]; //  Potencia adaptada al dibujo (exac.)
    static double valDib2PE[] = new double[8]; //  Potencia adaptada al dibujo (exac.
    static double dze1[] = new double[8];     //  Delta z de vrtice de 1 sup.
    static double dze2[] = new double[8];     //  Delta z de vrtice de 2 sup.
    static double dzb1[] = new double[8];     //  Delta z de borde de 1 sup.
    static double dzb2[] = new double[8];     //  Delta z de borde de 2 sup.
    static double diste[] = new double[8];    //  Distancia entre los elementos 
    static double distb[] = new double[8];    //  "i" e "i+1" en eje y borde


                                        //  Dimetro mximo para los diafragmas 

    static int      diamMax = AnteproyectoFL.diamMax;   


                                        //  Datos para la pupila

    static int      numRayos;                   //  N total de rayos
    static double   xpr[] = new double[140];    //  Coordenadas relativas para
    static double   ypr[] = new double[140];    //  el diagrama de impactos
    static double   hpr[] = new double[21];     //  Coordenadas relativas slo en 
                                                //  el plano zy


                                        //  Datos de los vidrios

    static double   indiceDib = 1.5;    //  Indice de refraccin (Anteproyecto)
    static double   indice[] = new double[7];  //  Indice de refraccin (ExactoFL)
    static double   abbe[] = new double[7];    //  Nmero de Abbe

    static int      pintarRayos[] = {0, 0};    //  Control para el dibujo


    int     cuadro;

                                //  Variables auxiliares
    static int  dibuja = 0;
    static int  calcula = 0;
    int     i;

    static int copiar;


    //======================    Abre la funcin     ===========================

    static public void abrir ()
    {
        int     i, j;


        SistemaFL.panelBase.add (panelBase);
        SistemaFL.panelBase.add (canvasExactoFL);
        SistemaFL.panelBase.add (canvasDiagramas);
        SistemaFL.panelBase.add (panelDiagramas);


                    //  Datos del objeto 1

        if (SistemaFL.valZObj[0] == -1600)
                                            //  No existe el objeto
        {
            SistemaFL.existeObjeto[0] = 0;
            labelValZObj.setText ("----");

                            //  Desactiva la corredera de campo y las leyendas
            sliderValHObj.setEnabled (false);
            for (j = 0; j < 5; j ++)
            {
                valCampo[j].setVisible (false);
            }
        }
        else
        {                                   //  Existe el objeto
            SistemaFL.existeObjeto[0] = 1;

                            //  Activa la corredera de campo y las leyendas
            sliderValHObj.setEnabled (true);
            for (j = 0; j < 5; j ++)
            {
                valCampo[j].setVisible (true);
            }
           
            if (SistemaFL.valZObj[0] <= -1500 || SistemaFL.valZObj[0] >= 1600)
                                                //  Objeto en el infinito
            {
                labelValZObj.setText (text[13][lang]);
                SistemaFL.zObjeto[0] = -1.E10;
            }
            else
                                                //  Objeto a distancia finita
            {
                labelValZObj.setText (SistemaFL.valZObj[0] + " mm");
                SistemaFL.zObjeto[0] = SistemaFL.valZObj[0];
            }
        }

        //------------  Paneles para los objetos    ---------------------------

                                    //  Botones "radio"

        if (SistemaFL.real[0] == 1)
            buttonR.setSelected (true);
        else
            buttonV.setSelected (true);

        labelValHObj.setText (SistemaFL.campo[0] + "");

/*
        if (SistemaFL.existeObjeto[0] == 1 && SistemaFL.infinito[0] == 1)
        {
            sliderValZObj.setValue ((int) SistemaFL.valZObj[0]);
            SistemaFL.valZObj[0] = -1.E10;
            SistemaFL.existeObjeto[0] = 1;
        }
        else
            sliderValZObj.setValue ((int) SistemaFL.valZObj[0]);
*/        
        
        sliderValZObj.setValue ((int) SistemaFL.valZObj[0]);
        sliderValHObj.setValue ((int) (SistemaFL.campo[0] * 10.));


                        //   Panel para la imagen    
    
        if (numColores == 1)
            buttonMono.setSelected (true);
        else
            buttonColor.setSelected (true);


        labelValZImag.setText (valZImag + " mm");
        labelValHImag.setText (escala + " mm");
        sliderValZImag.setValue ((int) valZImag);
        sliderValHImag.setValue ((int) (escala * 100.));
    

                        //      Paneles para lentes y diafragmas   

                                //  Paneles de cada elemento

        for (i = 1; i < 7; i ++)
        {
                                //  Elementos del panel
    
                                    //  Botones "radio"

            if (SistemaFL.tipoE[i] == 1)
                buttonL[i].setSelected (true);
            else
                buttonD[i].setSelected (true);

                                    //  Valor de la posicin

            labelValZE[i].setText (SistemaFL.valZE[i] + " mm");
    
                                    //  Corredera para la posicin
    
            sliderValZE[i].setValue ((int) SistemaFL.valZE[i]);


            if (SistemaFL.tipoE[i] == 1)           //     Es lente
            {

                                //  Ttulo "Potencia"

                unidad[i] = " diop";
                labelHE[i].setText (text[14][lang]);
            
                                //  Focal
            
                labelFE[i].setText (text[15][lang]);

                                //  Doblado

                labelBE[i].setText (text[9][lang]);
                panelE[i].add (sliderValBE[i]);
      
    
                                //  Activa las leyendas de la posicin

                for (j = 0; j < 5; j ++)
                {
                    valPos[i][j].setVisible (true);
                }
                                //  Borra las leyendas del dimetro

                for (j = 0; j < 4; j ++)
                {
                    valDiam[i][j].setVisible (false);
                }

                                //  Activa las leyendas de la potencia

                for (j = 0; j < 5; j ++)
                {
                    valPot[i][j].setVisible (true);
                }

                                //  Corredera para la potencia

                datosCorrederaHLente (i);

                                //  Activa o no las correderas de posicin
                                //  doblado, ndice y n de Abbe

                if (SistemaFL.valPE[i] != 0.)
                {
                    sliderValZE[i].setEnabled (true);
                    sliderValBE[i].setEnabled (true);

                    sliderValNE[i].setEnabled (true);
                    sliderValAE[i].setEnabled (true);
                    labelValNE[i].setText (indice[i] + "");
                    labelValAE[i].setText (abbe[i] + "");
                    sliderValNE[i].setValue ((int) (indice[i] * 100.));
                    sliderValAE[i].setValue ((int) (abbe[i] * 10.));
                }
                else
                {
                    sliderValZE[i].setEnabled (false);
                    sliderValBE[i].setEnabled (false);

                    sliderValNE[i].setEnabled (false);
                    sliderValAE[i].setEnabled (false);
                    labelValNE[i].setText ("---");
                    labelValAE[i].setText ("---");
                    sliderValNE[i].setValue (160);
                    sliderValAE[i].setValue (500);
                }
            }

            else           //  Es diafragma

            {
                labelHE[i].setText (text[13][lang]);
                unidad[i] = " mm";

                                                //  Borra la focal si no es lente
                labelFE[i].setText (" ");
                labelValFE[i].setText (" ");
                                                //  Borra el doblado
                labelBE[i].setText (" ");
                labelValR1E[i].setText (" ");
                labelValR2E[i].setText (" ");
                panelE[i].remove (sliderValBE[i]);

                                                //  Borra el ndice
                labelNE[i].setText (" ");
                labelValNE[i].setText (" ");
                panelVE[i].remove (sliderValNE[i]);

                                                //  Borra el n de Abbe
                labelAE[i].setText (" ");
                labelValAE[i].setText (" ");
                panelVE[i].remove (sliderValAE[i]);



                if (SistemaFL.valDE[i] != diamMax)
                {
                    labelValHE[i].setText (SistemaFL.valDE[i] + " mm");
                }
                else
                {
                    labelValHE[i].setText ("---");
                }

                            //  Borra las leyendas de la potencia

                for (j = 0; j < 5; j ++)
                {
                    valPot[i][j].setVisible (false);
                }

                                //  Activa las leyendas del dimetro

                for (j = 0; j < 4; j ++)
                {
                    valDiam[i][j].setVisible (true);
                }

                                //  Corredera para el dimetro

                datosCorrederaHDiafragma (i);

                if (SistemaFL.valDE[i] != diamMax)
                {
                    sliderValZE[i].setEnabled (true);
                }
                else
                {
                    sliderValZE[i].setEnabled (false);
                }

            }
        }

        //-------------     Prepara los puntos de la pupila  -----------------

        int     k, ll, niaj, iw = -1;
        double  ang, alfa, beta;
        double  ro;             //  Radio relativo en pupila

                        //   Altura relativa en pupila para rayos meridianos

        for (ll = 0; ll <= nir; ll ++)          
        {
            ro = .98 * (float) ll / (float) nir;
            hpr[ll] = ro;
        }

                        //   Coordenadas relativas en pupila para rayos cruzados

        iw = -1;

        for (ll = 0; ll <= nir; ll ++)          
        {
            ro = .98 * (float) ll / (float) nir;

            niaj = nia * ll / nir;
            for (j = 0 ; j <= niaj; j ++)        
            {
                iw ++;

                if (niaj == 0)   
                    ang = 0.;
                else 
                    ang = j * 3.141592 / niaj;

                if (j == niaj)   
                {
                    alfa = -1;
                    beta = 0;
                }    
                else
                {
                    alfa = Math.cos (ang);
                    beta = Math.sin (ang);
                }
               
                xpr[iw] = ro * beta;
                ypr[iw] = ro * alfa;

            }
        }

        numRayos = iw + 1;

        SistemaFL.panelBase.repaint ();
        calculaSistema (1);
    }



    //======================  Crea varias fuentes   ===========================

    static Font fuente1 = new Font ("Dialog", Font.BOLD, 20);
    static Font fuente2 = new Font ("Dialog", Font.BOLD, 12);
    static Font fuente3 = new Font ("Dialog", Font.BOLD, 11);
    static Font fuente4 = new Font ("Dialog", Font.BOLD, 9);

    Color   colorTexto1 = Color.white;
    Color   colorTexto2 = Color.black;



    //=====================  Constructor  =====================================

    public ExactoFL ()
    {
        super ();       //  Llama al constructor de JFrame
        setSize (800, 450);

            


        //==============    Panel para el clculo exacto    ===================



        panelBase = new JPanel ();
        panelBase.setLayout (null);                 
        panelBase.setBackground (Color.gray);
        panelBase.setBounds (0, 230, 150, 140);


                //  Botones y leyendas del clculo exacto

                        //  Ttulo

        JLabel labelBase = new JLabel (text[0][lang]);
        labelBase.setBounds (15, 5, 140, 20);
        labelBase.setForeground (colorTexto1);
        labelBase.setFont (fuente3);
        panelBase.add (labelBase);


                        //  Botn para el objeto

        buttonObj = new JButton (text[1][lang]);
        buttonObj.setBounds (0, 25, 75, 20);
        buttonObj.setForeground (colorTexto2);
        buttonObj.setFont (fuente4);

                                //  Para que responda a una pulsacin

        buttonObj.addActionListener (this);  

                                //  Texto que devuelve cuando responde

        buttonObj.setActionCommand ("buttonObj");

        panelBase.add (buttonObj);

                        //  Botn para la imagen

        buttonImag = new JButton (text[3][lang]);
        buttonImag.setBounds (75, 25, 75, 20);
        buttonImag.setForeground (colorTexto2);
        buttonImag.setFont (fuente4);

                             //  Para que responda a una pulsacin

        buttonImag.addActionListener (this);  

                             //  Texto que devuelve cuando responde

        buttonImag.setActionCommand ("buttonImag");

        panelBase.add (buttonImag);

                        //  Ttulo para las lentes y diafragmas

        JLabel labelL = new JLabel (text[2][lang]);
        labelL.setBounds (10, 50, 150, 20);
        labelL.setForeground (colorTexto1);
        labelL.setFont (fuente3);
        panelBase.add (labelL);


                        //  Botones para lentes y diafragmas

        for (i = 1; i < 4; i ++)
        {
            nomBoton[i] = new String (""+i);
            buttonE[i] = new JButton (nomBoton[i]);
            buttonE[i].setBounds ((i-1)*50, 75, 50, 20);
            buttonE[i].setForeground (colorTexto2);
            buttonE[i].setFont (fuente3);
            buttonE[i].addActionListener (this); 
            buttonE[i].setActionCommand (nomBoton[i]);
            panelBase.add (buttonE[i]);
        }

        for (i = 4; i < 7; i ++)
        {
            nomBoton[i] = new String (""+i);
            buttonE[i] = new JButton (nomBoton[i]);
            buttonE[i].setBounds ((i-4)*50, 95, 50, 20);
            buttonE[i].setForeground (colorTexto2);
            buttonE[i].setFont (fuente3);
            buttonE[i].addActionListener (this); 
            buttonE[i].setActionCommand (nomBoton[i]);
            panelBase.add (buttonE[i]);
        }

                        //  Botn para el men principal

        buttonMP = new JButton (text[4][lang]);
        buttonMP.setBounds (0, 115, 150, 20);
        buttonMP.setForeground (colorTexto2);
        buttonMP.setFont (fuente3);
        buttonMP.addActionListener (this);  
        buttonMP.setActionCommand ("buttonMP");
        panelBase.add (buttonMP);



        //====  Prepara los paneles de las opciones del clculo exacto ========

        //----------------  Panel para el objeto    ---------------------------

        panelObj = new JPanel ();
        panelObj.setLayout (null);                 
        panelObj.setBounds (150, 230, 500, 220);
        
                         //  Elementos del panel
        
                             //  Ttulo
        
        labelObj = new JLabel (text[1][lang]);
        labelObj.setBounds (80, 10, 100, 30);
        labelObj.setForeground (Color.black);
        labelObj.setFont (fuente1);
        panelObj.add (labelObj);

    
                                    //  Botones "radio"

        buttonR = new JRadioButton ("Real");
        buttonR.setBounds (40, 40, 100, 30);
        buttonR.setFont (fuente3);
        buttonR.addActionListener (this);
        buttonR.setActionCommand ("R");
        buttonR.setSelected (true);

        buttonV = new JRadioButton ("Virtual");
        buttonV.setBounds (180, 40, 100, 30);
        buttonV.setFont (fuente3);
        buttonV.addActionListener (this);
        buttonV.setActionCommand ("V");


                                //  Agrupa los botones "radio"

        grupoO = new ButtonGroup ();
        grupoO.add (buttonR);
        grupoO.add (buttonV);

        panelObj.add (buttonR);
        panelObj.add (buttonV);

        
                                //  Corredera para la posicin del objeto
        
        labelZObj = new JLabel (text[7][lang]);
        labelZObj.setBounds (5, 80, 70, 20);
        labelZObj.setForeground (grisAzulado);
        labelZObj.setFont (fuente3);
        panelObj.add (labelZObj);
        
        labelValZObj = new JLabel ("---");
        labelValZObj.setBounds (5, 95, 70, 20);
        labelValZObj.setForeground (grisAzulado);
        labelValZObj.setFont (fuente3);
        panelObj.add (labelValZObj);
        
                                    //  Corredera
        
        sliderValZObj = new JSlider (-1600, 1600, -1600);
        sliderValZObj.setPaintTicks (true);
        sliderValZObj.setMajorTickSpacing (800);
        sliderValZObj.setMinorTickSpacing (100);
        sliderValZObj.setPaintLabels (false);
        sliderValZObj.setBounds (70, 80, 200, 30);

                                    //  Leyendas del SistemaFL.PosObj[0]

        valPosObj[0] = new JLabel (leyendaPosObj[0]);
        valPosObj[0].setBounds (55, 100, 60, 30);
        valPosObj[0].setForeground (grisAzulado);
        valPosObj[0].setFont (fuente3);
        valPosObj[0].setVisible (true);
        panelObj.add (valPosObj[0]);
    
        valPosObj[1] = new JLabel (leyendaPosObj[1]);
        valPosObj[1].setBounds (110, 100, 60, 30);
        valPosObj[1].setForeground (grisAzulado);
        valPosObj[1].setFont (fuente3);
        valPosObj[1].setVisible (true);
        panelObj.add (valPosObj[1]);
    
        valPosObj[2] = new JLabel (leyendaPosObj[2]);
        valPosObj[2].setBounds (168, 100, 60, 30);
        valPosObj[2].setForeground (grisAzulado);
        valPosObj[2].setFont (fuente3);
        valPosObj[2].setVisible (true);
        panelObj.add (valPosObj[2]);
    
        valPosObj[3] = new JLabel (leyendaPosObj[3]);
        valPosObj[3].setBounds (205, 100, 60, 30);
        valPosObj[3].setForeground (grisAzulado);
        valPosObj[3].setFont (fuente3);
        valPosObj[3].setVisible (true);
        panelObj.add (valPosObj[3]);
    
        valPosObj[4] = new JLabel (leyendaPosObj[4]);
        valPosObj[4].setBounds (240, 100, 60, 30);
        valPosObj[4].setForeground (grisAzulado);
        valPosObj[4].setFont (fuente3);
        valPosObj[4].setVisible (true);
        panelObj.add (valPosObj[4]);
    
                                    //  Crea el "escuchador" para la corredera.

        listenerValZObj = new SliderListener (labelValZObj);
        sliderValZObj.addChangeListener (listenerValZObj);
        panelObj.add (sliderValZObj);
        
        
                                //  Corredera para la altura del objeto
        
        labelHObj = new JLabel (text[8][lang]);
        labelHObj.setBounds (5, 140, 70, 20);
        labelHObj.setForeground (grisAzulado);
        labelHObj.setFont (fuente3);
        panelObj.add (labelHObj);
        
        labelValHObj = new JLabel ("0.");
        labelValHObj.setBounds (5, 160, 70, 20);
        labelValHObj.setForeground (grisAzulado);
        labelValHObj.setFont (fuente3);
        panelObj.add (labelValHObj);
        
                                    //  Corredera
        
        sliderValHObj = new JSlider (0, 200, 0);
        sliderValHObj.setPaintTicks (true);
        sliderValHObj.setMajorTickSpacing (50);
        sliderValHObj.setMinorTickSpacing (25);
        sliderValHObj.setPaintLabels (false);
        sliderValHObj.setBounds (80, 140, 190, 30);
        sliderValHObj.setEnabled (false);


                                    //  Leyendas del SistemaFL.campo[0]

        valCampo[0] = new JLabel (leyendaCampo[0]);
        valCampo[0].setBounds (85, 160, 60, 30);
        valCampo[0].setForeground (grisAzulado);
        valCampo[0].setFont (fuente3);
        valCampo[0].setVisible (false);
        panelObj.add (valCampo[0]);
    
        valCampo[1] = new JLabel (leyendaCampo[1]);
        valCampo[1].setBounds (130, 160, 60, 30);
        valCampo[1].setForeground (grisAzulado);
        valCampo[1].setFont (fuente3);
        valCampo[1].setVisible (false);
        panelObj.add (valCampo[1]);
    
        valCampo[2] = new JLabel (leyendaCampo[2]);
        valCampo[2].setBounds (168, 160, 60, 30);
        valCampo[2].setForeground (grisAzulado);
        valCampo[2].setFont (fuente3);
        valCampo[2].setVisible (false);
        panelObj.add (valCampo[2]);
    
        valCampo[3] = new JLabel (leyendaCampo[3]);
        valCampo[3].setBounds (211, 160, 60, 30);
        valCampo[3].setForeground (grisAzulado);
        valCampo[3].setFont (fuente3);
        valCampo[3].setVisible (false);
        panelObj.add (valCampo[3]);
    
        valCampo[4] = new JLabel (leyendaCampo[4]);
        valCampo[4].setBounds (255, 160, 60, 30);
        valCampo[4].setForeground (grisAzulado);
        valCampo[4].setFont (fuente3);
        valCampo[4].setVisible (false);
        panelObj.add (valCampo[4]);
    
        
                                    //  Crea el "escuchador" para la corredera.

        listenerValHObj = new SliderListener (labelValHObj);
        sliderValHObj.addChangeListener (listenerValHObj);
        panelObj.add (sliderValHObj);
        

        //----------------  Panel para la imagen    ---------------------------

        panelImag = new JPanel ();
        panelImag.setLayout (null);                 
        panelImag.setBounds (150, 230, 500, 220);
        
                      //  Elementos del panel
        
                          //  Ttulo
        
        labelImag = new JLabel (text[3][lang]);
        labelImag.setBounds (80, 0, 100, 30);
        labelImag.setForeground (Color.black);
        labelImag.setFont (fuente1);
        panelImag.add (labelImag);
    
                                    //  Botones "radio"

        buttonMono = new JRadioButton (text[21][lang]);
        buttonMono.setBounds (30, 30, 130, 30);
        buttonMono.setFont (fuente3);
        buttonMono.addActionListener (this);
        buttonMono.setActionCommand ("M");
        buttonMono.setSelected (true);

        buttonColor = new JRadioButton (text[22][lang]);
        buttonColor.setBounds (180, 30, 150, 30);
        buttonColor.setFont (fuente3);
        buttonColor.addActionListener (this);
        buttonColor.setActionCommand ("C");


                                //  Agrupa los botones "radio"

        grupo1 = new ButtonGroup ();
        grupo1.add (buttonMono);
        grupo1.add (buttonColor);

        panelImag.add (buttonMono);
        panelImag.add (buttonColor);

        
                                //  Corredera para la posicin de la imagen
        
        labelZParax = new JLabel (text[23][lang]);
        labelZParax.setBounds (5, 55, 200, 20);
        labelZParax.setForeground (grisAzulado);
        labelZParax.setFont (fuente3);
        panelImag.add (labelZParax);
        
        labelValZParax = new JLabel ("---");
        labelValZParax.setBounds (200, 55, 90, 20);
        labelValZParax.setForeground (grisAzulado);
        labelValZParax.setFont (fuente3);
        panelImag.add (labelValZParax);
        
        labelZImag = new JLabel (text[17][lang]);
        labelZImag.setBounds (5, 80, 260, 20);
        labelZImag.setForeground (grisAzulado);
        labelZImag.setFont (fuente3);
        panelImag.add (labelZImag);
        
        labelValZImag = new JLabel ("---");
        labelValZImag.setBounds (5, 105, 100, 20);
        labelValZImag.setForeground (grisAzulado);
        labelValZImag.setFont (fuente3);
        panelImag.add (labelValZImag);

                                    //  Corredera
        
        sliderValZImag = new JSlider (-100, 100, 0);
        sliderValZImag.setPaintTicks (true);
        sliderValZImag.setMajorTickSpacing (50);
        sliderValZImag.setMinorTickSpacing (10);
        sliderValZImag.setPaintLabels (false);
        sliderValZImag.setBounds (60, 100, 210, 30);
        
                                     //  Leyendas de PosImag

        valPosImag[0] = new JLabel (leyendaPosImag[0]);
        valPosImag[0].setBounds (55, 120, 60, 30);
        valPosImag[0].setForeground (grisAzulado);
        valPosImag[0].setFont (fuente3);
        valPosImag[0].setVisible (true);
        panelImag.add (valPosImag[0]);
    
        valPosImag[1] = new JLabel (leyendaPosImag[1]);
        valPosImag[1].setBounds (110, 120, 60, 30);
        valPosImag[1].setForeground (grisAzulado);
        valPosImag[1].setFont (fuente3);
        valPosImag[1].setVisible (true);
        panelImag.add (valPosImag[1]);
    
        valPosImag[2] = new JLabel (leyendaPosImag[2]);
        valPosImag[2].setBounds (161, 120, 60, 30);
        valPosImag[2].setForeground (grisAzulado);
        valPosImag[2].setFont (fuente3);
        valPosImag[2].setVisible (true);
        panelImag.add (valPosImag[2]);
    
        valPosImag[3] = new JLabel (leyendaPosImag[3]);
        valPosImag[3].setBounds (210, 120, 60, 30);
        valPosImag[3].setForeground (grisAzulado);
        valPosImag[3].setFont (fuente3);
        valPosImag[3].setVisible (true);
        panelImag.add (valPosImag[3]);
    
        valPosImag[4] = new JLabel (leyendaPosImag[4]);
        valPosImag[4].setBounds (250, 120, 60, 30);
        valPosImag[4].setForeground (grisAzulado);
        valPosImag[4].setFont (fuente3);
        valPosImag[4].setVisible (true);
        panelImag.add (valPosImag[4]);
        
                                    //  Crea el "escuchador" para la corredera.

        listenerValZImag = new SliderListener (labelValZImag);
        sliderValZImag.addChangeListener (listenerValZImag);
        panelImag.add (sliderValZImag);
        
        
                                //  Corredera para la escala de los diagramas
        
        labelHImag = new JLabel (text[18][lang]);
        labelHImag.setBounds (5, 150, 70, 20);
        labelHImag.setForeground (grisAzulado);
        labelHImag.setFont (fuente3);
        panelImag.add (labelHImag);
        
        labelValHImag = new JLabel ("1.");
        labelValHImag.setBounds (5, 170, 70, 20);
        labelValHImag.setForeground (grisAzulado);
        labelValHImag.setFont (fuente3);
        panelImag.add (labelValHImag);
        
                                    //  Corredera
        
        sliderValHImag = new JSlider (-200, 100, 1);
        sliderValHImag.setPaintTicks (true);
        sliderValHImag.setMajorTickSpacing (20);
        sliderValHImag.setPaintLabels (false);
        sliderValHImag.setBounds (70, 160, 190, 30);
        
                                    //  Crea el "escuchador" para la corredera.

        listenerValHImag = new SliderListener (labelValHImag);
        sliderValHImag.addChangeListener (listenerValHImag);
        panelImag.add (sliderValHImag);
        

        //---------     Panel para escribir las funciones de mrito     --------

        panelMerito = new JPanel ();
        panelMerito.setLayout (null);                 
        panelMerito.setBounds (0, 365, 150, 115);

                                    //  F. de M. en eje
    
        labelMerito[0] = new JLabel (text[24][lang]);
        labelMerito[0].setBounds (5, 10, 150, 15);
        labelMerito[0].setForeground (grisAzulado);
        labelMerito[0].setFont (fuente3);
        panelMerito.add (labelMerito[0]);
    
        labelValMerito[0] = new JLabel ("---");
        labelValMerito[0].setBounds (50, 25, 100, 15);
        labelValMerito[0].setForeground (grisAzulado);
        labelValMerito[0].setFont (fuente3);
        panelMerito.add (labelValMerito[0]);

                                    //  F. de M. en SistemaFL.campo[0]
    
        labelMerito[1] = new JLabel (text[25][lang]);
        labelMerito[1].setBounds (5, 45, 150, 15);
        labelMerito[1].setForeground (grisAzulado);
        labelMerito[1].setFont (fuente3);
        panelMerito.add (labelMerito[1]);
    
        labelValMerito[1] = new JLabel ("---");
        labelValMerito[1].setBounds (50, 60, 100, 15);
        labelValMerito[1].setForeground (grisAzulado);
        labelValMerito[1].setFont (fuente3);
        panelMerito.add (labelValMerito[1]);

    

        //-----------   Paneles para lentes y diafragmas    -------------------


                                //  Paneles de cada elemento

        for (i = 1; i < 7; i ++)
        {
            panelE[i] = new JPanel ();
            panelE[i].setLayout (null);                 
            panelE[i].setBounds (150, 230, 500, 220);

            panelVE[i] = new JPanel ();
            panelVE[i].setLayout (null);                 
            panelVE[i].setBounds (0, 365, 150, 85);
    
            SistemaFL.valZE[i] = 200. + 200. * i;
            SistemaFL.valPE[i] = 0.;
            valBE[i] = 0.;
            SistemaFL.valDibPE[i] = 0.;
            SistemaFL.existe[i] = 0;
            SistemaFL.valDE[i] = (double) diamMax;
            SistemaFL.dist[i] = 0.;
            diste[i] = 0.;
            distb[i] = 0.;
            SistemaFL.tipoE[i] = 1;
            SistemaFL.altura[i] = diamMax / 2.;
            unidad[i] = " diop.";
            indice[i] = 1.6;
            abbe[i] = 50.;

                                //  Elementos del panel
                                    //  Ttulo
    
            labelE[i] = new JLabel (text[10][lang]+" "+i);
            labelE[i].setBounds (20, 10, 200, 30);
            labelE[i].setForeground (Color.black);
            labelE[i].setFont (fuente3);
            panelE[i].add (labelE[i]);
    
                                    //  Botones "radio"

            buttonL[i] = new JRadioButton (text[11][lang]);
            buttonL[i].setBounds (110, 10, 70, 30);
            buttonL[i].setFont (fuente3);
            buttonL[i].addActionListener (this);
            buttonL[i].setActionCommand ("L");
            buttonL[i].setSelected (true);

            buttonD[i] = new JRadioButton (text[12][lang]);
            buttonD[i].setBounds (180, 10, 100, 30);
            buttonD[i].setFont (fuente3);
            buttonD[i].addActionListener (this);
            buttonD[i].setActionCommand ("D");

                                    //  Agrupa los botones "radio"

            grupo[i] = new ButtonGroup ();
            grupo[i].add (buttonL[i]);
            grupo[i].add (buttonD[i]);

            panelE[i].add (buttonL[i]);
            panelE[i].add (buttonD[i]);

                                //  Lentes y diafragmas

                                    //  Posicin
    
            labelZE[i] = new JLabel (text[7][lang]);
            labelZE[i].setBounds (5, 45, 70, 15);
            labelZE[i].setForeground (grisAzulado);
            labelZE[i].setFont (fuente3);
            panelE[i].add (labelZE[i]);
    
                                    //  Valor de la posicin
    
            labelValZE[i] = new JLabel (SistemaFL.valZE[i] + " mm");
            labelValZE[i].setBounds (5, 60, 70, 15);
            labelValZE[i].setForeground (grisAzulado);
            labelValZE[i].setFont (fuente3);
            panelE[i].add (labelValZE[i]);
    
                                    //  Corredera
    
            sliderValZE[i] = new JSlider (0, 1600, 200+200*i);
            sliderValZE[i].setPaintTicks (true);
            sliderValZE[i].setMajorTickSpacing (400);
            sliderValZE[i].setMinorTickSpacing (50);
            sliderValZE[i].setBounds (60, 45, 210, 30);
            sliderValZE[i].setEnabled (false);
    
                                    //  Crea el "escuchador" para la corredera.
    
            listenerValZE[i] = new SliderListener (labelValZE[i]);
            sliderValZE[i].addChangeListener (listenerValZE[i]);
            sliderValZE[i].setEnabled (false);
    
            panelE[i].add (sliderValZE[i]);

                                    //  Leyendas de la posicin

            valPos[i][0] = new JLabel (leyendaPos[0]);
            valPos[i][0].setBounds (65, 65, 60, 30);
            valPos[i][0].setForeground (grisAzulado);
            valPos[i][0].setFont (fuente3);
            panelE[i].add (valPos[i][0]);
    
            valPos[i][1] = new JLabel (leyendaPos[1]);
            valPos[i][1].setBounds (105, 65, 60, 30);
            valPos[i][1].setForeground (grisAzulado);
            valPos[i][1].setFont (fuente3);
            panelE[i].add (valPos[i][1]);
    
            valPos[i][2] = new JLabel (leyendaPos[2]);
            valPos[i][2].setBounds (155, 65, 60, 30);
            valPos[i][2].setForeground (grisAzulado);
            valPos[i][2].setFont (fuente3);
            panelE[i].add (valPos[i][2]);
    
            valPos[i][3] = new JLabel (leyendaPos[3]);
            valPos[i][3].setBounds (200, 65, 60, 30);
            valPos[i][3].setForeground (grisAzulado);
            valPos[i][3].setFont (fuente3);
            panelE[i].add (valPos[i][3]);
    
            valPos[i][4] = new JLabel (leyendaPos[4]);
            valPos[i][4].setBounds (240, 65, 60, 30);
            valPos[i][4].setForeground (grisAzulado);
            valPos[i][4].setFont (fuente3);
            panelE[i].add (valPos[i][4]);
    
            panelE[i].add (sliderValZE[i]);
    
                                    //  Potencia o radio de diafragma
    
            labelHE[i] = new JLabel (text[14][lang]);
            labelHE[i].setBounds (5, 95, 70, 10);
            labelHE[i].setForeground (grisAzulado);
            labelHE[i].setFont (fuente3);
            panelE[i].add (labelHE[i]);
            SistemaFL.altura[i] = diamMax / 2.;
    
                                    //  Valor de la potencia
    
            texto1 = "0 diop";
            labelValHE[i] = new JLabel (texto1);
            labelValHE[i].setBounds (5, 110, 70, 10);
            labelValHE[i].setForeground (grisAzulado);
            labelValHE[i].setFont (fuente3);
            panelE[i].add (labelValHE[i]);

                                    //  Focal
    
            labelFE[i] = new JLabel (text[15][lang]);
            labelFE[i].setBounds (5, 125, 70, 10);
            labelFE[i].setForeground (grisAzulado);
            labelFE[i].setFont (fuente3);
            panelE[i].add (labelFE[i]);
    
                                    //  Valor de la focal

            texto1 = "---";
            labelValFE[i] = new JLabel (texto1);
            labelValFE[i].setBounds (5, 140, 70, 10);
            labelValFE[i].setForeground (grisAzulado);
            labelValFE[i].setFont (fuente3);
            panelE[i].add (labelValFE[i]);

                                //  Corredera
    
            sliderValHE[i] = new JSlider (-200, 200, 0);
            datosCorrederaHLente (i);

                                    //  Crea el "escuchador" para la corredera.
    
            listenerValHE[i] = new SliderListener (labelValHE[i]);
            sliderValHE[i].addChangeListener (listenerValHE[i]);
    

                                    //  Leyendas de la potencia

            valPot[i][0] = new JLabel (leyendaPot[0]);
            valPot[i][0].setBounds (75, 120, 60, 30);
            valPot[i][0].setForeground (grisAzulado);
            valPot[i][0].setFont (fuente3);
            panelE[i].add (valPot[i][0]);
    
            valPot[i][1] = new JLabel (leyendaPot[1]);
            valPot[i][1].setBounds (120, 120, 60, 30);
            valPot[i][1].setForeground (grisAzulado);
            valPot[i][1].setFont (fuente3);
            panelE[i].add (valPot[i][1]);
    
            valPot[i][2] = new JLabel (leyendaPot[2]);
            valPot[i][2].setBounds (170, 120, 60, 30);
            valPot[i][2].setForeground (grisAzulado);
            valPot[i][2].setFont (fuente3);
            panelE[i].add (valPot[i][2]);
    
            valPot[i][3] = new JLabel (leyendaPot[3]);
            valPot[i][3].setBounds (210, 120, 60, 30);
            valPot[i][3].setForeground (grisAzulado);
            valPot[i][3].setFont (fuente3);
            panelE[i].add (valPot[i][3]);
    
            valPot[i][4] = new JLabel (leyendaPot[4]);
            valPot[i][4].setBounds (250, 120, 60, 30);
            valPot[i][4].setForeground (grisAzulado);
            valPot[i][4].setFont (fuente3);
            panelE[i].add (valPot[i][4]);
    
            panelE[i].add (sliderValHE[i]);


                                    //  Leyendas del dimetro

            valDiam[i][0] = new JLabel (leyendaDiam[0]);
            valDiam[i][0].setBounds (80, 120, 60, 30);
            valDiam[i][0].setForeground (grisAzulado);
            valDiam[i][0].setFont (fuente3);
            panelE[i].add (valDiam[i][0]);
    
            valDiam[i][1] = new JLabel (leyendaDiam[1]);
            valDiam[i][1].setBounds (125, 120, 60, 30);
            valDiam[i][1].setForeground (grisAzulado);
            valDiam[i][1].setFont (fuente3);
            panelE[i].add (valDiam[i][1]);
    
            valDiam[i][2] = new JLabel (leyendaDiam[2]);
            valDiam[i][2].setBounds (180, 120, 60, 30);
            valDiam[i][2].setForeground (grisAzulado);
            valDiam[i][2].setFont (fuente3);
            panelE[i].add (valDiam[i][2]);
    
            valDiam[i][3] = new JLabel (leyendaDiam[3]);
            valDiam[i][3].setBounds (230, 120, 60, 30);
            valDiam[i][3].setForeground (grisAzulado);
            valDiam[i][3].setFont (fuente3);
            panelE[i].add (valDiam[i][3]);
    
            panelE[i].add (sliderValHE[i]);


                                    //  Doblado
    
            labelBE[i] = new JLabel (text[9][lang]);
            labelBE[i].setBounds (5, 155, 70, 15);
            labelBE[i].setForeground (grisAzulado);
            labelBE[i].setFont (fuente3);
            panelE[i].add (labelBE[i]);

            labelValBE[i] = new JLabel (" ");
            panelE[i].add (labelValBE[i]);
    
                                    //  Valor de los radios
    
            labelValR1E[i] = new JLabel ("---");
            labelValR1E[i].setBounds (5, 170, 70, 15);
            labelValR1E[i].setForeground (grisAzulado);
            labelValR1E[i].setFont (fuente3);
            panelE[i].add (labelValR1E[i]);

            labelValR2E[i] = new JLabel ("---");
            labelValR2E[i].setBounds (5, 185, 70, 15);
            labelValR2E[i].setForeground (grisAzulado);
            labelValR2E[i].setFont (fuente3);
            panelE[i].add (labelValR2E[i]);
    
                                    //  Corredera
    
            sliderValBE[i] = new JSlider (-100, 100, 0);
            sliderValBE[i].setPaintTicks (true);
            sliderValBE[i].setMajorTickSpacing (50);
            sliderValBE[i].setMinorTickSpacing (50);
            sliderValBE[i].setPaintLabels (false);
            sliderValBE[i].setBounds (80, 160, 190, 30);
            sliderValBE[i].setEnabled (false);

                                    //  Crea el "escuchador" para la corredera.
    
            listenerValBE[i] = new SliderListener (labelValBE[i]);
            sliderValBE[i].addChangeListener (listenerValBE[i]);
            sliderValBE[i].setEnabled (false);

            panelE[i].add (sliderValBE[i]);


                                    //  Indice
    
            labelNE[i] = new JLabel (text[19][lang]);
            labelNE[i].setBounds (5, 10, 60, 15);
            labelNE[i].setForeground (grisAzulado);
            labelNE[i].setFont (fuente3);
            panelVE[i].add (labelNE[i]);

                                    //  Valor del ndice
    
            labelValNE[i] = new JLabel (indice[i]+" ");
            labelValNE[i].setBounds (5, 25, 60, 15);
            labelValNE[i].setForeground (grisAzulado);
            labelValNE[i].setFont (fuente3);
            panelVE[i].add (labelValNE[i]);
    
                                    //  Corredera
    
            sliderValNE[i] = new JSlider (140, 180, 150);
            sliderValNE[i].setBounds (50, 15, 100, 30);
            sliderValNE[i].setEnabled (false);

                                    //  Crea el "escuchador" para la corredera.
    
            listenerValNE[i] = new SliderListener (labelValNE[i]);
            sliderValNE[i].addChangeListener (listenerValNE[i]);
            sliderValNE[i].setEnabled (false);

            panelVE[i].add (sliderValNE[i]);


                                    //  N de Abbe
    
            labelAE[i] = new JLabel (text[20][lang]);
            labelAE[i].setBounds (5, 45, 60, 15);
            labelAE[i].setForeground (grisAzulado);
            labelAE[i].setFont (fuente3);
            panelVE[i].add (labelAE[i]);

                                    //  Valor del n de Abbe
    
            labelValAE[i] = new JLabel (abbe[i]+" ");
            labelValAE[i].setBounds (5, 60, 65, 15);
            labelValAE[i].setForeground (grisAzulado);
            labelValAE[i].setFont (fuente3);
            panelVE[i].add (labelValAE[i]);
    
                                    //  Corredera
    
            sliderValAE[i] = new JSlider (400, 600, 500);
            sliderValAE[i].setBounds (50, 45, 100, 30);
            sliderValAE[i].setEnabled (false);

                                    //  Crea el "escuchador" para la corredera.
    
            listenerValAE[i] = new SliderListener (labelValAE[i]);
            sliderValAE[i].addChangeListener (listenerValAE[i]);
            sliderValAE[i].setEnabled (false);

            panelVE[i].add (sliderValAE[i]);

        }


        //----------    Panel para las leyendas de los diagramas     ---------

        panelDiagramas = new JPanel ();
        panelDiagramas.setLayout (null);                 
        panelDiagramas.setBackground (Color.gray);
        panelDiagramas.setBounds (420, 420, 380, 20);


                //  Leyendas para los diagramas

        labelDiagramas1 = new JLabel (text[5][lang]);
        labelDiagramas1.setBounds (80, 0, 100, 20);
        labelDiagramas1.setForeground (colorTexto1);
        labelDiagramas1.setFont (fuente3);
        panelDiagramas.add (labelDiagramas1);


        labelDiagramas2 = new JLabel (text[6][lang]+" = "+lado+" mm");
        labelDiagramas2.setBounds (130, 0, 120, 20);
        labelDiagramas2.setForeground (colorTexto1);
        labelDiagramas2.setFont (fuente3);
        panelDiagramas.add (labelDiagramas2);


        labelDiagramas3 = new JLabel (text[8][lang]);
        labelDiagramas3.setBounds (250, 0, 150, 20);
        labelDiagramas3.setForeground (colorTexto1);
        labelDiagramas3.setFont (fuente3);
        panelDiagramas.add (labelDiagramas3);


        //=================     Paneles para dibujar    =====================

        //-------------    Panel para la marcha exacta   --------------------

        canvasExactoFL = new DibujoExactoFL ();
        canvasExactoFL.setBackground (Color.black);
        canvasExactoFL.setBounds (30, 0, 800, 210);


        //-------------    Panel para los diagramas de impactos   ------------

        canvasDiagramas = new DibujoDiagramasFL ();
        canvasDiagramas.setBackground (Color.black);
        canvasDiagramas.setBounds (420, 230, 380, 190);

    }


    //========  Define los mtodos de ActionListener  =========================


    public void actionPerformed (ActionEvent e) 
    {
        int     i, j;


            //  Obtiene la etiqueta del botn pulsado

        String s = e.getActionCommand ();


        //-------------     Opciones del men      -----------------------

        //  Ante cualquier accin de cambio de panel, borra el panel 
        //  inferior central, que es el que haba puesto la opcin anterior.

        if ((s != "L") && (s != "D") && (s != "R") && (s != "V") 
                                     && (s != "M") && (s != "C"))
        {
            if (cuadro == 0)
                SistemaFL.panelBase.remove (panelObj);
    
            if (cuadro == 1)
            {
                SistemaFL.panelBase.remove (panelImag);
                SistemaFL.panelBase.remove (panelMerito);
            }
    
            for (i = 0; i < 7; i ++)
            {
                if (cuadro == 20 + i)
                {
                    SistemaFL.panelBase.remove (panelE[i]);
                    SistemaFL.panelBase.remove (panelVE[i]);
                }
            }
        }

                //  Pone el panel de la opcin
 
                                //  Objeto

        if (s == "buttonObj")  
        {
            SistemaFL.panelBase.add (panelObj);
            cuadro = 0;
        }
 
                                //  Controla el botn "radio" del objeto

        if (s == "R")           //  Objeto SistemaFL.real[0]
            SistemaFL.real[0] = 1;

        if (s == "V")           //  Objeto virtual
            SistemaFL.real[0] = 0;

                                //  Imagen

        if (s == "buttonImag")  
        {
            SistemaFL.panelBase.add (panelImag);
            SistemaFL.panelBase.add (panelMerito);
            cuadro = 1;
        }
 
                                //  Controla el botn "radio" de la imagen

        if (s == "M")           //  Imagen monocromtica
            numColores = 1;

        if (s == "C")           //  Imagen en color
        {
            numColores = 3;
            if (FuncionesExactasFL.preparaSistema () == 1)
            {
                FuncionesExactasFL.marchaParaxial ();
                if (FuncionesExactasFL.preparaRayos () == 1)
                {
                    FuncionesExactasFL.propagaHazRayos ();
                }
            }
        }

                                //  Elemento i

        for (i = 0; i < 7; i ++)
        {

                                    //  Controla el botn que lo llama
            if (s == nomBoton[i])
            {

                SistemaFL.panelBase.add (panelE[i]);
                SistemaFL.panelBase.add (panelVE[i]);
  
                                   //  Si es en color y hay lente activa el n de Abbe

                if ((numColores == 3) && (SistemaFL.valPE[i] != 0))    
                {
                    labelValAE[i].setText (abbe[i] + "");
                    sliderValAE[i].setEnabled (true);
                }
                else
                {
                    labelValAE[i].setText ("---");
                    sliderValAE[i].setEnabled (false);
                }
                cuadro = 20 + i;
            }


                                    //  Controla el botn "radio"
                //  Como al cambiar los valores de las correderas, se lanza
                //  un evento de cambio y llama al "StateChanged", hay que poner
                //  el "setValue (0)" lo primero de todo en el caso "L", para
                //  que no utilice el que haba antes (diamMax) al calcular el
                //  espesor, mientras que en el caso "D" el "setValue (diamMax)" 
                //  ha de estar despus de cambiar el mximo.

            if (cuadro == 20 + i)
            {

                               //  Escribe las leyendas de la posicion

                for (j = 0; j < 5; j ++)
                {
                    valPos[i][j].setVisible (true);
                }

                if (s == "L")           //     Lo declaramos lente
                {
                    SistemaFL.tipoE[i] = 1;
                    unidad[i] = " diop.";
                    SistemaFL.existe[i] = 0;

                                //  Borra las leyendas del dimetro

                    for (j = 0; j < 4; j ++)
                    {
                        valDiam[i][j].setVisible (false);
                    }

                    datosCorrederaHLente (i);

                    sliderValZE[i].setEnabled (false);
                    sliderValBE[i].setEnabled (false);
                    labelHE[i].setText (text[14][lang]);
                    labelValHE[i].setText (0. + unidad[i]);
                    labelFE[i].setText (text[15][lang]);
                    labelValFE[i].setText ("---");
                    labelBE[i].setText (text[9][lang]);
                    labelValR1E[i].setText ("---");
                    labelValR2E[i].setText ("---");
                    panelE[i].add (sliderValBE[i]);

                    labelNE[i].setText (text[19][lang]);
                    labelAE[i].setText (text[20][lang]);
                    labelValNE[i].setText ("---");
                    labelValAE[i].setText ("---");
                    sliderValNE[i].setValue (160);
                    sliderValAE[i].setValue (500);
                    sliderValNE[i].setEnabled (false);
                    sliderValAE[i].setEnabled (false);

                    panelVE[i].add (sliderValNE[i]);
                    panelVE[i].add (sliderValAE[i]);
                    SistemaFL.altura[i] = diamMax / 2.;

                                //  Escribe las leyendas de la potencia
                    for (j = 0; j < 5; j ++)
                    {
                        valPot[i][j].setVisible (true);
                    }

                    SistemaFL.valPE[i] = 0.;
                    SistemaFL.valDibPE[i] = 0.;
                    SistemaFL.valDE[i] = (double) diamMax;

                }

                if (s == "D")           //  Lo declaramos diafragma
                {
                    SistemaFL.tipoE[i] = 0;
                    unidad[i] = " mm";
                    SistemaFL.existe[i] = 0;

                                //  Borra las leyendas de la potencia

                    for (j = 0; j < 5; j ++)
                    {
                        valPot[i][j].setVisible (false);
                    }

                    datosCorrederaHDiafragma (i);

                    sliderValZE[i].setEnabled (false);
                    panelE[i].remove (sliderValBE[i]);
                    panelVE[i].remove (sliderValNE[i]);
                    panelVE[i].remove (sliderValAE[i]);
                    labelHE[i].setText (text[13][lang]);
                    labelValHE[i].setText ("---");
                    labelFE[i].setText (" ");
                    labelBE[i].setText (" ");
                    labelNE[i].setText (" ");
                    labelAE[i].setText (" ");
                    labelValFE[i].setText (" ");
                    labelValR1E[i].setText (" ");
                    labelValR2E[i].setText (" ");
                    labelValNE[i].setText (" ");
                    labelValAE[i].setText (" ");

                                //  Escribe las leyendas del dimetro

                    for (j = 0; j < 4; j ++)
                    {
                        valDiam[i][j].setVisible (true);
                    }

                    SistemaFL.valPE[i] = 0.;
                    SistemaFL.valDibPE[i] = 0.;
                    SistemaFL.valDE[i] = (double) diamMax;
                    SistemaFL.altura[i] = diamMax / 2.;
                    espesor[i] = 0.;

                }
            }

        }



        if (s == "buttonMP")    //  Vuelve a Men principal desde Clculo exacto
        {
            SistemaFL.panelBase.remove (panelBase);
            SistemaFL.panelBase.remove (canvasExactoFL);
            SistemaFL.panelBase.remove (canvasDiagramas);
            SistemaFL.panelBase.remove (panelDiagramas);

            SistemaFL.panelBase.add (SistemaFL.panelBase.panelMP);
//            repaint ();
        }

                //  Actualiza la ventana

        SistemaFL.panelBase.repaint ();
        calculaSistema (1);

    }


    //================      Clase para leer las correderas  ===================

        //  Al moverse la corredera entra aqu y no sigue hasta que se
        //  vuelve a mover o se pulsa otro botn.
        //  Por eso se debe poner aqu todo el cdigo de las operaciones
        //  que deban SistemaFL.real[0]izarse al mover la corredera.
        //  Se puede poner una clase para cada corredera o bien una sola clase
        //  con un control segn el nombre de la corredera.

    class SliderListener implements ChangeListener 
    {
        JLabel  tf;                            


        public SliderListener (JLabel f) 
        {
            tf = f;
        }
        

        //------------  Define los mtodos de "stateChanged"    ---------------

        public void stateChanged (ChangeEvent e) 
        {
            JSlider s1 = (JSlider) e.getSource ();
            double  focal;
            int     j;


        //-------------  Aqu viene el cdigo de operaciones    ---------------


            //------------------------    Objeto     -------------------------


                            //  Posicin 
    
            if (tf == labelValZObj) 
            {
                SistemaFL.valZObj[0] = (double) s1.getValue ();

                if (SistemaFL.valZObj[0] == -1600)   
                                        //  No existe el objeto
                {
                    SistemaFL.existeObjeto[0] = 0;
                    tf.setText ("----");
                    calcula = 0;

                                //  Desactiva la corredera y las leyendas de campo

                    sliderValHObj.setEnabled (false);
                    for (j = 0; j < 5; j ++)
                    {
                        valCampo[j].setVisible (false);
                    }
                }
                else
                {
                    SistemaFL.existeObjeto[0] = 1;

                                //  Activa la corredera y las leyendas de campo

                    sliderValHObj.setEnabled (true);
                    for (j = 0; j < 5; j ++)
                    {
                        valCampo[j].setVisible (true);
                    }


                    if (SistemaFL.valZObj[0]>=1600 || SistemaFL.valZObj[0]<=-1500)
                                                //  Objeto en el infinito
                    {
                        SistemaFL.zObjeto[0] = -1.e10;
                        tf.setText (text[16][lang]);
                    }
                    else
                    {
                                            //  Objeto a distancia finita
                        SistemaFL.zObjeto[0] = SistemaFL.valZObj[0];
                        tf.setText (SistemaFL.valZObj[0] + " mm");
                    }

                    calcula = 1;

                }
            }
    
                        //  Altura
    
            if (tf == labelValHObj)
            {
                SistemaFL.campo[0] = (double) s1.getValue () / 10.;
                tf.setText (SistemaFL.campo[0] + " ");

                calcula = 1;
            }
            

            //------------------------    Imagen     -------------------------


                            //  Posicin 
    
            if (tf == labelValZImag) 
            {
                valZImag = (double) s1.getValue ();
    
                if (valZImag >= 1600)
                {
                    valZImag = 1.e10;
                    tf.setText (text[16][lang]);
                }
                else
                    tf.setText (valZImag + " mm");

                calcula = 2;
            }
    
                        //  Escala
    
            if (tf == labelValHImag)
            {
                escala = Math.pow (10., s1.getValue () / 100.);

                lado = (int) (escala * 100.) / 100.;
                tf.setText (lado + " mm");
                labelDiagramas2.setText (text[6][lang]+" = "+lado+" mm");

                calcula = 3;
            }
            
    

            //-------------------       Lente 1        -----------------------


            if ((tf == labelValZE[1]) || (tf == labelValHE[1]) 
                           || (tf == labelValBE[1]) || (tf == labelValNE[1])
                           || (tf == labelValAE[1]))
            {
                datosElemento (s1, tf, 1);

                diste[1] = dze2[1] - dze1[2];
                distb[1] = dzb2[1] - dzb1[2];
                if (diste[1] > distb[1])
                    SistemaFL.dist[1] = diste[1];
                else
                    SistemaFL.dist[1] = distb[1];


                        //  Empuja las otras lentes si hace falta

                if (SistemaFL.valZE[2] < SistemaFL.valZE[1] + SistemaFL.dist[1])
                    SistemaFL.valZE[2] = SistemaFL.valZE[1] + SistemaFL.dist[1];
                if (SistemaFL.valZE[3] < SistemaFL.valZE[2] + SistemaFL.dist[2])
                    SistemaFL.valZE[3] = SistemaFL.valZE[2] + SistemaFL.dist[2];
                if (SistemaFL.valZE[4] < SistemaFL.valZE[3] + SistemaFL.dist[3])
                    SistemaFL.valZE[4] = SistemaFL.valZE[3] + SistemaFL.dist[3];
                if (SistemaFL.valZE[5] < SistemaFL.valZE[4] + SistemaFL.dist[4])
                    SistemaFL.valZE[5] = SistemaFL.valZE[4] + SistemaFL.dist[4];
                if (SistemaFL.valZE[6] < SistemaFL.valZE[5] + SistemaFL.dist[5])
                    SistemaFL.valZE[6] = SistemaFL.valZE[5] + SistemaFL.dist[5];

                                //  Corrige los valores de sus correderas

                ExactoFL.sliderValZE[2].setValue ((int) SistemaFL.valZE[2]);
                ExactoFL.sliderValZE[3].setValue ((int) SistemaFL.valZE[3]);
                ExactoFL.sliderValZE[4].setValue ((int) SistemaFL.valZE[4]);
                ExactoFL.sliderValZE[5].setValue ((int) SistemaFL.valZE[5]);
                ExactoFL.sliderValZE[6].setValue ((int) SistemaFL.valZE[6]);

                calcula = 1;
            }



            //-------------------       Lente 2        -----------------------


            if ((tf == labelValZE[2]) || (tf == labelValHE[2]) 
                           || (tf == labelValBE[2]) || (tf == labelValNE[2])
                           || (tf == labelValAE[2]))
            {

                datosElemento (s1, tf, 2);

                diste[1] = dze2[1] - dze1[2];
                distb[1] = dzb2[1] - dzb1[2];
                if (diste[1] > distb[1])
                    SistemaFL.dist[1] = diste[1];
                else
                    SistemaFL.dist[1] = distb[1];

                diste[2] = dze2[2] - dze1[3];
                distb[2] = dzb2[2] - dzb1[3];
                if (diste[2] > distb[2])
                    SistemaFL.dist[2] = diste[2];
                else
                    SistemaFL.dist[2] = distb[2];


                        //  Empuja las otras lentes si hace falta

                if (SistemaFL.valZE[1] > SistemaFL.valZE[2] - SistemaFL.dist[1])
                    SistemaFL.valZE[1] = SistemaFL.valZE[2] - SistemaFL.dist[1];
                if (SistemaFL.valZE[3] < SistemaFL.valZE[2] + SistemaFL.dist[2])
                    SistemaFL.valZE[3] = SistemaFL.valZE[2] + SistemaFL.dist[2];
                if (SistemaFL.valZE[4] < SistemaFL.valZE[3] + SistemaFL.dist[3])
                    SistemaFL.valZE[4] = SistemaFL.valZE[3] + SistemaFL.dist[3];
                if (SistemaFL.valZE[5] < SistemaFL.valZE[4] + SistemaFL.dist[4])
                    SistemaFL.valZE[5] = SistemaFL.valZE[4] + SistemaFL.dist[4];
                if (SistemaFL.valZE[6] < SistemaFL.valZE[5] + SistemaFL.dist[5])
                    SistemaFL.valZE[6] = SistemaFL.valZE[5] + SistemaFL.dist[5];

                                //  Corrige los valores de sus correderas

                ExactoFL.sliderValZE[1].setValue ((int) SistemaFL.valZE[1]);
                ExactoFL.sliderValZE[3].setValue ((int) SistemaFL.valZE[3]);
                ExactoFL.sliderValZE[4].setValue ((int) SistemaFL.valZE[4]);
                ExactoFL.sliderValZE[5].setValue ((int) SistemaFL.valZE[5]);
                ExactoFL.sliderValZE[6].setValue ((int) SistemaFL.valZE[6]);

                calcula = 1;
            }


            //-------------------       Lente 3        -----------------------


            if ((tf == labelValZE[3]) || (tf == labelValHE[3]) 
                           || (tf == labelValBE[3]) || (tf == labelValNE[3])
                           || (tf == labelValAE[3]))
            {

                datosElemento (s1, tf, 3);

                diste[2] = dze2[2] - dze1[3];
                distb[2] = dzb2[2] - dzb1[3];
                if (diste[2] > distb[2])
                    SistemaFL.dist[2] = diste[2];
                else
                    SistemaFL.dist[2] = distb[2];

                diste[3] = dze2[3] - dze1[4];
                distb[3] = dzb2[3] - dzb1[4];
                if (diste[3] > distb[3])
                    SistemaFL.dist[3] = diste[3];
                else
                    SistemaFL.dist[3] = distb[3];


                        //  Empuja las otras lentes si hace falta

                if (SistemaFL.valZE[2] > SistemaFL.valZE[3] - SistemaFL.dist[2])
                    SistemaFL.valZE[2] = SistemaFL.valZE[3] - SistemaFL.dist[2];
                if (SistemaFL.valZE[1] > SistemaFL.valZE[2] - SistemaFL.dist[1])
                    SistemaFL.valZE[1] = SistemaFL.valZE[2] - SistemaFL.dist[1];
                if (SistemaFL.valZE[4] < SistemaFL.valZE[3] + SistemaFL.dist[3])
                    SistemaFL.valZE[4] = SistemaFL.valZE[3] + SistemaFL.dist[3];
                if (SistemaFL.valZE[5] < SistemaFL.valZE[4] + SistemaFL.dist[4])
                    SistemaFL.valZE[5] = SistemaFL.valZE[4] + SistemaFL.dist[4];
                if (SistemaFL.valZE[6] < SistemaFL.valZE[5] + SistemaFL.dist[5])
                    SistemaFL.valZE[6] = SistemaFL.valZE[5] + SistemaFL.dist[5];

                                //  Corrige los valores de sus correderas
                ExactoFL.sliderValZE[1].setValue ((int) SistemaFL.valZE[1]);
                ExactoFL.sliderValZE[2].setValue ((int) SistemaFL.valZE[2]);
                ExactoFL.sliderValZE[4].setValue ((int) SistemaFL.valZE[4]);
                ExactoFL.sliderValZE[5].setValue ((int) SistemaFL.valZE[5]);
                ExactoFL.sliderValZE[6].setValue ((int) SistemaFL.valZE[6]);

                calcula = 1;
            }


            //-------------------       Lente 4        -----------------------


            if ((tf == labelValZE[4]) || (tf == labelValHE[4]) 
                           || (tf == labelValBE[4]) || (tf == labelValNE[4])
                           || (tf == labelValAE[4]))
            {

                datosElemento (s1, tf, 4);

                diste[3] = dze2[3] - dze1[4];
                distb[3] = dzb2[3] - dzb1[4];
                if (diste[3] > distb[3])
                    SistemaFL.dist[3] = diste[3];
                else
                    SistemaFL.dist[3] = distb[3];

                diste[4] = dze2[4] - dze1[5];
                distb[4] = dzb2[4] - dzb1[5];
                if (diste[4] > distb[4])
                    SistemaFL.dist[4] = diste[4];
                else
                    SistemaFL.dist[4] = distb[4];


                        //  Empuja las otras lentes si hace falta

                if (SistemaFL.valZE[3] > SistemaFL.valZE[4] - SistemaFL.dist[3])
                    SistemaFL.valZE[3] = SistemaFL.valZE[4] - SistemaFL.dist[3];
                if (SistemaFL.valZE[2] > SistemaFL.valZE[3] - SistemaFL.dist[2])
                    SistemaFL.valZE[2] = SistemaFL.valZE[3] - SistemaFL.dist[2];
                if (SistemaFL.valZE[1] > SistemaFL.valZE[2] - SistemaFL.dist[1])
                    SistemaFL.valZE[1] = SistemaFL.valZE[2] - SistemaFL.dist[1];
                if (SistemaFL.valZE[5] < SistemaFL.valZE[4] + SistemaFL.dist[4])
                    SistemaFL.valZE[5] = SistemaFL.valZE[4] + SistemaFL.dist[4];
                if (SistemaFL.valZE[6] < SistemaFL.valZE[5] + SistemaFL.dist[5])
                    SistemaFL.valZE[6] = SistemaFL.valZE[5] + SistemaFL.dist[5];


                                //  Corrige los valores de sus correderas
                ExactoFL.sliderValZE[1].setValue ((int) SistemaFL.valZE[1]);
                ExactoFL.sliderValZE[2].setValue ((int) SistemaFL.valZE[2]);
                ExactoFL.sliderValZE[3].setValue ((int) SistemaFL.valZE[3]);
                ExactoFL.sliderValZE[5].setValue ((int) SistemaFL.valZE[5]);
                ExactoFL.sliderValZE[6].setValue ((int) SistemaFL.valZE[6]);

                calcula = 1;
            }


            //-------------------       Lente 5        -----------------------

            if ((tf == labelValZE[5]) || (tf == labelValHE[5]) 
                           || (tf == labelValBE[5]) || (tf == labelValNE[5])
                           || (tf == labelValAE[5]))
            {

                datosElemento (s1, tf, 5);

                diste[4] = dze2[4] - dze1[5];
                distb[4] = dzb2[4] - dzb1[5];
                if (diste[4] > distb[4])
                    SistemaFL.dist[4] = diste[4];
                else
                    SistemaFL.dist[4] = distb[4];

                diste[5] = dze2[5] - dze1[6];
                distb[5] = dzb2[5] - dzb1[6];
                if (diste[5] > distb[5])
                    SistemaFL.dist[5] = diste[5];
                else
                    SistemaFL.dist[5] = distb[5];


                        //  Empuja las otras lentes si hace falta

                if (SistemaFL.valZE[4] > SistemaFL.valZE[5] - SistemaFL.dist[4])
                    SistemaFL.valZE[4] = SistemaFL.valZE[5] - SistemaFL.dist[4];
                if (SistemaFL.valZE[3] > SistemaFL.valZE[4] - SistemaFL.dist[3])
                    SistemaFL.valZE[3] = SistemaFL.valZE[4] - SistemaFL.dist[3];
                if (SistemaFL.valZE[2] > SistemaFL.valZE[3] - SistemaFL.dist[2])
                    SistemaFL.valZE[2] = SistemaFL.valZE[3] - SistemaFL.dist[2];
                if (SistemaFL.valZE[1] > SistemaFL.valZE[2] - SistemaFL.dist[1])
                    SistemaFL.valZE[1] = SistemaFL.valZE[2] - SistemaFL.dist[1];
                if (SistemaFL.valZE[6] < SistemaFL.valZE[5] + SistemaFL.dist[5])
                    SistemaFL.valZE[6] = SistemaFL.valZE[5] + SistemaFL.dist[5];

                                //  Corrige los valores de sus correderas

                ExactoFL.sliderValZE[1].setValue ((int) SistemaFL.valZE[1]);
                ExactoFL.sliderValZE[2].setValue ((int) SistemaFL.valZE[2]);
                ExactoFL.sliderValZE[3].setValue ((int) SistemaFL.valZE[3]);
                ExactoFL.sliderValZE[4].setValue ((int) SistemaFL.valZE[4]);
                ExactoFL.sliderValZE[6].setValue ((int) SistemaFL.valZE[6]);

                calcula = 1;
            }

            //-------------------       Lente 6        -----------------------


            if ((tf == labelValZE[6]) || (tf == labelValHE[6]) 
                           || (tf == labelValBE[6]) || (tf == labelValNE[6])
                           || (tf == labelValAE[6]))
            {

                datosElemento (s1, tf, 6);

                diste[5] = dze2[5] - dze1[6];
                distb[5] = dzb2[5] - dzb1[6];
                if (diste[5] > distb[5])
                    SistemaFL.dist[5] = diste[5];
                else
                    SistemaFL.dist[5] = distb[5];


                        //  Empuja las otras lentes si hace falta

                if (SistemaFL.valZE[5] > SistemaFL.valZE[6] - SistemaFL.dist[5])
                    SistemaFL.valZE[5] = SistemaFL.valZE[6] - SistemaFL.dist[5];
                if (SistemaFL.valZE[4] > SistemaFL.valZE[5] - SistemaFL.dist[4])
                    SistemaFL.valZE[4] = SistemaFL.valZE[5] - SistemaFL.dist[4];
                if (SistemaFL.valZE[3] > SistemaFL.valZE[4] - SistemaFL.dist[3])
                    SistemaFL.valZE[3] = SistemaFL.valZE[4] - SistemaFL.dist[3];
                if (SistemaFL.valZE[2] > SistemaFL.valZE[3] - SistemaFL.dist[2])
                    SistemaFL.valZE[2] = SistemaFL.valZE[3] - SistemaFL.dist[2];
                if (SistemaFL.valZE[1] > SistemaFL.valZE[2] - SistemaFL.dist[1])
                    SistemaFL.valZE[1] = SistemaFL.valZE[2] - SistemaFL.dist[1];

                                //  Corrige los valores de sus correderas

                ExactoFL.sliderValZE[1].setValue ((int) SistemaFL.valZE[1]);
                ExactoFL.sliderValZE[2].setValue ((int) SistemaFL.valZE[2]);
                ExactoFL.sliderValZE[3].setValue ((int) SistemaFL.valZE[3]);
                ExactoFL.sliderValZE[4].setValue ((int) SistemaFL.valZE[4]);
                ExactoFL.sliderValZE[5].setValue ((int) SistemaFL.valZE[5]);

                calcula = 1;
            }


            //-----------     Renueva el dibujo del sistema     ---------------

                       //       Calcula el sistema

            calculaSistema (calcula);
        }
    }


    //===============         Calcula el sistema            ===================

    static    void    calculaSistema (int calcula)
    {
        double  sp;

        switch (calcula)
        {
            case 0:
                canvasExactoFL.redraw ();
                canvasDiagramas.redraw ();
                break;


            case 1:

                if (FuncionesExactasFL.preparaSistema () == 1)
                {
                    FuncionesExactasFL.marchaParaxial ();
                    sp = (int) (FuncionesExactasFL.imagParax * 10.) / 10.;
                    labelValZParax.setText (sp + " mm");

                    if (FuncionesExactasFL.preparaRayos () == 1)
                    {
                        FuncionesExactasFL.propagaHazRayos ();
                    }
                }


                canvasExactoFL.redraw ();
                canvasDiagramas.redraw ();
                break;

            case 2:

                canvasExactoFL.redraw ();
                canvasDiagramas.redraw ();
                break;

            case 3:

                canvasDiagramas.redraw ();
                break;

        }   
    }


    //===============   Calcula los datos de un elemento    ===================


    void datosElemento (JSlider s1, JLabel tf, int i)
    {
        double  potencia, focal, doblado;

                    //      Posicin

        if (tf == labelValZE[i])  
        {
            SistemaFL.valZE[i] = (double) s1.getValue ();
            tf.setText (SistemaFL.valZE[i] + " mm");
        }

                    //      Potencia

        if (tf == labelValHE[i])
        {

            if (SistemaFL.tipoE[i] == 1)          //  Es lente
            {
                SistemaFL.valPE[i] = s1.getValue () / 10.;
                datosLente (i);
            }
            else                        //  Es diafragma
            {
                SistemaFL.valDE[i] = (double) s1.getValue ();
                SistemaFL.altura[i] = SistemaFL.valDE[i] / 2.;
                if (SistemaFL.valDE[i] != diamMax)
                {
                    tf.setText (SistemaFL.valDE[i] + unidad[i]);
                    sliderValZE[i].setEnabled (true);
                    SistemaFL.existe[i] = 1;
                    SistemaFL.radio[i] = 1000.e10;
                    SistemaFL.radioDib[i] = 1000.e10;
                }
                else
                {
                    tf.setText ("---");
                    sliderValZE[i].setEnabled (false);
                    SistemaFL.existe[i] = 0;
                }
            }          

        }

                    //      Doblado

        if (tf == labelValBE[i])
        {
            valBE[i] = s1.getValue ();
            datosLente (i);
        }

                    //      Indice

        if (tf == labelValNE[i])
        {
            indice[i] = s1.getValue () / 100.;
            labelValNE[i].setText (indice[i] + "");

            SistemaFL.valPE[i] = 1000. * (indice[i] - 1.) * (curv1[i] - curv2[i]);
            potencia = (int) (10. * SistemaFL.valPE[i]) / 10.;
            labelValHE[i].setText (potencia + unidad[i]);

//            int pot = (int) (SistemaFL.valPE[i] * 10.);
//            sliderValHE[i].setValue (pot);

            focal = (int) (10000. / SistemaFL.valPE[i]) / 10.;
            labelValFE[i].setText (focal + " mm");
        }

                    //      N de Abbe

        if (tf == labelValAE[i])
        {
            abbe[i] = s1.getValue () / 10.;
            labelValAE[i].setText (abbe[i] + "");
        }

    }


    //===============   Calcula los datos de una lente    ===================


    void datosLente (int i)
    {
        double     focal, doblado, delta, rad, absCurv1, absCurv2;
        double     radDib1, radDib2, absRadDib1, absRadDib2, f, rDib;
        double     signo1, signo2, curvMax = 0.01, radMin = 20.;


        if (SistemaFL.valPE[i] > 0)
        {
            SistemaFL.valDibPE[i] = SistemaFL.valPE[i] + 8.;
        }
        else
        {
            SistemaFL.valDibPE[i] = SistemaFL.valPE[i] - 8.;
        }

        rDib = .5;


        labelValHE[i].setText (SistemaFL.valPE[i] + unidad[i]);

        if (SistemaFL.valPE[i] != 0)          //  Hay lente
        {
            focal = (int) (10000. / SistemaFL.valPE[i]) / 10.;
            labelValFE[i].setText (focal + " mm");
    
                            //  Activa la corredera de la posicin

            sliderValZE[i].setEnabled (true);

                            //  Activa el doblado

            sliderValBE[i].setEnabled (true);

                            //  Activa el ndice

            labelValNE[i].setText (indice[i] + "");
            sliderValNE[i].setEnabled (true);

            if (numColores == 3)        //  Si es en color activa el n de Abbe
            {
                labelValAE[i].setText (abbe[i] + "");
                sliderValAE[i].setEnabled (true);
            }
            else
            {
                labelValAE[i].setText ("---");
                sliderValAE[i].setEnabled (false);
            }

            SistemaFL.existe[i] = 1;

                            //  Calcula los radios como lente simtrica

            SistemaFL.curv[i] = SistemaFL.valPE[i] / (2. * indiceDib - 2.);
            if (Math.abs (SistemaFL.curv[i]) <= 1.e-10)
            {
                SistemaFL.radio[i] = 1000.e10;
            }
            else
            {
                SistemaFL.radio[i] = 2000. * (indiceDib - 1.) / SistemaFL.valPE[i];
            }
            SistemaFL.radioDib[i] = SistemaFL.radio[i] * rDib;

                            //  Calcula los radios como lente doblada

            doblado = valBE[i] / 2.;
            delta = SistemaFL.valPE[i] / (indice[i] - 1.);   

            curv1[i] = (doblado + delta) / 2000.;

            curv2[i] = (doblado - delta) / 2000.;


                                    //  Radio 1

            absCurv1 = Math.abs (curv1[i]);
            signo1 = curv1[i] / absCurv1;
            if (absCurv1 <= 1.e-10)
            {
                radio1[i] = 1000.e10;
            }
            else
            {
                radio1[i] = 1. / curv1[i];
            }
                       

            if (Math.abs (radio1[i]) < radMin / rDib)
            {
                radio1[i] = signo1 * radMin / rDib;
                curv1[i] = 1. / radio1[i];
                curv2[i] = curv1[i] - delta / 1000.;
            }
            radDib1 = radio1[i] * rDib;
    

                                    //  Radio 2

            absCurv2 = Math.abs (curv2[i]);
            signo2 = curv2[i] / absCurv2;
            if (absCurv2 <= 1.e-10)
            {
                radio2[i] = 1000.e10;
            }
            else
            {
                radio2[i] = 1. / curv2[i];
            }
                       
            if (Math.abs (radio2[i]) < radMin / rDib)
            {
                radio2[i] = signo2 * radMin / rDib;
                curv2[i] = 1. / radio2[i];
                curv1[i] = curv2[i] + delta / 1000.;

                absCurv1 = Math.abs (curv1[i]);
                if (absCurv1 <= 1.e-10)
                {
                    radio1[i] = 1000.e10;
                }
                else
                {
                    radio1[i] = 1. / curv1[i];
                }
            }

            radDib1 = radio1[i] * rDib;
            radDib2 = radio2[i] * rDib;

            radioDib1[i] = radDib1;
            valDib1PE[i] = 500. / radioDib1[i];
            rad = (double) ((int) (radio1[i] * 10.)) / 10.; 
            labelValR1E[i].setText (rad + " mm");

            radioDib2[i] = radDib2;
            valDib2PE[i] = 500. / radioDib2[i];
            rad = (double) ((int) (radio2[i] * 10.)) / 10.; 
            labelValR2E[i].setText (rad + " mm");

                            //      Calcula el espesor


            if (SistemaFL.valPE[i] < 0.)
                espesor[i] = 3.;
            else
                espesor[i] = SistemaFL.valPE[i] * 2.;
        }
        else               //       No hay lente
        {
            labelValFE[i].setText ("---");
            labelValR1E[i].setText ("---");
            labelValR2E[i].setText ("---");
            labelValNE[i].setText ("---");
            labelValAE[i].setText ("---");
            sliderValZE[i].setEnabled (false);
            sliderValBE[i].setEnabled (false);
            sliderValNE[i].setEnabled (false);
            sliderValAE[i].setEnabled (false);
            SistemaFL.existe[i] = 0;
        }
    }

    //-------------------------------------------------------------------------

    static public  void datosCorrederaHLente (int i)
    {
                                        //  "setValue" ha de ser lo primero

        sliderValHE[i].setValue ((int) (SistemaFL.valPE[i] * 10.));
        sliderValHE[i].setMinimum (-200);
        sliderValHE[i].setMaximum (200);
        sliderValHE[i].setPaintTicks (true);
        sliderValHE[i].setMajorTickSpacing (100);
        sliderValHE[i].setMinorTickSpacing (20);
        sliderValHE[i].setBounds (80, 100, 190, 30);
    }

    //-------------------------------------------------------------------------

    static public  void datosCorrederaHDiafragma (int i)
    {
                                        //  "setValue" ha de ser lo primero

        sliderValHE[i].setValue ((int) SistemaFL.valDE[i]);
        sliderValHE[i].setMinimum (0);
        sliderValHE[i].setMaximum (diamMax);
        sliderValHE[i].setPaintTicks (true);
        sliderValHE[i].setMajorTickSpacing (10);
        sliderValHE[i].setMinorTickSpacing (2);
        sliderValHE[i].setBounds (80, 100, 190, 30);
    }


}
                                                                                                                                                                
                                                                                                                                                                
