/**************************************************************************\
*                                                                          *
*   Clase que contiene las funciones de clculo para elementos cardinales  *
*                                                                          *
\**************************************************************************/


import java.awt.*;

public class FuncionesCardinalesFL
{


    /**********************************************************************\
    *                                                                      *
    *                   Funciones del trazado de rayos                     *    
    *                                                                      *
    \**********************************************************************/


    //=====================     tablaTramosCard     ============================

    //  Crea la tabla de tramos para los rayos de los puntos cardinales

    static int     tablaTramosCard ()
    {
        int     i, n;

        for (i = 0; i <= AnteproyectoFL.numElementos; i ++)
            AnteproyectoFL.tramoCard[i] = AnteproyectoFL.elemento[i];
        AnteproyectoFL.numTramosCard = AnteproyectoFL.numElementos + 1;
        AnteproyectoFL.tramoCard[i] = 7;


        if (AnteproyectoFL.numTramosCard < 2)
            return 0;       //  No hay tramos definidos


        return 1;
    }


    //=====================     marchaParaxialCard      ========================

    //  Calcula la posicin y tamao de las imgenes para cada elemento
    //  Si obj = 0 es la marcha de izquierda a derecha
    //  Si obj = 1 es la marcha de derecha a izquierda

    static int     marchaParaxialCard (int obj)
    {
        int     i, ia, ip, k, n;
        double  zE, zS, zSp, s, fp, sp, a, ap, h, b, bp;
        double  max, factor;

        n = AnteproyectoFL.numElementos;

        if (n < 1)          //  No hay elementos definidos
            return 0;


        if (obj == 0)       //  Marcha de izquierda a derecha
        {
                                            //  Datos del rayo incidente
            
            AnteproyectoFL.aRayoCard[obj][0] = 0.; 
            AnteproyectoFL.bRayoCard[obj][0] = 10.; 
            AnteproyectoFL.apRayoCard[obj][0] = 0.; 
            AnteproyectoFL.bpRayoCard[obj][0] = 10.; 
            

            for (k = 1; k <= n+1; k ++)
            {
                i = AnteproyectoFL.elemento[k];
                ia= AnteproyectoFL.elemento[k-1];

                a = AnteproyectoFL.apRayoCard[obj][ia];
                b = AnteproyectoFL.bpRayoCard[obj][ia];

                if (a == 0)
                    zS = 1.e10;
                else
                    zS = - b / a;

                zE = SistemaFL.valZE[i];
                h = a * zE + b;
                AnteproyectoFL.fRayoCard[obj][i] = Math.abs (h) / SistemaFL.valDE[i];

                s = zS - zE;
                if (SistemaFL.tipoE[i] == 0)        //  Es diafragma
                {
                    ap = a;
                    bp = b;
                }
                else                                    //  Es lente
                {
                    fp = 1000. / SistemaFL.valPE[i];
                    if (s == -fp)
                    {
                        sp = 1.e10;
                    }
                    else
                    {
                        sp = s * fp / (fp + s);
                    }

                    zSp = zE + sp;


                    if (sp == 0)
                    {
                        ap = 1.e10;
                    }
                    else
                    {
                        ap =  - h / sp;
                    }

                    bp = - ap * zSp;

                }

                AnteproyectoFL.aRayoCard[obj][i] = a;
                AnteproyectoFL.apRayoCard[obj][i] = ap;
                AnteproyectoFL.bRayoCard[obj][i] = b;
                AnteproyectoFL.bpRayoCard[obj][i] = bp;

            }

                                    //  Posicin del foco imagen

            AnteproyectoFL.zF[obj] = - AnteproyectoFL.bRayoCard[obj][7] /
                                     AnteproyectoFL.aRayoCard[obj][7];

                                    //  Posicin del punto principal imagen

            AnteproyectoFL.zH[obj] = -
               (AnteproyectoFL.bRayoCard[obj][7] - AnteproyectoFL.bpRayoCard[obj][0]) /
               (AnteproyectoFL.aRayoCard[obj][7] - AnteproyectoFL.apRayoCard[obj][0]);

        }
        else                //  Marcha de derecha a izquierda
        {
                                            //  Datos del rayo incidente
            
            AnteproyectoFL.aRayoCard[obj][7] = 0.; 
            AnteproyectoFL.bRayoCard[obj][7] = 10.; 
            AnteproyectoFL.apRayoCard[obj][7] = 0.; 
            AnteproyectoFL.bpRayoCard[obj][7] = 10.; 
            

            for (k = n; k >= 0; k --)
            {
                i = AnteproyectoFL.elemento[k];
                ip= AnteproyectoFL.elemento[k+1];

                ap = AnteproyectoFL.aRayoCard[obj][ip];
                bp = AnteproyectoFL.bRayoCard[obj][ip];

                if (ap == 0)
                    zSp = 1.e10;
                else
                    zSp = - bp / ap;

                zE = SistemaFL.valZE[i];
                h = ap * zE + bp;
                AnteproyectoFL.fRayoCard[obj][i] = Math.abs (h) / SistemaFL.valDE[i];
                sp = zSp - zE;
            
                if (SistemaFL.tipoE[i] == 0)        //  Es diafragma
                {
                    a = ap;
                    b = bp;
                }
                else                                    //  Es lente
                {
                    fp = 1000. / SistemaFL.valPE[i];
                    if (sp == fp)
                    {
                        s = 1.e10;
                    }
                    else
                    {
                        s = sp * fp / (fp - sp);
                    }

                    zS = zE + s;


                    if (s == 0)
                    {
                        a = 1.e10;
                    }
                    else
                    {
                        a =  - h / s;
                    }

                    b = - a * zS;

                }

                AnteproyectoFL.aRayoCard[obj][i] = a;
                AnteproyectoFL.apRayoCard[obj][i] = ap;
                AnteproyectoFL.bRayoCard[obj][i] = b;
                AnteproyectoFL.bpRayoCard[obj][i] = bp;

            }


                                    //  Posicin del foco objeto

            AnteproyectoFL.zF[obj] = - AnteproyectoFL.bpRayoCard[obj][0] /
                                     AnteproyectoFL.apRayoCard[obj][0];


                                    //  Posicin del punto principal objeto

            AnteproyectoFL.zH[obj] = -
               (AnteproyectoFL.bRayoCard[obj][7] - AnteproyectoFL.bpRayoCard[obj][0]) /
               (AnteproyectoFL.aRayoCard[obj][7] - AnteproyectoFL.apRayoCard[obj][0]);


        }

        return 1;
    }



    //=======================   normalizaCoeficientes   =========================

    //  Normaliza los coeficientes de los rayos
    //  Normaliza el trazado para el borde de las lentes

    static int  normalizaCoeficientes ()
    {
        int     i, k, n, obj;
        double  max;


        n = AnteproyectoFL.numElementos;

                        //  Busca el factor de relacin mximo

        max = 0.;
        for (obj = 0; obj < 2; obj ++)
        {
            for (k = 1; k <= n; k ++)
            {
                i = AnteproyectoFL.elemento[k];
                if (max < AnteproyectoFL.fRayoCard[obj][i])
                    max = AnteproyectoFL.fRayoCard[obj][i];
            }
        }
        max = max * 2.;

        for (obj = 0; obj < 2; obj ++)
        {
            for (k = 0; k <= n+1; k ++)
            {
                i = AnteproyectoFL.elemento[k];
                AnteproyectoFL.aRayoCard[obj][i] = AnteproyectoFL.aRayoCard[obj][i] / max;
                AnteproyectoFL.bRayoCard[obj][i] = AnteproyectoFL.bRayoCard[obj][i] / max;
                AnteproyectoFL.apRayoCard[obj][i] = AnteproyectoFL.apRayoCard[obj][i] / max;
                AnteproyectoFL.bpRayoCard[obj][i] = AnteproyectoFL.bpRayoCard[obj][i] / max;
            }
        }

        return 1;
    }



    //=======================   interseccionesRayos   =========================


    //  Calcula las intersecciones de los rayos con las superficies


    static int  interseccionesRayosCard (int obj)
    {
        int     i, ip, j, k, n;
        double  zE, ap, bp, zEp;

        n = AnteproyectoFL.numTramosCard;


                //  Calcula las intersecciones de cada rayo
                //  a la salida del elemento k y entrada del k+1

        
        for (k = 0; k <= n; k ++)
        {
            i = AnteproyectoFL.tramoCard[k];
            ip = AnteproyectoFL.tramoCard[k+1];
           
            ap = AnteproyectoFL.apRayoCard[obj][i];
            bp = AnteproyectoFL.bpRayoCard[obj][i];
            zE = SistemaFL.valZE[i];
            zEp = SistemaFL.valZE[ip];
           
           
                            //  Interseccin a la salida del elemento k
           
            if (i == 0)             //  Es el objeto
            {
                AnteproyectoFL.zpRayoCard[obj][0] = zE;
                AnteproyectoFL.ypRayoCard[obj][0] =
                            AnteproyectoFL.bpRayoCard[obj][0];
            }
            else
            {
                Caja.doble1 = ap;
                Caja.doble2 = bp;
                Caja.doble3 = zE + SistemaFL.espesor[i] / 2.;
                Caja.doble4 = - SistemaFL.radioDib[i];
           
                FuncionesParaxialesFL.rectaEsfera ();
           
                AnteproyectoFL.zpRayoCard[obj][i] = Caja.doble1;
                AnteproyectoFL.ypRayoCard[obj][i] = Caja.doble2;
            }
           
                            //  Interseccin a la entrada del elemento k+1
           
            if (ip == 7)             //  Es el borde derecho
            {
                AnteproyectoFL.zaRayoCard[obj][ip] = 1600;
                AnteproyectoFL.yaRayoCard[obj][ip] = AnteproyectoFL.aRayoCard[obj][ip] *
                      1600 + AnteproyectoFL.bRayoCard[obj][ip];
            }
            else
            {
                Caja.doble1 = ap;
                Caja.doble2 = bp;
                Caja.doble3 = zEp - SistemaFL.espesor[ip] / 2.;
                Caja.doble4 = SistemaFL.radioDib[ip];
           
                FuncionesParaxialesFL.rectaEsfera ();
           
                AnteproyectoFL.zaRayoCard[obj][ip] = Caja.doble1;
                AnteproyectoFL.yaRayoCard[obj][ip] = Caja.doble2;
            }

        }

        return 1;
    }

}
