/**************************************************************************\
*                                                                          *
*          Clase que contiene las funciones de clculo exacto              *
*                                                                          *
\**************************************************************************/


import java.awt.*;

public class FuncionesExactasFC
{


    /**********************************************************************\
    *                                                                      *
    *                   Funciones del trazado de rayos                     *    
    *                                                                      *
    \**********************************************************************/

                //  Datos generales

    static int numSup;              //  Nmero de superficies y diafraggmas
    static int numColores;          //  0 Monocromtico,  1 En color
    static double   imagParax;      //  Posicin de la imagen paraxial

                //  Datos para las superficies
                    //  El subndice 0 es el objeto
                    //  Los dems van de 1 a 12 o 13

    static double curv[] = new double[15];      //  Curvatura de la superficie
    static double r[] = new double[15];         //  Radio de curvatura
    static double v[] = new double[15];         //  Vrtice de la superficie
    static double d[] = new double[15];         //  Distancia desde la anterior
    static double hmax [] = new double[15];     //  Radio de la abertura
    static double ene[][] = new double[3][15];  //  Indice de refraccin anterior

                //  Datos de los rayos

                //  Los subndices corresponden:
                //  El 1 al punto del objeto (0 eje, 1 extremo)
                //  El 2 al color (0 verde, 1 azul, 2 rojo).
                //  El 3 a la superficie a la que llega el rayo.
                //  El subndice 1 es espacio objeto.
                //  El 4 al rayo j.

                            //  Para rayos en plano meridiano

    static int pasam[][][][] = new int[2][3][15][251]; //1 si pasa el rayo, 0 si no.

                            //  Para rayos cruzados

    static int pasa[][][][] = new int[2][3][15][251]; // 1 si pasa el rayo, 0 si no.

                //      Coeficientes de las rectas de los rayos

                            //  Para rayos en plano meridiano

    static double cmRayo[][][][] = new double[2][3][15][21];    
    static double dmRayo[][][][] = new double[2][3][15][21];  //    ( y = cz + d )

                            //  Para rayos cruzados

    static double aRayo[][][][] = new double[2][3][15][251];    
    static double bRayo[][][][] = new double[2][3][15][251];  //    ( x = az + b )
    static double cRayo[][][][] = new double[2][3][15][251];    
    static double dRayo[][][][] = new double[2][3][15][251];  //    ( y = cz + d )

                //      Intersecciones de los rayos con las superficies

                            //  Para rayos en plano meridiano

    static double zmRayo[][][][] = new double[2][3][15][21];    
    static double ymRayo[][][][] = new double[2][3][15][21];  //    ( y = cz + d )

                            //  Para rayos cruzados

    static double zRayo[][][][] = new double[2][3][15][251]; 
    static double xRayo[][][][] = new double[2][3][15][251]; 
    static double yRayo[][][][] = new double[2][3][15][251];      

    static double hRayo[][][]  = new double[3][15][251];  //  Altura del rayo en el
                                                          //  elemento (paraxial).



    //=====================     preparaSistema    =============================

    //  Prepara los datos a partir de los valores de ExactoFC.java

    static int    preparaSistema ()
    {
        int     i, j = 0;
        double  delta;


        if (SistemaFC.existeObjeto[0] == 0)   //  No hay objeto definido
        {
            ExactoFC.dibuja = 0;
            return 0;                   
        }

        numColores = ExactoFC.numColores;

        for (i = 1; i < 7; i ++)
        {
            if (SistemaFC.existe[i] != 0) 
            {
                    //  Si el objeto es real no dibuja si est dentro de una lente

                if ((SistemaFC.real[0] == 1) && 
                    (SistemaFC.zObjeto[0] >= SistemaFC.valZE[i] - ExactoFC.espesor[i] / 2) &&
                    (SistemaFC.zObjeto[0] <= SistemaFC.valZE[i] + ExactoFC.espesor[i] / 2))
                {
                    ExactoFC.dibuja = 0;
                    return 0;                   
                }

                    //  Si el objeto es real, no cuenta las lentes que haya delante

                if ((SistemaFC.real[0] == 1) && (SistemaFC.zObjeto[0] > SistemaFC.valZE[i]))
                {
                    continue;
                }

                j ++;

                ene[0][j] = 1.;         //  Delante de todo elemento est el aire
                if (numColores != 0)
                {
                    ene[1][j] = ene[2][j] = 1.;
                }

                if (SistemaFC.tipoE[i] == 0)           //  Es diafragma
                {

                    ExactoFC.dze1[i] = 0.;
                    ExactoFC.dze2[i] = 0.;

                    ExactoFC.dzb1[i] = 0.;
                    ExactoFC.dzb2[i] = 0.;

                    v[j] = SistemaFC.valZE[i];
                    curv[j] = 0.;
                    r[j] = 1.e10;
                    hmax[j] = SistemaFC.altura[i];

                    ene[0][j+1] = 1.;         //  Detrs del diafragma est el aire
                    if (numColores != 0)
                    {
                        ene[1][j+1] = ene[2][j+1] = 1.;
                    }
                }
                else                                //  Es lente
                {
                    ExactoFC.dze1[i] = - ExactoFC.espesor[i] / 2.;
                    ExactoFC.dze2[i] = ExactoFC.espesor[i] / 2.;

                    v[j] = SistemaFC.valZE[i] + ExactoFC.dze1[i];
                    curv[j] = ExactoFC.curv1[i];
                    r[j] = ExactoFC.radio1[i];
                    hmax[j] = SistemaFC.altura[i];

                    v[j+1] = SistemaFC.valZE[i] + ExactoFC.dze2[i];
                    curv[j+1] = ExactoFC.curv2[i];
                    r[j+1] = ExactoFC.radio2[i];
                    hmax[j+1] = SistemaFC.altura[i];

                    ene[0][j+1] = ExactoFC.indice[i];
                    if (numColores != 1)
                    {
                        delta = (ExactoFC.indice[i] - 1.) / ExactoFC.abbe[i];
                        ene[1][j+1] = ExactoFC.indice[i] + delta;
                        ene[2][j+1] = ExactoFC.indice[i] - delta;
                    }

                    j ++;
                }
            }
                                                  
        }

        if (j == 0)                     //  No hay elementos definidos
        {
            ExactoFC.dibuja = 0;
            return 0;                   
        }

        numSup = j;

                        //  La superficie "numSup+1" es el borde derecho del dibujo

            r[numSup+1] = 1000.e10;
            v[numSup+1] = 1600.;
            ene[0][numSup+1] = 1.;         //  Al final de todo est el aire
            if (numColores != 0)
            {
                ene[1][numSup+1] = ene[2][numSup+1] = 1.;
            }

        v[0] = SistemaFC.zObjeto[0];

        for (j = 1; j <= numSup; j ++)
        {
            d[j-1] = v[j] - v[j-1];
        }

        ExactoFC.dibuja = 1;
        return 1;
    }


    //=====================     marchaParaxial      ========================


    static int     marchaParaxial ()
    {
        int     i, j, k;
        double  tg, sigma, alt, alta, sigp, focal, salid, alta1 = 10.;


        if (SistemaFC.existeObjeto[0] == 0)   //  No hay objeto definido
            return 0;                   
        if (ExactoFC.dibuja == 0)
            return 0;                   

        tg = Math.tan (SistemaFC.campo[0] * 3.151592 / 180.);

        SistemaFC.valYObj[0] = d[0] * tg;


                //  Marcha paraxial de rayo paralelo para hallar la focal                  

        sigma = 0.;
        alta = alta1;

        for (i = 1; i <= numSup; i ++)      
        {
              alt = alta - d[i-1] * sigma;
              sigp = (alt * (ene[0][i+1] - ene[0][i]) * curv[i] + 
                      sigma * ene[0][i]) / ene[0][i+1];
              alta = alt;
              sigma = sigp;
        }                      
        focal = alta1 / sigma;


                //  Segunda marcha paraxial para hallar la imagen

        sigma = alta1 / d[0];
        alta = 0.;

        for (i = 1; i <= numSup; i ++)      
        {
              alt = alta - d[i-1] * sigma;
              sigp = (alt * (ene[0][i+1] - ene[0][i]) * curv[i] + 
                      sigma * ene[0][i]) / ene[0][i+1];
              alta = alt;
              sigma = sigp;
        }                      


                //  Clculo de imagen paraxial               

        salid = alta / sigma;
        imagParax = v[numSup] + salid;

        return 1;
    }



    //=====================     preparaRayos    =============================

    //  Calcula los coeficientes a, b, de los rayos en espacio objeto
    //  Utiliza las coordenadas verdaderas


    static int    preparaRayos ()
    {
        int     i, j, k;
        double  rPup, hp;
        double  f, tg, tgMax = .5;

        double zObj = SistemaFC.zObjeto[0];
        double yObj = SistemaFC.valYObj[0];

        if (ExactoFC.dibuja == 0)
            return 0;                   

        if (d[0] == 0)
            return 0;


                            //  Limita el ngulo de abertura
        tg = Math.abs (hmax[1] * ExactoFC.hpr[ExactoFC.nir] / d[0]);
        if (tg > tgMax)
            f = tgMax / tg;
        else
            f = 1.;
        rPup = hmax[1] * f;     //  Radio de la primera abertura (Hace de pupila) 

                            //  Coeficientes de los rayos en espacio objeto

                                        //  Rayos meridianos del punto del eje

        for (j = 0; j <= ExactoFC.nir; j ++)
        {
            cmRayo[0][0][1][j] = cmRayo[0][1][1][j] = cmRayo[0][2][1][j] = 
                              rPup * ExactoFC.hpr[j] / d[0];
            dmRayo[0][0][1][j] = dmRayo[0][1][1][j] = dmRayo[0][2][1][j] =
                              - zObj * cmRayo[0][0][1][j];
            pasam[0][0][0][j] = pasam[0][1][0][j] = pasam[0][2][0][j] = 1;
        }

        for (j = ExactoFC.nir + 1; j <= ExactoFC.nir * 2; j ++)
        {
            cmRayo[0][0][1][j] = cmRayo[0][1][1][j] = cmRayo[0][2][1][j] = 
                             - rPup * ExactoFC.hpr[j-ExactoFC.nir] / d[0];
            dmRayo[0][0][1][j] = dmRayo[0][1][1][j] = dmRayo[0][2][1][j] =
                              - zObj * cmRayo[0][0][1][j];
            pasam[0][0][0][j] = pasam[0][1][0][j] = pasam[0][2][0][j] = 1;
        }

                                    //  Rayos meridianos del punto de borde

        for (j = 0; j <= ExactoFC.nir; j ++)
        {
            cmRayo[1][0][1][j] = cmRayo[1][1][1][j] = cmRayo[1][2][1][j] = 
                          (rPup * ExactoFC.hpr[j] - yObj) / d[0];
            dmRayo[1][0][1][j] = dmRayo[1][1][1][j] = dmRayo[1][2][1][j] =
                     yObj  - zObj * cmRayo[1][0][1][j];
             
            pasam[1][0][0][j] = pasam[1][1][0][j] = pasam[1][2][0][j] = 1;
        }

        for (j = ExactoFC.nir + 1; j <= ExactoFC.nir * 2; j ++)
        {
            cmRayo[1][0][1][j] = cmRayo[1][1][1][j] = cmRayo[1][2][1][j] = 
                          (- rPup * ExactoFC.hpr[j-ExactoFC.nir] - yObj) / d[0];
            dmRayo[1][0][1][j] = dmRayo[1][1][1][j] = dmRayo[1][2][1][j] =
                     yObj  - zObj * cmRayo[1][0][1][j];
            pasam[1][0][0][j] = pasam[1][1][0][j] = pasam[1][2][0][j] = 1;
        }


                                        //  Rayos cruzados

        for (j = 0; j < ExactoFC.numRayos; j ++)
        {
            aRayo[0][0][1][j] = aRayo[0][1][1][j] = aRayo[0][2][1][j] =
                                rPup * ExactoFC.xpr[j] / d[0];
            bRayo[0][0][1][j] = bRayo[0][1][1][j] = bRayo[0][2][1][j] = 
                                - zObj * aRayo[0][0][1][j];
                                
            cRayo[0][0][1][j] = cRayo[0][1][1][j] = cRayo[0][2][1][j] = 
                                rPup * ExactoFC.ypr[j] / d[0];
            dRayo[0][0][1][j] = dRayo[0][1][1][j] = dRayo[0][2][1][j] = 
                                - zObj * cRayo[0][0][1][j];
                                
            pasa[0][0][0][j] = pasa[0][1][0][j] = pasa[0][2][0][j] = 1;
                                
            aRayo[1][0][1][j] = aRayo[1][1][1][j] = aRayo[1][2][1][j] = 
                                aRayo[0][0][1][j];
            bRayo[1][0][1][j] = bRayo[1][1][1][j] = bRayo[1][2][1][j] = 
                                bRayo[0][0][1][j];
                                
            cRayo[1][0][1][j] = cRayo[1][1][1][j] = cRayo[1][2][1][j] = 
                                (rPup * ExactoFC.ypr[j] - yObj) / d[0];
            dRayo[1][0][1][j] = dRayo[1][1][1][j] = dRayo[1][2][1][j] = 
                                yObj - zObj * cRayo[1][0][1][j];
                                
            pasa[1][0][0][j] = pasa[1][1][0][j] = pasa[1][2][0][j] = 1;
        }

        return 1;
    }




    //=======================    propagaHazRayos    =========================

    static int  propagaHazRayos ()
    {
        int     i, j, k, l;

        if (ExactoFC.dibuja == 0)
            return 0;                   

                    //  Rayos meridianos

        for (l = 0; l < 2; l ++)
        {
            for (k = 0; k < numColores; k ++)
            {
                for (j = 0; j <= ExactoFC.nir * 2; j ++)
                {
                    for (i = 1; i <= numSup+1; i ++)
                    {
                        refractaRayoMerid (l, k, i, j);
                    }
                }
            }
        }


                    //  Rayos cruzados

        for (l = 0; l < 2; l ++)
        {
            for (k = 0; k < numColores; k ++)
            {
                for (j = 0; j <= ExactoFC.numRayos; j ++)
                {
                    for (i = 1; i <= numSup+1; i ++)
                    {
                        refractaRayoCruzado (l, k, i, j);
                    }
                }
            }
        }


        return 1;
    }


    //=======================   refractaRayoMerid     =========================

    static int  refractaRayoMerid (int l, int k, int i, int j)
    {

        //  Toma el vrtice de la superficie como origen de coordenadas

        double  e, da, alfa, alfap, rad, f, pp, yl, zl, g, eneq, ef, af, ap;
        double  sigc;
        double  radio = r[i], h2, r2;
        double  cel = cmRayo[l][k][i][j];

        
        if (pasam[l][k][i-1][j] == 0)
        {
            pasam[l][k][i][j] = 0;
            return 0;
        }


                //     Altura en el plano tangente al vrtice

        double  del = cel * v[i] + dmRayo[l][k][i][j];  

                        //  Calcula la interseccin
    
        h2 = hmax[i] * hmax[i];
        alfa = 1. / Math.sqrt (1. + cel * cel);
        e = radio - cel * del;
        da = 1.+ cel * cel;
        f = del * del;
        rad = e * e - da * f;
        if (rad < 0)                    //  La recta no corta a la esfera
        {
            pasam[l][k][i-1][j] = 0;
            return 0;
        }
        pp = Math.sqrt (rad);
    
        if (e < 0)    
            zl = (e + pp) / da;
        else  
            zl = (e - pp) / da;

        yl =  cel * zl + del;
        ymRayo[l][k][i][j] = yl;

        zmRayo[l][k][i][j] = v[i] + zl;


        r2 = yl * yl;


        if (r2 > h2)    //  El rayo no pasa por la abertura  
        {
            pasam[l][k][i][j] = 0;
            return 0;
        }
        else
            pasam[l][k][i][j] = 1;


                        //  Calcula la refraccin si procede

        eneq = ene[k][i] / ene[k][i+1];

        if (eneq == 1.)         //  Es diafragma o borde derecho del dibujo
        {
            cmRayo[l][k][i+1][j] = cmRayo[l][k][i][j];
            dmRayo[l][k][i+1][j] = dmRayo[l][k][i][j];
        }
        else
        {
            g = (radio - zl - cel * yl) * alfa * eneq / radio;
            ef = 1. + g * g - eneq * eneq;
            if (ef < 0)    
            {
                pasam[l][k][i][j] = 0;
                return 0;
            }
    
            af = (Math.sqrt (ef) - g) / radio;
            ap = eneq * alfa;
            alfap = (radio - zl) * af + ap;
    
            alfa = alfap;
            sigc = ap * cel - yl * af;
            cel = sigc / alfa;
            del = (-v[i] - zl) * cel + yl;
    
            cmRayo[l][k][i+1][j] = cel;
            dmRayo[l][k][i+1][j] = del;
        }

        return 1;
    }



    //=======================   refractaRayoCruzado     =========================

    static int  refractaRayoCruzado (int l, int k, int i, int j)
    {

        //  Toma el vrtice de la superficie como origen de coordenadas

        double  e, da, alfa, alfap, rad, f, pp, xl, yl, zl, g, eneq, ef, af, ap;
        double  sigb, sigc;
        double  radio = r[i], h2, r2;

        double  ael = aRayo[l][k][i][j];
        double  cel = cRayo[l][k][i][j]; 

        
        if (pasa[l][k][i-1][j] == 0)
        {
            pasa[l][k][i][j] = 0;
            return 0;
        }

                //     Altura en el plano tangente al vrtice

        double  bel = ael * v[i] + bRayo[l][k][i][j];  
        double  del = cel * v[i] + dRayo[l][k][i][j];  

                        //  Calcula la interseccin
    
        h2 = hmax[i] * hmax[i];
        alfa = 1. / Math.sqrt (1. + ael * ael + cel * cel);
        e = radio - ael * bel - cel * del;
        da = 1.+ ael * ael + cel * cel;
        f = bel * bel + del * del;
        rad = e * e - da * f;
        if (rad < 0)                    //  La recta no corta a la esfera
        {
            pasa[l][k][i-1][j] = 0;
            return 0;
        }
        pp = Math.sqrt (rad);
    
        if (e < 0)    
            zl = (e + pp) / da;
        else  
            zl = (e - pp) / da;
    
        xl =  ael * zl + bel;
        yl =  cel * zl + del;

        xRayo[l][k][i][j] = xl;
        yRayo[l][k][i][j] = yl;
        zRayo[l][k][i][j] = zl;

        r2 = xl * xl + yl * yl;


        if (r2 > h2)    //  El rayo no pasa por la abertura  
        {
            pasa[l][k][i][j] = 0;
            return 0;
        }
        else
            pasa[l][k][i][j] = 1;


                        //  Calcula la refraccin si procede

        eneq = ene[k][i] / ene[k][i+1];

        if (eneq == 1.)         //  Es diafragma o borde derecho del dibujo
        {
            aRayo[l][k][i+1][j] = aRayo[l][k][i][j];
            bRayo[l][k][i+1][j] = bRayo[l][k][i][j];
            cRayo[l][k][i+1][j] = cRayo[l][k][i][j];
            dRayo[l][k][i+1][j] = dRayo[l][k][i][j];
        }
        else
        {
            g = (radio - zl - ael * xl - cel * yl) * alfa * eneq / radio;
            ef = 1. + g * g - eneq * eneq;
            if (ef < 0)    
            {
                pasa[l][k][i][j] = 0;
                return 0;
            }
    
            af = (Math.sqrt (ef) - g) / radio;
            ap = eneq * alfa;
            alfap = (radio - zl) * af + ap;
    
            alfa = alfap;
            sigb = ap * ael - xl * af;
            sigc = ap * cel - yl * af;
            ael = sigb / alfa;
            cel = sigc / alfa;
            bel = (-v[i] - zl) * ael + xl;
            del = (-v[i] - zl) * cel + yl;

            aRayo[l][k][i+1][j] = ael;
            bRayo[l][k][i+1][j] = bel;
            cRayo[l][k][i+1][j] = cel;
            dRayo[l][k][i+1][j] = del;
        }

        return 1;
    }

}

                                                                                                                                                                
