/**************************************************************************\
*                                                                          *
*                Panel para dibujar los puntos cardinales                  *
*                           --------------------                           *
*                                                                          *
*       Se deforma el dibujo para que se vean mejor las lentes:            *
*       Se dibujan las dimensiones horizontales a escala 1/2.              *
*       Las verticales a escala 4/1.                                       *
*       El radio de curvatura a escala 12/1.                               *
*                                                                          *
\**************************************************************************/


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;


//=============================================================================


public class PuntosCardinalesFL extends JPanel implements ActionListener
{
    Font fuente2 = new Font ("Courier", Font.BOLD, 12);
    Color   colorTexto2 = Color.black;
    DibujoSistemaFL  dibujoSistema;
    JButton buttonFinPC;
    DibujoPCFL    dibujoPC;


    //--------------------   Constructor    -----------------------------------

    public PuntosCardinalesFL (DibujoSistemaFL canvasSistema)
    {

        dibujoSistema = canvasSistema;

        setLayout (null);                 
        setBounds (0, 210, 800, 250);

        buttonFinPC = new JButton (SistemaFL.text[1][SistemaFL.lang]);
        buttonFinPC.setBounds (2, 180, 140, 30);
        buttonFinPC.setForeground (colorTexto2);
        buttonFinPC.setFont (fuente2);
        buttonFinPC.addActionListener (this);  
        buttonFinPC.setActionCommand ("buttonFinPC");

        add (buttonFinPC);

        dibujoPC = new DibujoPCFL (dibujoSistema);

        add (dibujoPC);
    }

    //========  Define los mtodos de ActionListener  =========================


    public void actionPerformed (ActionEvent e) 
    {
        int     i, j;


            //  Obtiene la etiqueta del botn pulsado

        String s = e.getActionCommand ();


        //-------------     Opciones del anteproyecto   -----------------------

        //  Ante cualquier accin de cambio de panel, borra el panel 
        //  inferior derecho, que es el que haba puesto la opcin anterior.

        if (s == "buttonFinPC")
        {
            SistemaFL.panelBase.remove (this);
            SistemaFL.panelBase.add (AnteproyectoFL.anteproyecto.panelBase);
//            cuadro = 1;
            SistemaFL.panelBase.repaint ();
        }
    }
}



//=============================================================================


class DibujoPCFL  extends Canvas
{
    int     eje = 105;
    DibujoSistemaFL  dibujoSistema;



    public DibujoPCFL (DibujoSistemaFL canvasSistema)
    {
        dibujoSistema = canvasSistema;
        setBounds (30, 0, 770, 180);
    }



    //--------------------  Funcin para dibujar    ---------------------------

    public void paint (Graphics graphics)
    {

        int     i, j, k, n, ia, ip, i1, i2, z, y, w, z1, z2, h, y1, y2, obj;
        double  radioDib, zv, altura;
        Color cyan = new Color (0, 255, 255);
        float[] trama = { 4.f, 4.f }; 
        BasicStroke  trazos, continuo;

           
        trazos = new BasicStroke (1, BasicStroke.CAP_ROUND,
                    BasicStroke.JOIN_MITER, 1.f, trama, 0.f);

        continuo = new BasicStroke (1);


                        //  Utiliza las funciones de Graphics2D
     
        Graphics2D gr = (Graphics2D) graphics;


                        //  Traza una lnea de separacin

        gr.setColor (Color.white);
        gr.drawLine (0, 0, 800, 0);

                        //  Dibuja las lentes y diafragmas

        dibujoSistema.dibujaElementos (gr);


                        //  Hace los clculos para las dos marchas
                        //  obj = 0 para marcha de izquierda a derecha
                        //  obj = 1 para marcha de derecha a izquierda 


        FuncionesCardinalesFL.tablaTramosCard ();

        for (obj = 0; obj < 2; obj ++)
            FuncionesCardinalesFL.marchaParaxialCard (obj);

        FuncionesCardinalesFL.normalizaCoeficientes ();

        for (obj = 0; obj < 2; obj ++)
            FuncionesCardinalesFL.interseccionesRayosCard (obj);


        n = AnteproyectoFL.numTramosCard;
        if (n < 2)
            return;

                //  Dibuja el eje del sistema

        gr.setColor (Color.yellow);
        gr.drawLine (0, eje, 800, eje);


                //  Dibuja los rayos

                    //  Dibuja toda la recta (rayos y prolongaciones) 
                    //  en los tramos extremos con trazos.
                    //  Luego dibujar el recorrido real con lnea continua.
           
        gr.setStroke (trazos);           //  Pone lnea de trazos


        for (obj = 0; obj < 2; obj ++)
        {
            if (obj == 0)
                gr.setColor (Color.green);
            else
                gr.setColor (Color.cyan);

           
                                //  Tramo inicial
           
            z1 = 0;
            y1 = eje - (int) (AnteproyectoFL.bpRayoCard[obj][0] * 2.);
            z2 = 800;
            if (AnteproyectoFL.apRayoCard[obj][0] == 0)
                y2 = y1;
            else
                y2 = eje - (int) ((AnteproyectoFL.apRayoCard[obj][0] * 1600 +
                                 AnteproyectoFL.bpRayoCard[obj][0]) * 2.);
           
            gr.drawLine (z1, y1, z2, y2);
           
                                //  Tramo final
           
            i = AnteproyectoFL.tramoCard[n-1];   //  Extremo izquierdo del tramo
            ip = AnteproyectoFL.tramoCard[n];    //  Extremo derecho del tramo
           
            z1 = 0;
            y1 = eje - (int) (AnteproyectoFL.bpRayoCard[obj][i] * 2.);
            z2 = 800;
            y2 = eje - (int) (AnteproyectoFL.yaRayoCard[obj][ip] * 2.);
           
            gr.drawLine (z1, y1, z2, y2);
        }   
            

                    //  Cada tramo va del elemento k al k+1

        gr.setStroke (continuo);        //  Pone trazo continuo

        for (obj = 0; obj < 2; obj ++)
        {
            if (obj == 0)
                gr.setColor (Color.green);
            else
                gr.setColor (Color.cyan);
           
            for (k = 0; k < n; k ++)
            {
                i = AnteproyectoFL.tramoCard[k];    //  Extremo izquierdo del tramo
                ip = AnteproyectoFL.tramoCard[k+1]; //  Extremo derecho del tramo
            
                if (i == 0)
                {
                            //  Tramo del objeto al elemento 1
            
                    z1 = 0;
                    y1 = eje - (int) (AnteproyectoFL.bpRayoCard[obj][0] * 2.);
            
                }
            
                            //  Restantes tramos
            
                else
                {
                    z1 = (int) (AnteproyectoFL.zpRayoCard[obj][i] / 2.);
                    y1 = eje - (int) (AnteproyectoFL.ypRayoCard[obj][i] * 2.);
                }
            
            
                        //  Interseccin con la superficie de entrada siguiente
            
                z2 = (int) (AnteproyectoFL.zaRayoCard[obj][ip] / 2.);
                y2 = eje - (int) (AnteproyectoFL.yaRayoCard[obj][ip] * 2.);
            
                gr.drawLine (z1, y1, z2, y2);
           
            }
        }

                //  Dibuja los planos focales

        gr.setColor (Color.red);
                                                //  Objeto
        z1 = (int) (AnteproyectoFL.zF[1] / 2.);
        gr.drawLine (z1, eje-90, z1, eje+90);
        gr.drawString ("F", z1+5, eje+20);
                                                //  Imagen 
        z1 = (int) (AnteproyectoFL.zF[0] / 2.);   
        gr.drawLine (z1, eje-90, z1, eje+90);
        gr.drawString ("F'", z1+5, eje+20);

                //  Dibuja los planos principales

        gr.setColor (Color.magenta);
                                                //  Objeto
        z1 = (int) (AnteproyectoFL.zH[1] / 2.);
        gr.drawLine (z1, eje-90, z1, eje+90);
        gr.drawString ("H", z1+5, eje+20);
                                                //  Imagen 
        z1 = (int) (AnteproyectoFL.zH[0] / 2.);   
        gr.drawLine (z1, eje-90, z1, eje+90);
        gr.drawString ("H'", z1+5, eje+20);
    }

    public void redraw ()
    {
        repaint ();
    }
}
