/******************************************************************************\
*                                                                              *
*                             JSistema                                         *
*                                                                              *
*       Programa con fichas para calcular sistemas de focal larga y corta      *
*                                                                              *
*                                                                              *
\******************************************************************************/



import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;



//**************          Clase principal del programa      ********************


public class Sistema extends JApplet 
{
    static PanelCompleto    panelCompleto;
    static PanelLeyenda     panelLeyenda;       //  Para el ttulo del programa
    static PanelSistema     panelSistema;       //  Para el programa
    static int              lang = 0;
    static int              ancho = 800;        //  Anchura del panel de dibujo
    static int              altoLeyenda = 32;   //  Altura del panel del ttulo
    static int              altoDibujo = 500;   //  Altura del panel de dibujo
    static int              altoTotal;
    static String           teoria[] = { "DocA_RayCa.html", "DocA_RayEs.html", "DocA_RayEn.html" };             



    //************    Bloque con todos los textos de este fichero    ***********

    static String text[][] =
    {
//        { "SISTEMES OPTICS", "SISTEMAS OPTICOS", "OPTICAL SISTEMS" },
        { "TRAAT DE RAIGS", "TRAZADO DE RAYOS", "RAY TRACING" },
        { "Sistemes de focal llarga", "Sistemas de focal larga", "Long focal systems" },
        { "Telescopis, microscopis, proyectors ...",
            "Telescopios, microscopios, proyectores ...",
            "Telescopes, microscopes, projection systems ..." },
        { "Sistemes de focal curta", "Sistemas de focal corta", "Short focal systems" },
        { "Cmara fotogrfica, ull ...", "Cmara fotogrfica, ojo ...", 
            "Photographic camera, eye ..." },
        { "En quant a", "Acerca de", "About"},
    };


    static String[][] acerca_etiqueta = 
    {  
        { "Acceptar", "Aceptar", "OK"},
        { "Applet de Traat de raigs versi 1.0 \n\n"+ 
          "Grup d'Innovaci Docent en ptica Fsica i Fotnica \n"+
          "Universitat de Barcelona, 2003 \n"+ 
          "La utilitzaci d'aquest programa est sota una llicncia de Creative Commons \n"+
          "Veure condicions a http://www.publicacions.ub.es/doi/licencia/resum-deriv.htm\n\n"+
          "Curs d'ptica en Java DOI: 10.1344/401.000000050 \n"+
          "Applet de Traat de raigs DOI: 10.1344/203.000000097",

          "Applet de Trazado de rayos versin 1.0 \n\n"+
          "Grup d'Innovaci Docent en ptica Fsica i Fotnica \n"+
          "Universitat de Barcelona, 2003 \n"+
          "La utilizacin de este programa est bajo una licencia de Creative Commons \n"+
          "Ver condiciones en http://creativecommons.org/license/by-nc-sa/2.0/ \n \n"+
          "Curso de ptica en Java DOI: 10.1344/401.000000050 \n"+
          "Applet de Trazado de rayos DOI: 10.1344/203.000000097",

          "Ray tracing Applet version 1.0 \n\n"+
          "Grup d'Innovaci Docent en ptica Fsica i Fotnica \n"+
          "Universitat de Barcelona, 2003 \n"+
          "The use of this program is under a Creative Commons license \n"+ 
          "See conditions in http://creativecommons.org/license/by-nc-sa/2.0/ \n \n"+
          "Java Optics Course DOI: 10.1344/401.000000050 \n "+
          "Ray tracing Applet DOI: 10.1344/203.000000097"
        }
    };
  

    //***********         Empieza el programa principal        *****************


    public static void main (String args[]) 
    {
            //  Lee el parmetro que indica el idioma
            //  Lo convierte a maysculas y le quita aditamentos

        try
        {
            String dato = args[0].toUpperCase().intern();

    
            if (dato == "CA")
            {
                lang = 0;
            }
            else if (dato == "ES")
            {
                lang = 1;
            }
            else if (dato == "EN")
            {
                lang = 2;
            }
            else
                lang = 0;

        }

        catch (Exception e2)
        {
            lang = 0;
        }

            //  Crea el marco para el contenido. 

        Marco   marco = new Marco ("");

            //  Construye el "Applet". (Constructor por omisin). 

        Sistema cuadro = new Sistema ();

            //  Inicia el programa

        cuadro.initb ();
        cuadro.start ();

            //  Aade el cuadro al marco y lo muestra

        marco.getContentPane().add (cuadro);
        marco.setSize (ancho, altoTotal);
        marco.show ();
    }


    //****************   Funcin de inicio del "applet"      ******************

    public void init ()
    {
                        //  Lee el parmetro que indica el idioma
        try 
        {
           lang=Integer.valueOf (getParameter("llengua")).intValue();
        }
        catch (Exception e)
        {
            lang = 0;
        }

        initb ();
    }


    //****************   Funcin de inicio del programa      ******************

    public void initb ()
    {

                    //      Crea el panel completo y lo aade al applet

        altoTotal = altoLeyenda + altoDibujo;
//        setSize (ancho, altoTotal);
        getContentPane ().setLayout (new BorderLayout ());
        panelCompleto = new PanelCompleto ();
        getContentPane ().add ("Center", panelCompleto);
    }


    //*******************    Funciones auxiliares no necersarias     ***********

    public void start ()
    {
        panelCompleto.setEnabled (true);
    }

    public void stop ()
    {
        panelCompleto.setEnabled (false);
    }

    public void destroy ()
    {
        remove (panelCompleto); 
    }
    
}

//==============================================================================

//***************    Definiciones de clases      *******************************

//==============================================================================


class  Marco extends JFrame implements WindowListener 
{
    public Marco (String nombre)
    {
        super (nombre);
        setResizable (false);
        setDefaultCloseOperation (EXIT_ON_CLOSE);

        addWindowListener (this);
    }

    //  Define los mtodos de WindowListener. 
    //  Debe definirlos todos, aunque deje vacos los que no interesen.

            //  Para que se cierre la ventana
    public void windowClosing (WindowEvent e) { System.exit (0); }

            //  Los dems quedan vacos
    public void windowActivated (WindowEvent e) {;}
    public void windowClosed (WindowEvent e) {;}
    public void windowDeactivated (WindowEvent e) {;}
    public void windowDeiconified (WindowEvent e) {;}
    public void windowIconified (WindowEvent e) {;}
    public void windowOpened (WindowEvent e) {;}

}


//*******************      Panel del ttulo         ****************************


class PanelLeyenda extends JPanel implements ActionListener
{
    public PanelLeyenda ()
    {
        setSize (Sistema.ancho, Sistema.altoLeyenda);
        setLayout (null);

                        //  Crea una fuente
    
        Font fuente1 = new Font ("Helvetica", Font.BOLD, 24);
    
            //  Declara y construye un objeto con una leyenda para ttulo
    
        JLabel tituloBase;
        tituloBase = new JLabel (Sistema.text[0][Sistema.lang]);
        tituloBase.setBounds (250, 0, 400, 40);
        tituloBase.setBackground (Color.white);
        tituloBase.setForeground (Color.black);
        tituloBase.setFont (fuente1);
        //add (tituloBase);


                //  Crea el botn "Acerca de"

        Font fuente2 = new Font ("Dialog", Font.BOLD, 12);
        JButton buttonAcerca = new JButton (Sistema.text[5][Sistema.lang]);
        buttonAcerca.setBounds (680, 10, 95, 22);
        buttonAcerca.setForeground (Color.black);
        buttonAcerca.setFont (fuente2);
        buttonAcerca.addActionListener (this);  
        buttonAcerca.setActionCommand ("buttonAcerca");
        add (buttonAcerca);
    }

    //========  Define los mtodos de ActionListener  =========================

    public void actionPerformed (ActionEvent e) 
    {
        int i, n;
        double dato[] = new double[8];



            //  Obtiene la etiqueta del botn pulsado

        String s = e.getActionCommand ();

        //--------------         Llama al texto "Acerca de"       -----------

        if (s == "buttonAcerca") 
        {
            JFrame acerca = new JFrame ();
            Object[] options = { Sistema.acerca_etiqueta[0][Sistema.lang] }; 
            ImageIcon icono = null;
            JOptionPane option = new JOptionPane (
                Sistema.acerca_etiqueta[1][Sistema.lang],
                JOptionPane.INFORMATION_MESSAGE,
                JOptionPane.DEFAULT_OPTION, icono, options);

            JDialog dialog = option.createDialog 
                (acerca, Sistema.text[5][Sistema.lang]);
            dialog.setResizable (false);
            dialog.show ();
        }
    }
}


//****************      Panel de las fichas         ***************************
//      Consta de un panel base y los sub-paneles de cada ficha.


class PanelSistema extends JPanel 
{
    SistemaFL       sistemaFL;
    SistemaFC       sistemaFC;

    public PanelSistema ()
    {
        setLayout (null);
//        setSize (800, 500);

                        //  Crea varias fuentes
    
        Font fuente1 = new Font ("Helvetica", Font.BOLD, 24);
        Font fuente2 = new Font ("Helvetica", Font.BOLD, 14);
    

                //  Crea el panel base de las fichas

        JTabbedPane panelFichas = new JTabbedPane ();


                //  Crea las fichas (paneles) y los aade al panel base

        sistemaFL = new SistemaFL ();
        sistemaFC = new SistemaFC ();

        panelFichas.addTab (Sistema.text[3][Sistema.lang], null, sistemaFC,
            Sistema.text[4][Sistema.lang]);
        panelFichas.addTab (Sistema.text[1][Sistema.lang], null, sistemaFL,
             Sistema.text[2][Sistema.lang]);

        panelFichas.setSize (Sistema.ancho, Sistema.altoDibujo);


                //  Aade el panel base de las fichas al "PanelSistema"

        add (panelFichas);

        panelFichas.setSelectedIndex (1);
    }

}



class PanelCompleto extends JPanel
{
    public PanelCompleto ()
    {
        setLayout (null);

        Sistema.panelLeyenda = new PanelLeyenda ();
        Sistema.panelLeyenda.setBounds (0, 0, Sistema.ancho, Sistema.altoLeyenda);
        add (Sistema.panelLeyenda);
//        Sistema.panelLeyenda.repaint ();

        Sistema.panelSistema = new PanelSistema ();
        add (Sistema.panelSistema);
        Sistema.panelSistema.setBounds (0, Sistema.altoLeyenda, 
                     Sistema.ancho, Sistema.altoDibujo);
//        Sistema.panelSistema.repaint ();


    }
}

