/**************************************************************************\
*                                                                          *
*                       Clculo y dibujo de sistemas pticos               *
*                                                                          *
\**************************************************************************/



import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;


//==================        Clase principal     ===============================


public class SistemaFL extends JPanel
{
    static SistemaFL    sistema;
    static PanelBaseFL  panelBase;
    AnteproyectoFL      anteproyecto;
    ExactoFL            exacto;
    static int          lang = 0;
    static String       strTeoria = null;

    static  DibujoEscalaHFL       canvasEscalaH;
    static  DibujoEscalaVFL       canvasEscalaV;

    static int ancho;
    static int alto;        

    static int ultimoHecho = 0;     //  0 si no se ha calculado nada
                                    //  1 si se ha calculado "AnteproyectoFL"
                                    //  2 si se ha calculado "ExactoFL"

                        //  Datos generales del objeto

    static  int     existeObjeto[] = {0, 0};
    static  int     real[] = {1, 1};
    static  double  valZObj[] = {-1600, -1600};   // Posicin dada por la corredera
    static  double  zObjeto[] = {-1600, -1600};   //    "   utilizada para clculo
    static  double  valYObj[] = {0., 0.};
    static  double  campo[] = {0., 0.};
    static  double  campoDib[] = {0., 0.};


                //  Datos de los elementos (lentes o diafragmas)

                    //  El subndice 0 corresponde al objeto
                    //  El subndice 7 corresponde al borde derecho del cuadro


    static int tipoE[] = new int[8];          //  1 si es lente, 0 si es diafragma
    static int existe[] = new int[8];         //  1 si existe, 0 si no existe
    static double valZE[] = new double[8];    //  Posicin
    static double valPE[] = new double[8];    //  Potencia 
    static double valFE[] = new double[8];    //  Focal
    static double valDibPE[] = new double[8]; //  Potencia adaptada al dibujo
    static double valDE[] = new double[8];    //  Dimetro del diafragma
    static double curv[] = new double[8];     //  Curvatura
    static double radio[] = new double[8];    //  Radio de curvatura
    static double radioDib[] = new double[8]; //  Radio de curvatura para dibujo
    static double espesor[] = new double[8];  //  Espesor de la lente en eje
    static double altura[] = new double[8];   //  Radio de la abertura
    static double dist[] = new double[8];     //  Distancia entre los elementos 
                                              //  "i" e "i+1".
                                              //  Se toma igual a la mitad de la
                                              //  suma de ambos espesores.
                                              //  En las lentes el espesor es
                                              //  el doble de la potencia de dibujo.


    //==========    Bloque con todos los textos de este fichero     ===========

    static String text[][] =
    {
//        { "SISTEMES OPTICS", "SISTEMAS OPTICOS", "OPTICAL SISTEMS" },
        { "TRAAT DE RAIGS", "TRAZADO DE RAYOS", "RAY TRACING" },
        { "Avantprojecte", "Anteproyecto", "Preliminary sketch" },
        { "Clcul exacte", "Clculo exacto", "Exact calculation" },
        { "Llegir un fitxer", "Leer un fichero", "Read file" },
        { "Enregistrar", "Grabar un fichero", "Save to file" },
        { "Resum de teoria", "Resumen de teora", "Theory summary" },
        { "Sortida", "Salida", "Exit" },
        { "TEORIA", "TEORIA", "THEORY" },
    };


    //=================         Se inica la aplicacin        ===================


    public SistemaFL ()
    {
        lang = Sistema.lang;
        ancho = Sistema.ancho;
        alto = Sistema.altoDibujo;
        strTeoria = Sistema.teoria[lang];

                        //  Crea el contenido de la ventana: "panelBase"

        setSize (ancho, alto);
        setLayout (null);

                        //  Crea el panel base para el "applet"

        panelBase = new PanelBaseFL ();
        add (panelBase);
  
         
                        //  Crea las otras clases que luego necesitar

        anteproyecto = new AnteproyectoFL ();
        exacto = new ExactoFL ();

                        //  Panel para la escala vertical 

        canvasEscalaV = new DibujoEscalaVFL ();
        canvasEscalaV.setBackground (Color.black);
        canvasEscalaV.setBounds (0, 0, 30, 210);
        add (canvasEscalaV);
        canvasEscalaV.repaint ();

                        //  Panel para la escala horizontal 

        canvasEscalaH = new DibujoEscalaHFL ();
        canvasEscalaH.setBackground (Color.black);
        canvasEscalaH.setBounds (0, 210, 800, 20);
        add (canvasEscalaH);
        canvasEscalaH.repaint ();

        repaint ();

    }

}


//==================        Clase marco         ===============================


class MarcoFL extends JFrame 
{
    public  MarcoFL (String nombre)
    {
        super (nombre);
        setResizable (false);
        setDefaultCloseOperation (EXIT_ON_CLOSE);
    }
}


//===================   Clase PanelBaseFL     ===================================

class PanelBaseFL extends JPanel implements ActionListener
{

    static  JPanel   panelMP;


    //-----------------  Crea varias fuentes    -------------------------------

    Font fuente1 = new Font ("Dialog", Font.BOLD, 24);
    Font fuente2 = new Font ("Dialog", Font.BOLD, 12);

    Color   colorTexto1 = Color.white;
    Color   colorTexto2 = Color.black;



    //=====================  Constructor  =====================================


    public PanelBaseFL ()
    {

        setLayout (null);
        setSize (SistemaFL.ancho, SistemaFL.alto);
            


        //==============  Panel para el men principal  ======================

        panelMP = new JPanel ();
        panelMP.setLayout (null);                 
        panelMP.setBackground (Color.gray);
        panelMP.setBounds (0, 220, 800, 230);

                    //  Ttulo

        JLabel labelAntep = new JLabel (SistemaFL.text[0][SistemaFL.lang]);
        labelAntep.setBounds (50, 10, 200, 30);
        labelAntep.setForeground (colorTexto1);
        labelAntep.setFont (fuente2);
        panelMP.add (labelAntep);

                    //  Prepara los botones del men principal

                        //  Para el anteproyecto

        JButton buttonAntep = new JButton (SistemaFL.text[1][SistemaFL.lang]);
        buttonAntep.setBounds (10, 40, 200, 30);
        buttonAntep.setForeground (colorTexto2);
        buttonAntep.setFont (fuente2);

                                //  Para que responda a una pulsacin
        buttonAntep.addActionListener (this);  

                                //  El texto que devuelve cuando responde
        buttonAntep.setActionCommand ("buttonAntep");
        panelMP.add (buttonAntep);


                        //  Para el clculo excato

        JButton buttonExactoFL = new JButton (SistemaFL.text[2][SistemaFL.lang]);
        buttonExactoFL.setBounds (10, 70, 200, 30);
        buttonExactoFL.setForeground (colorTexto2);
        buttonExactoFL.setFont (fuente2);
        buttonExactoFL.addActionListener (this);  
        buttonExactoFL.setActionCommand ("buttonExactoFL");
        panelMP.add (buttonExactoFL);


                        //  Para leer un fichero

        JButton buttonLeer = new JButton (SistemaFL.text[3][SistemaFL.lang]);
        buttonLeer.setBounds (10, 100, 200, 30);
        buttonLeer.setForeground (colorTexto2);
        buttonLeer.setFont (fuente2);
        buttonLeer.addActionListener (this);  
        buttonLeer.setActionCommand ("buttonLeer");
        panelMP.add (buttonLeer);


                        //  Para grabar un fichero

        JButton buttonGrabar = new JButton (SistemaFL.text[4][SistemaFL.lang]);
        buttonGrabar.setBounds (10, 130, 200, 30);
        buttonGrabar.setForeground (colorTexto2);
        buttonGrabar.setFont (fuente2);
        buttonGrabar.addActionListener (this);  
        buttonGrabar.setActionCommand ("buttonGrabar");
        panelMP.add (buttonGrabar);


                        //  Para la pgina de teora

        JButton buttonTeoria = new JButton (SistemaFL.text[5][SistemaFL.lang]);
        buttonTeoria.setBounds (10, 160, 200, 30);
        buttonTeoria.setForeground (colorTexto2);
        buttonTeoria.setFont (fuente2);
        buttonTeoria.addActionListener (this);  
        buttonTeoria.setActionCommand ("buttonTeoria");
        panelMP.add (buttonTeoria);


                        //  Para el botn "Salida"

        JButton salida = new JButton (SistemaFL.text[6][SistemaFL.lang]);
        salida.setBounds (10, 190, 200, 30);
        salida.setForeground (colorTexto2);
        salida.setFont (fuente2);
        salida.addActionListener (this);  
        salida.setActionCommand ("buttonSalida");
        panelMP.add (salida);


        //=====================================================================


        //------------   Se aade el panel del men a la ventana  --------------

        add (panelMP);
    }


    //========  Define los mtodos de ActionListener  =========================

    public void actionPerformed (ActionEvent e) 
    {
        int i, n;
        double dato[] = new double[8];



            //  Obtiene la etiqueta del botn pulsado

        String s = e.getActionCommand ();


        //----------------      Llama a AnteproyectFL        -------------------

        if (s == "buttonAntep")  
        {
            remove (panelMP);
            AnteproyectoFL.abrir ();
            repaint ();
        }


        //--------------        Llama a Clculo ExactoFL      -------------------

        if (s == "buttonExactoFL") 
        {
            remove (panelMP);
            ExactoFL.abrir ();
            repaint ();
        }

        //--------------         Llama a Leer Fichero       -------------------

        if (s == "buttonLeer") 
        {
                            //      Crea un selector de ficheros

            FileDialog selector = new FileDialog (new Frame(), "Selector");
            selector.setForeground (Color.black);
            selector.setFont (fuente2);
            selector.show ();
        
            String fichero = selector.getFile ();
            String dir = selector.getDirectory ();
            String dirFichero = dir + fichero;

            if ((dir == null) || (fichero == null))
            {
                            //  No se ha elegido ningn fichero
            
                return;
            }


            try
            {
                FileReader file = new FileReader (dirFichero);  
                BufferedReader lector = new BufferedReader (file);

                                //  Lee los datos del objeto 1

                n = leeLineaAscii (lector, dato, 4);
                if (n < 0)       //  Error de lectura
                {
                    lector.close ();
                    return;
                }

                                //  Convierte los datos;

                SistemaFL.existeObjeto[0] = (int) dato[0]; 
                SistemaFL.real[0]         = (int) dato[1]; 
                SistemaFL.valZObj[0]      = dato[2]; 
                SistemaFL.campo[0]        = dato[3]; 

                                //  Lee los datos del objeto 2

                n = leeLineaAscii (lector, dato, 4);
                if (n < 0)       //  Error de lectura
                {
                    lector.close ();
                    return;
                }

                                //  Convierte los datos;

                SistemaFL.existeObjeto[1] = (int) dato[0]; 
                SistemaFL.real[1]         = (int) dato[1]; 
                SistemaFL.valZObj[1]      = dato[2]; 
                SistemaFL.campo[1]        = dato[3]; 

                                //  Inicia los datos de las lentes

                for (i = 1; i < 7; i ++)
                {
                    SistemaFL.existe[i] = 0;
                    SistemaFL.tipoE[i]  = 1;
                    SistemaFL.valPE[i]  = 0;
                    SistemaFL.valDE[i]  = 70;
                    AnteproyectoFL.datosCorrederaHLente (i);
                }   

                                //  Lee los datos de las lentes

                for (i = 1; i < 7; i ++)
                {
                    n = leeLineaAscii (lector, dato, 8);
          
                    if (n == - 1)       //  Final del fichero
                    {
                        lector.close ();
                        break;
                    }
          
                    if (n == - 2)       //  Error de lectura
                    {
                        lector.close ();
                        return;
                    }

                            //  Convierte los datos;

                    SistemaFL.existe[i] = (int) dato[0];
                    SistemaFL.tipoE[i]  = (int) dato[1];
                    SistemaFL.valZE[i]  = dato[2];
                    SistemaFL.valPE[i]  = dato[3];
                    SistemaFL.valDE[i]  = dato[4];
                    ExactoFL.valBE[i]  = dato[5];
                    ExactoFL.indice[i] = dato[6]; 
                    ExactoFL.abbe[i]   = dato[7]; 

                }   
            }

            catch (IOException ioe)
            {
                            //  Error de lectura 
            
                return;
            }     

                            //  Llama a "AnteproyectoFL"

            remove (panelMP);
            AnteproyectoFL.abrir ();

            repaint ();
        }


        //--------------         Llama a Grabar Fichero       -------------------

        if (s == "buttonGrabar") 
        {

            if (SistemaFL.existeObjeto[0] == 0)
                return;


                            //    Crea un selector de ficheros

            FileDialog selector = new FileDialog (new Frame(), "Selector");
            selector.setForeground (Color.black);
            selector.setFont (fuente2);
            selector.show ();
        
            String fichero = selector.getFile ();
            String dir = selector.getDirectory ();
            String dirFichero = dir + fichero;

            if ((dir == null) || (fichero == null))
            {
                            //  No se ha elegido ningn fichero
            
                return;
            }

                                //  Empieza la grabacin

            try
            {
                FileWriter file = new FileWriter (dirFichero);  
                BufferedWriter grabar = new BufferedWriter (file);


                                    //  Graba el objeto 1

                String objeto = SistemaFL.existeObjeto[0]+"  "+ 
                                SistemaFL.real[0]+"  "+    
                                SistemaFL.valZObj[0]+"  "+
                                SistemaFL.campo[0];  

                grabar.write (objeto);
                grabar.newLine ();

                                    //  Graba el objeto 2 (del AnteproyectoFL)

                objeto = SistemaFL.existeObjeto[1]+"  "+ 
                         SistemaFL.real[1]+"  "+    
                         SistemaFL.valZObj[1]+"  "+
                         SistemaFL.campo[1];  

                grabar.write (objeto);
                grabar.newLine ();


                for (i = 1; i < 7; i ++)
                {
                    String lista = SistemaFL.existe[i]+"  "+ 
                                   SistemaFL.tipoE[i]+"  "+
                                   SistemaFL.valZE[i]+"  "+ 
                                   SistemaFL.valPE[i]+"  "+ 
                                   SistemaFL.valDE[i]+"  "+
                                   ExactoFL.valBE[i]+"  "+
                                   ExactoFL.indice[i]+"  "+
                                   ExactoFL.abbe[i];


                    grabar.write (lista);
                    grabar.newLine ();
                }
                grabar.close ();
            }

            catch (IOException ioe)
            {
                            //  Error de grabacin
                return;
            }     

        }

        //--------------         Llama a Leer Texto de Teora       -----------

        if (s == "buttonTeoria") 
        {
                            //      Crea un cuadro para texto

            JFrame teoria = new JFrame (SistemaFL.text[7][SistemaFL.lang]);
            teoria.setForeground (Color.black);
            teoria.setFont (fuente2);
            teoria.setSize (700, 500);
        
            JTextPane texto = new JTextPane ();
            teoria.getContentPane().add (texto);
            texto.setBackground (new Color (204, 204, 204));

            JScrollPane scroll = new JScrollPane (texto);
            scroll.setBackground (new Color (204, 204, 204));
            teoria.getContentPane().add (scroll);

            teoria.show ();

            java.net.URL    info_page = null;

            try
            {
                info_page = getClass ().getResource (SistemaFL.strTeoria);
            }
            catch (Exception eee)
            {
                System.err.println ("Error al cargar el texto");
            }

            try
            {
                texto.setPage (info_page);
            }
            catch (IOException  ee)
            {
                System.err.println ("Error al leer una URL mala");
            }
        }

        //--------------         Salida                      -----------

        if (s == "buttonSalida") 
        {
            System.exit (0);
        }
    }



    /**********************************************************************\
    *                        LeeLineaAscii                                 *
    *              Lee una lnea de datos de un fichero ASCII              *
    *               Devuelve el n de datos ledos                         *
    *               Al final del fichero devuelve - 1                      *
    \**********************************************************************/


    static int leeLineaAscii (BufferedReader lector, double dato[], int nMax)
    {

        int    i, nchar = 0;
        int    numDatos = 0;
        char   cadenaBase[] = new char[100];
        char   cadena[] = new char[100];
        String lineaInicial; 
        String lineaBase;  //  Para toda la lnea pero sin ceros extremos
        String trozo;      //  Para cada trozo

        try
        {
                    //  Lee una lnea del fichero
        
            lineaInicial = lector.readLine ();
            if (lineaInicial == null)     //   Final del fichero
            {
                return - 1;
            }


            while (true)
            {

                        //  Le quita los ceros iniciales
            
                lineaBase = lineaInicial.trim ();
          
                        //  La convierte en cadena de caracteres
            
                cadenaBase = lineaBase.toCharArray ();
            
                if (cadenaBase.length < 1)
                    break;
    
                        //  Copia la primera parte de la cadena
                        //  (El primer nmero ASCII)
            
                for (i = 0; i < cadenaBase.length; i ++)
                {
                    if (Character.isWhitespace (cadenaBase[i])) 
                        break;
                    cadena[i] = cadenaBase[i];
                }
                nchar = i;
            
                        //  La convierte en "String"
            
                trozo = new String (cadena, 0, nchar);
            
                        //  Extrae el n entero que representa
            
                dato[numDatos] = Double.parseDouble (trozo);
                numDatos ++;
                if (numDatos > nMax)
                    break;
    
                        //  Crea una nueva "String" con la 2 parte
                        //  de la cadena
            
                if (cadenaBase.length <= nchar)
                    break;
                lineaInicial = new String 
                          (cadenaBase, nchar, cadenaBase.length-nchar);

            }

        }
        catch (EOFException  eof)
        {
                //  Error de lectura 
        
            return - 2;
        }
        catch (IOException ioe)
        {
            return - 2;
        }     

        return numDatos;
    }    

}
                                                                                                                                                                
